<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76981 "21:23:01"))'</do-it>



<class>
<name>ChemoJunAbstractObject</name>
<environment>ChemoJun</environment>
<super>Jun.JunAbstractObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>fileName </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Abstract-Objects</category>
<attributes>
<package>ChemoJun-Abstract-Objects</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunAbstractObject class</class-id> <category>instance creation</category>

<body package="ChemoJun-Abstract-Objects" selector="new">new
	^(super new) initialize; yourself</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractObject class</class-id> <category>converting</category>

<body package="ChemoJun-Abstract-Objects" selector="baseNameFromFilename:">baseNameFromFilename: aFilename 
	"ChemoJunAbstractObject baseNameFromFilename: (JunFileDialog request)."
	"ChemoJunAbstractObject baseNameFromFilename: (nil)."

	| aString |
	aFilename isNil ifTrue: [^JunSystem defaultBaseName].
	aString := (Filename splitPath: aFilename asString) last.
	aString isNil ifTrue: [^JunSystem defaultBaseName].
	aString := (Filename splitExtension: aString) first.
	^aString</body>

<body package="ChemoJun-Abstract-Objects" selector="extensionFromFilename:">extensionFromFilename: aFilename 
	"ChemoJunAbstractObject extensionFromFilename: (JunFileDialog request)."

	| aString |
	aFilename isNil ifTrue: [^String new].
	aString := (Filename splitPath: aFilename asString) last.
	aString isNil ifTrue: [^String new].
	^aString copyFrom: (self baseNameFromFilename: aFilename) size + 1
		to: aString size</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractObject class</class-id> <category>copyright</category>

<body package="ChemoJun-Abstract-Objects" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Abstract-Objects" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Abstract-Objects" selector="version">version
	^'071'
</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunAbstractObject</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunAbstractObject</class-id> <category>initialize-release</category>

<body package="ChemoJun-Abstract-Objects" selector="initialize">initialize
	fileName := nil</body>

<body package="ChemoJun-Abstract-Objects" selector="release">release
	super release</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractObject</class-id> <category>accessing</category>

<body package="ChemoJun-Abstract-Objects" selector="baseName">baseName
	^self class baseNameFromFilename: self fileName</body>

<body package="ChemoJun-Abstract-Objects" selector="extension">extension
	^self class extensionFromFilename: self fileName</body>

<body package="ChemoJun-Abstract-Objects" selector="fileName">fileName
	^fileName</body>

<body package="ChemoJun-Abstract-Objects" selector="fileName:">fileName: aFilename 
	aFilename ifNil: [fileName := nil]
		ifNotNil: [fileName := aFilename asFilename]</body>

<body package="ChemoJun-Abstract-Objects" selector="informationString">informationString
	| aString |
	self 
		assert: [String new writeStream]
		do: 
			[:aStream | 
			self fileName notNil 
				ifTrue: 
					[aStream tab.
					aStream nextPutAll: (#jun_file__ &gt;&gt; 'file: ') asString.
					aStream nextPutAll: (Filename splitPath: self fileName asString) last.
					aStream cr].
			aString := aStream contents]
		ensure: [:aStream | aStream close].
	^aString</body>

<body package="ChemoJun-Abstract-Objects" selector="pathName">pathName
	^(Filename splitPath: self fileName asString) first</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractObject</class-id> <category>converting</category>

<body package="ChemoJun-Abstract-Objects" selector="asFilename">asFilename
	^self fileName asFilename</body>

<body package="ChemoJun-Abstract-Objects" selector="asURI">asURI
	^self fileName asURI</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractObject</class-id> <category>copying</category>

<body package="ChemoJun-Abstract-Objects" selector="postCopy">postCopy
	super postCopy.
	fileName := fileName copy</body>
</methods>


</st-source>
