<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76977 "21:22:57"))'</do-it>



<class>
<name>ChemoJunAbstractViewer</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunGeneralViewer</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>informationHolder defaultResolution withoutResetViewWhenOpen serialNumberSetting </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Abstract-Objects</category>
<attributes>
<package>ChemoJun-Abstract-Objects</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer class</class-id> <category>copyright</category>

<body package="ChemoJun-Abstract-Objects" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Abstract-Objects" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Abstract-Objects" selector="version">version
	^'071'
</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>initialize-release</category>

<body package="ChemoJun-Abstract-Objects" selector="initialize">initialize
	super initialize.
	informationHolder := nil.
	defaultResolution := nil.
	withoutResetViewWhenOpen := false.
	self serialNumberSetting</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>accessing</category>

<body package="ChemoJun-Abstract-Objects" selector="featureResolution">featureResolution
	^#medium</body>

<body package="ChemoJun-Abstract-Objects" selector="fileName">fileName
	^nil</body>

<body package="ChemoJun-Abstract-Objects" selector="informationHolder">informationHolder
	informationHolder isNil
		ifTrue: 
			[informationHolder := ValueHolder with: String new.
			informationHolder compute: [:value | self setInformationWindowLabel]].
	^informationHolder</body>

<body package="ChemoJun-Abstract-Objects" selector="numberOfPolygons">numberOfPolygons
	| numberOfPolygons |
	self displayObject isNil ifTrue: [^0].
	numberOfPolygons := 0.
	self displayObject polygonsDo: [:each | numberOfPolygons := numberOfPolygons + 1].
	^numberOfPolygons</body>

<body package="ChemoJun-Abstract-Objects" selector="numberOfPrimitives">numberOfPrimitives
	| numberOfPrimitives |
	self displayObject isNil ifTrue: [^0].
	numberOfPrimitives := 0.
	self displayObject primitivesDo: [:each | numberOfPrimitives := numberOfPrimitives + 1].
	^numberOfPrimitives</body>

<body package="ChemoJun-Abstract-Objects" selector="serialNumberSetting">serialNumberSetting
	serialNumberSetting 
		ifNil: [self serialNumberSetting: self defaulSerialNumberSetting].
	^serialNumberSetting</body>

<body package="ChemoJun-Abstract-Objects" selector="serialNumberSetting:">serialNumberSetting: aSerialNumberSetting 
	serialNumberSetting := aSerialNumberSetting.
	serialNumberSetting compute: 
			[:expression | 
			self indexExpression: expression.
			self flushDisplayObject.
			self changed: #object].
	self indexExpression: serialNumberSetting expression</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>actions</category>

<body package="ChemoJun-Abstract-Objects" selector="clickAt:">clickAt: aPoint 
	^self</body>

<body package="ChemoJun-Abstract-Objects" selector="pickedObjectAt:">pickedObjectAt: mouse2dPoint 
	| compoundObject pickedObject |
	self displayObject isNil ifTrue: [^nil].
	compoundObject := JunOpenGL3dCompoundObject new.
	self displayObject polygonsDo: [:aPolygon | compoundObject add: aPolygon].
	pickedObject := JunOpenGLObjectPicker 
				pickObjectAt: mouse2dPoint
				fromCompound: compoundObject
				projection: self displayProjection.
	pickedObject isNil ifTrue: [^nil].
	^pickedObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>converting</category>

<body package="ChemoJun-Abstract-Objects" selector="asImage">asImage
	| aView imageExtent |
	aView := self getView.
	(aView isNil or: [aView isOpen not]) 
		ifTrue: [imageExtent := self defaultImageExtent]
		ifFalse: [imageExtent := aView bounds extent].
	^self asImageExtent: imageExtent</body>

<body package="ChemoJun-Abstract-Objects" selector="asImageExtent:">asImageExtent: imageExtent 
	| anImage |
	anImage := super asImageExtent: imageExtent.
	self 
		assert: [Pixmap extent: anImage extent]
		do: 
			[:aPixmap | 
			anImage displayOn: aPixmap graphicsContext.
			superimposeBlock notNil 
				ifTrue: 
					[| arguments |
					arguments := Array 
								with: self
								with: aPixmap
								with: nil.
					superimposeBlock 
						valueWithArguments: (arguments copyFrom: 1 to: superimposeBlock numArgs)].
			anImage := aPixmap asImage]
		ensure: [:aPixmap | aPixmap close].
	^anImage</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>defaults</category>

<body package="ChemoJun-Abstract-Objects" selector="defaulSerialNumberSetting">defaulSerialNumberSetting
	| aSerialNumberSetting |
	aSerialNumberSetting := ChemoJunSerialNumberSetting new.
	^aSerialNumberSetting</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultBaseName">defaultBaseName
	^self displayObject name ifNil: [super defaultBaseName]
		ifNotNil: [:aString | aString , '_' , JunSystem defaultBaseName]</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultDisplayViewClass">defaultDisplayViewClass
	^ChemoJunAbstractViewerView</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultEyePoint">defaultEyePoint
	| box distance |
	self displayObject isNil ifTrue: [^10000 , 0 , 0].
	^self defaultProjectionTable at: #eyePoint
		ifAbsent: 
			[box := self boundingBox.
			distance := box origin distance: box corner.
			distance := distance * 2.
			^distance , 0 , 0]</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultMinimumTriangleArea">defaultMinimumTriangleArea
	self featureResolution = #high ifTrue: [^0.001]</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultPartitionSize">defaultPartitionSize
	^16</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultResolution">defaultResolution
	defaultResolution isNil ifTrue: [defaultResolution := #medium].
	^defaultResolution</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultResolution:">defaultResolution: aSymbol 
	(#(#low #medium #high) includes: aSymbol)
		ifTrue: [defaultResolution := aSymbol]</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultShading">defaultShading
	^self defaultProjectionTable at: #shading ifAbsent: [^#smoothShading]</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultString">defaultString
	^String new</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultTriangulationClass">defaultTriangulationClass
	"{ JunFormTriangulation2 | JunFormTriangulation3 }"

	^JunFormTriangulation2</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultUpVector">defaultUpVector
	^self defaultProjectionTable at: #upVector ifAbsent: [0 , -1 , 1]</body>

<body package="ChemoJun-Abstract-Objects" selector="defaultWindowLabel">defaultWindowLabel
	^(#jun_Viewfinder &gt;&gt; 'Viewfinder') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>flushing</category>

<body package="ChemoJun-Abstract-Objects" selector="flushDisplayObject">flushDisplayObject
	self displayObject: nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>interface closing</category>

<body package="ChemoJun-Abstract-Objects" selector="noticeOfWindowClose:">noticeOfWindowClose: aWindow 
	| window |
	super noticeOfWindowClose: aWindow.
	window := self getInformationWindow.
	window isNil ifFalse: [window sensor eventQuit: nil].
	self serialNumberSetting closeRequest</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>interface opening</category>

<body package="ChemoJun-Abstract-Objects" selector="openWithoutResetView">openWithoutResetView
	withoutResetViewWhenOpen := true.
	self open</body>

<body package="ChemoJun-Abstract-Objects" selector="postOpenWith:">postOpenWith: aBuilder 
	super postOpenWith: aBuilder.
	self setWindowLabel.
	withoutResetViewWhenOpen = false ifTrue: [self resetView]</body>

<body package="ChemoJun-Abstract-Objects" selector="setWindowLabel">setWindowLabel
	| aWindow |
	aWindow := self getWindow.
	aWindow isNil ifTrue: [^nil].
	aWindow model = self ifFalse: [^nil].
	aWindow label: self defaultWindowLabel</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>menu accessing</category>

<body package="ChemoJun-Abstract-Objects" selector="updateViewMenuIndication">updateViewMenuIndication
	^self</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>menu messages</category>

<body package="ChemoJun-Abstract-Objects" selector="highResolution">highResolution
	self defaultResolution: #high.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Abstract-Objects" selector="lowResolution">lowResolution
	self defaultResolution: #low.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Abstract-Objects" selector="mediumResolution">mediumResolution
	self defaultResolution: #medium.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Abstract-Objects" selector="settingIndex">settingIndex
	self serialNumberSetting ifNotNil: 
			[:aSerialNumberSetting | 
			| aWindow |
			(aWindow := aSerialNumberSetting getWindow) isNil 
				ifTrue: 
					[aWindow := self getWindow.
					aWindow isNil 
						ifTrue: [self serialNumberSetting open]
						ifFalse: 
							[self serialNumberSetting openAt: aWindow displayBox topRight + (8 @ 0)]]
				ifFalse: 
					[aWindow isCollapsed ifTrue: [aWindow expand].
					aWindow raise]]</body>

<body package="ChemoJun-Abstract-Objects" selector="showInformation">showInformation
	| aWindow myWindow aView |
	(aWindow := self getInformationWindow) isNil
		ifTrue: 
			[aWindow := ComposedTextView
						createOn: self informationHolder
						label: (#chemoJun_Information &gt;&gt; 'Information') asString
						icon: (Icon constantNamed: #workspace).
			(myWindow := self getWindow) isNil
				ifTrue: [aWindow openWithExtent: 300 @ 300]
				ifFalse: [aWindow openIn: (myWindow displayBox bottomRight + (8 @ 27) extent: 300 @ 300)].
			aView := self getInformationView.
			aView controller menuHolder: [self class editMenu].
			self setInformationWindowLabel]
		ifFalse: 
			[aWindow isCollapsed ifTrue: [aWindow expand].
			aWindow raise]</body>

<body package="ChemoJun-Abstract-Objects" selector="spawnObject">spawnObject
	| displayModel |
	displayModel := super spawnObject.
	self moleculeObject 
		ifNotNil: [:it | displayModel displayObject name: it baseName].
	displayModel setWindowLabel.
	displayModel updateMenuIndication.
	^displayModel</body>

<body package="ChemoJun-Abstract-Objects" selector="spawnObject:">spawnObject: spawningObject 
	| aViewer aWindow |
	aViewer := self cloneViewer.
	aViewer displayObject: spawningObject.
	aWindow := aViewer builder window.
	aWindow openWithExtent: aWindow bounds extent.
	aWindow displayPendingInvalidation.
	aViewer setWindowLabel.
	aViewer updateMenuIndication.
	^aWindow</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>pencil</category>

<body package="ChemoJun-Abstract-Objects" selector="boundingBoxesFrom:">boundingBoxesFrom: a3dObject 
	| width height depth denominator point boundingBoxes |
	width := a3dObject boundingBox width.
	height := a3dObject boundingBox height.
	depth := a3dObject boundingBox depth.
	denominator := width max: (height max: depth).
	point := width / denominator , (height / denominator) 
				, (depth / denominator).
	point := point * self defaultPartitionSize.
	point := point rounded.
	boundingBoxes := Jun3dBoundingBoxes fromObject: a3dObject howMany: point.
	self pencilTrace: 
			[| aBody aViewfinder aViewport |
			aBody := JunOpenGL3dCompoundObject new.
			aBody add: self displayObject.
			aBody add: a3dObject.
			aBody 
				add: (boundingBoxes asJunOpenGL3dObjectColor: ColorValue cyan alpha: 0.1).
			aViewfinder := JunOpenGLDisplayModel displayObject: aBody.
			aViewfinder defaultProjectionTable: self projectionTable.
			aViewfinder openAt: 200 @ 200.
			aViewfinder parallelProjection.
			aViewport := JunOpenGLShowModel displayModel: aViewfinder.
			aViewport useTransparency: true.
			aViewport openAt: 200 @ 200.
			aViewport parallelProjection].
	^boundingBoxes</body>

<body package="ChemoJun-Abstract-Objects" selector="convert:triangles:controller:">convert: collectionOfPoints triangles: collectionOfTriangles controller: aController 
	| aPlane aProjection pointCollection triangleCollection |
	aProjection := self displayProjection.
	pointCollection := collectionOfPoints collect: 
					[:point | 
					| aPoint |
					aPoint := aController regularizePoint: point.
					aPoint := aProjection translateTo3dPointFromPoint: aPoint.
					aPoint := aPoint - self sightPoint.
					aPoint yourself].
	triangleCollection := collectionOfTriangles collect: 
					[:triangle | 
					| aTriangle |
					aTriangle := triangle collect: 
									[:point | 
									| aPoint |
									aPoint := aController regularizePoint: point.
									aPoint := aProjection translateTo3dPointFromPoint: aPoint.
									aPoint := aPoint - self sightPoint.
									aPoint yourself].
					aPlane := JunPlane 
								on: (aTriangle at: 1)
								on: (aTriangle at: 2)
								on: (aTriangle at: 3).
					(aPlane valueF: self eyePoint) sign &lt; 0 
						ifTrue: [aTriangle := aTriangle reverse].
					aTriangle yourself].
	self pencilTrace: 
			[| aLine aTransformation0 aTransformation1 aTransformation2 aBody aViewfinder aViewport |
			aLine := (self sightPoint to: self eyePoint) normalized.
			aTransformation0 := Jun3dTransformation 
						translate: (aLine atT: self zoomHeight / 2).
			aTransformation1 := Jun3dTransformation 
						translate: (aLine atT: self zoomHeight / 1.99).
			aTransformation2 := Jun3dTransformation 
						translate: (aLine atT: self zoomHeight / 1.98).
			aBody := JunOpenGL3dCompoundObject new.
			aBody add: self displayObject.
			triangleCollection do: 
					[:triangle | 
					| aTriangle aPolyline |
					aTriangle := (JunOpenGL3dPolygon vertexes: triangle asArray) 
								transform: aTransformation0.
					aTriangle paint: (ColorValue red blendWith: ColorValue white).
					aBody add: aTriangle.
					aTriangle := (JunOpenGL3dPolylineLoop vertexes: triangle asArray) 
								transform: aTransformation1.
					aTriangle lineWidth: 1.
					aTriangle paint: ColorValue red.
					aBody add: aTriangle.
					aPolyline := (JunOpenGL3dPolylineLoop vertexes: pointCollection) 
								transform: aTransformation2.
					aPolyline lineWidth: 3.
					aPolyline paint: ColorValue magenta.
					aBody add: aPolyline].
			aViewfinder := JunOpenGLDisplayModel displayObject: aBody.
			aViewfinder defaultProjectionTable: self projectionTable.
			aViewfinder openAt: 200 @ 200.
			aViewfinder parallelProjection.
			aViewport := JunOpenGLShowModel displayModel: aViewfinder.
			aViewport useTransparency: true.
			aViewport openAt: 200 @ 200.
			aViewport parallelProjection].
	^Array with: pointCollection with: triangleCollection</body>

<body package="ChemoJun-Abstract-Objects" selector="cylinder:triangles:">cylinder: pointCollection triangles: triangleCollection 
	| baseLine aRadius anInterval anArray aCylinder aPolygon aTransformation |
	baseLine := (Jun3dLine from: self sightPoint to: self eyePoint) 
				normalizedLine.
	aRadius := self zoomHeight / 2.
	baseLine := Jun3dLine from: (baseLine atT: 0)
				to: (baseLine atT: aRadius * 1.5).
	anInterval := 0 to: 1 by: 0.1.
	anArray := Array new: anInterval size.
	(1 to: anArray size) 
		do: [:index | anArray at: index put: (OrderedCollection new: pointCollection size)].
	pointCollection do: 
			[:aPoint | 
			| aLine |
			aLine := baseLine translatedBy: aPoint.
			anInterval with: (1 to: anArray size)
				do: [:t :index | (anArray at: index) add: (aLine atT: t)]].
	aCylinder := JunOpenGL3dCompoundObject new.
	(1 to: anArray size - 1) do: 
			[:arrayIndex | 
			| fromPoints toPoints fp1 tp1 fp2 tp2 |
			fromPoints := anArray at: arrayIndex.
			toPoints := anArray at: arrayIndex + 1.
			fp1 := fromPoints at: 1.
			tp1 := toPoints at: 1.
			(2 to: pointCollection size) do: 
					[:index | 
					fp2 := fromPoints at: index.
					tp2 := toPoints at: index.
					aPolygon := JunOpenGL3dPolygon vertexes: (Array 
										with: fp1
										with: tp1
										with: tp2
										with: fp2).
					self defaultTriangulationClass = JunFormTriangulation3 
						ifTrue: [aPolygon := aPolygon reversed].
					aCylinder add: aPolygon.
					fp1 := fp2.
					tp1 := tp2]].
	aTransformation := Jun3dTransformation translate: (baseLine atT: 0).
	triangleCollection do: 
			[:aTriangle | 
			aPolygon := (JunOpenGL3dPolygon vertexes: aTriangle reverse) 
						transform: aTransformation.
			aCylinder add: aPolygon].
	aTransformation := Jun3dTransformation translate: (baseLine atT: 1).
	triangleCollection do: 
			[:aTriangle | 
			aPolygon := (JunOpenGL3dPolygon vertexes: aTriangle yourself) 
						transform: aTransformation.
			aCylinder add: aPolygon].
	aCylinder 
		primitivesDo: [:primitive | primitive paint: ColorValue magenta alpha: 0.5].
	self pencilTrace: 
			[| aBody aViewfinder aViewport |
			aBody := JunOpenGL3dCompoundObject new.
			aBody add: self displayObject.
			aBody add: aCylinder.
			aViewfinder := JunOpenGLDisplayModel displayObject: aBody.
			aViewfinder defaultProjectionTable: self projectionTable.
			aViewfinder openAt: 200 @ 200.
			aViewfinder parallelProjection.
			aViewport := JunOpenGLShowModel displayModel: aViewfinder.
			aViewport useTransparency: true.
			aViewport openAt: 200 @ 200.
			aViewport parallelProjection].
	^aCylinder</body>

<body package="ChemoJun-Abstract-Objects" selector="extractPatchesFrom:">extractPatchesFrom: boundingBoxes 
	| compoundObject cursorAnimator |
	compoundObject := JunOpenGL3dCompoundObject new.
	cursorAnimator := JunCursorAnimator clockCursors.
	cursorAnimator tick: 1000.
	cursorAnimator showWhile: 
			[self displayObject polygonsDo: 
					[:aPolygon | 
					| anArray |
					anArray := aPolygon asPointArray 
								collect: [:aPoint | boundingBoxes containsPoint: aPoint].
					(anArray detect: [:aBoolean | aBoolean = false] ifNone: [nil]) isNil 
						ifTrue: [compoundObject add: aPolygon]]].
	self pencilTrace: 
			[| aBody aViewfinder |
			aBody := JunOpenGL3dCompoundObject new.
			aBody add: compoundObject.
			aBody 
				add: (boundingBoxes asJunOpenGL3dObjectColor: ColorValue cyan alpha: 0.1).
			aViewfinder := JunOpenGLDisplayModel displayObject: aBody.
			aViewfinder defaultProjectionTable: self projectionTable.
			aViewfinder openAt: 200 @ 200.
			aViewfinder parallelProjection].
	"[| frontPatches |
	frontPatches := JunOpenGL3dCompoundObject new.
	compoundObject polygonsDo: 
			[:aPolygon | 
			| pointCollection aPlane |
			pointCollection := aPolygon vertexes.
			aPlane := JunPlane 
						on: (pointCollection at: 1)
						on: (pointCollection at: pointCollection size // 3 + 1)
						on: (pointCollection at: pointCollection size // 3 * 2 + 1).
			(aPlane valueF: self eyePoint) &gt;= 0 ifTrue: [frontPatches add: aPolygon]].
	compoundObject := frontPatches] value."
	^compoundObject</body>

<body package="ChemoJun-Abstract-Objects" selector="pencilClosedPointCollection:from:">pencilClosedPointCollection: collectionOfPoints from: aController 
	| aTriangulation anArray aCylinder boundingBoxes patchCollection |
	self displayObject isNil ifTrue: [^nil].
	collectionOfPoints size &lt; 3 ifTrue: [^nil].
	aController isNil ifTrue: [^nil].
	self errorSignal handle: 
			[:exception | 
			JunDialog 
				warn: (#chemoJun_Can_not_perform_triangulation_ 
						&gt;&gt; 'Can not perform triangulation.') asString.
			^nil]
		do: 
			[aTriangulation := self 
						triangulationClass: self defaultTriangulationClass
						pointCollection: collectionOfPoints
						controller: aController].
	self errorSignal handle: 
			[:exception | 
			JunDialog 
				warn: (#chemoJun_Can_not_perform_conversion_ &gt;&gt; 'Can not perform conversion.') 
						asString.
			^nil]
		do: 
			[anArray := self 
						convert: aTriangulation points
						triangles: aTriangulation triangles
						controller: aController].
	aCylinder := self cylinder: anArray first triangles: anArray last.
	aCylinder components isEmpty ifTrue: [^nil].
	boundingBoxes := self boundingBoxesFrom: aCylinder.
	boundingBoxes isEmpty ifTrue: [^nil].
	patchCollection := self extractPatchesFrom: boundingBoxes.
	patchCollection components isEmpty ifTrue: [^nil].
	self spawnObject: patchCollection</body>

<body package="ChemoJun-Abstract-Objects" selector="pencilOpenedPointCollection:from:">pencilOpenedPointCollection: collectionOfPoints from: aController 
	| aPlane patchCollection |
	self displayObject isNil ifTrue: [^nil].
	collectionOfPoints size &lt; 3 ifTrue: [^nil].
	aController isNil ifTrue: [^nil].
	aPlane := self plane: collectionOfPoints from: aController.
	patchCollection := self splitPathesFrom: aPlane.
	patchCollection components isEmpty ifTrue: [^nil].
	self spawnObject: patchCollection</body>

<body package="ChemoJun-Abstract-Objects" selector="pencilTrace:">pencilTrace: aBlock 
	"aBlock value"</body>

<body package="ChemoJun-Abstract-Objects" selector="plane:from:">plane: collectionOfPoints from: aController 
	| aProjection pointCollection firstPoint secondPoint thirdPoint aLine aPlane |
	self pencilTrace: 
			[aController notNil 
				ifTrue: 
					[| anImage aWindow |
					anImage := aController view topComponent asImage.
					aWindow := ScheduledWindow new.
					aWindow label: self getWindow label.
					aWindow component: anImage.
					aWindow openIn: (200 @ 200 extent: anImage extent)]].
	aProjection := self displayProjection.
	pointCollection := collectionOfPoints collect: 
					[:point | 
					| aPoint |
					aPoint := aController regularizePoint: point.
					aPoint := aProjection translateTo3dPointFromPoint: aPoint.
					aPoint := aPoint - self sightPoint.
					aPoint yourself].
	aLine := (Jun3dLine from: self sightPoint to: self eyePoint) 
				normalizedLine.
	firstPoint := pointCollection first 
				translatedBy: (aLine atT: self zoomHeight / 2).
	secondPoint := pointCollection last 
				translatedBy: (aLine atT: self zoomHeight / 2).
	aLine := aLine 
				translatedBy: (firstPoint center: secondPoint) - (aLine atT: 0).
	thirdPoint := aLine atT: (self zoomHeight * 1.5) negated.
	aPlane := firstPoint plane: secondPoint and: thirdPoint.
	^aPlane</body>

<body package="ChemoJun-Abstract-Objects" selector="splitPathesFrom:">splitPathesFrom: aPlane 
	| compoundObject cursorAnimator |
	self pencilTrace: 
			[| aCircle aBody aViewfinder |
			aCircle := Jun3dCircle 
						center: aPlane asTriangle centerOfGravity
						radius: self zoomHeight / 2
						upVector: aPlane normalVector.
			aBody := JunOpenGL3dCompoundObject new.
			aBody add: self displayObject.
			aBody 
				add: (aCircle asJunOpenGL3dObjectColor: ColorValue magenta alpha: 0.5) 
						reversed.
			aBody 
				add: (aCircle asJunOpenGL3dObjectColor: ColorValue magenta alpha: 0.5).
			aViewfinder := JunOpenGLDisplayModel displayObject: aBody.
			aViewfinder defaultProjectionTable: self projectionTable.
			aViewfinder openAt: 200 @ 200
			"aViewfinder parallelProjection"].
	compoundObject := JunOpenGL3dCompoundObject new.
	cursorAnimator := JunCursorAnimator handCursors.
	cursorAnimator tick: 1000.
	cursorAnimator showWhile: 
			[self displayObject polygonsDo: 
					[:aPolygon | 
					| anArray |
					anArray := aPolygon asPointArray 
								collect: [:aPoint | (aPlane valueF: aPoint) &gt;= 0].
					(anArray detect: [:aBoolean | aBoolean = false] ifNone: [nil]) isNil 
						ifTrue: [compoundObject add: aPolygon]]].
	self pencilTrace: 
			[| aCircle aBody aViewfinder |
			aCircle := Jun3dCircle 
						center: aPlane asTriangle centerOfGravity
						radius: self zoomHeight / 2
						upVector: aPlane normalVector.
			aBody := JunOpenGL3dCompoundObject new.
			aBody add: compoundObject.
			aBody 
				add: (aCircle asJunOpenGL3dObjectColor: ColorValue magenta alpha: 0.5) 
						reversed.
			aBody 
				add: (aCircle asJunOpenGL3dObjectColor: ColorValue magenta alpha: 0.5).
			aViewfinder := JunOpenGLDisplayModel displayObject: aBody.
			aViewfinder defaultProjectionTable: self projectionTable.
			aViewfinder openAt: 200 @ 200
			"aViewfinder parallelProjection"].
	^compoundObject</body>

<body package="ChemoJun-Abstract-Objects" selector="triangulationClass:pointCollection:controller:">triangulationClass: aClass pointCollection: collectionOfPoints controller: aController 
	| formTriangulation |
	self pencilTrace: 
			[aController notNil 
				ifTrue: 
					[| anImage aWindow |
					anImage := aController view topComponent asImage.
					aWindow := ScheduledWindow new.
					aWindow label: self getWindow label.
					aWindow component: anImage.
					aWindow openIn: (200 @ 200 extent: anImage extent)]].
	formTriangulation := aClass points: collectionOfPoints.
	self pencilTrace: 
			[| aWindow aPixmap graphicsContext |
			aWindow := ScheduledWindow new.
			aWindow label: 'Triangulation'.
			aWindow 
				openIn: (200 @ 200 extent: formTriangulation boundingBox extent rounded).
			aPixmap := Pixmap extent: aWindow bounds extent.
			
			[self errorSignal handle: 
					[:exception | 
					aWindow controller closeAndUnschedule.
					exception reject]
				do: 
					[graphicsContext := aPixmap graphicsContext.
					graphicsContext paint: ColorValue white.
					graphicsContext displayRectangle: aPixmap bounds.
					JunApplicationModel displayPendingInvalidation.
					Cursor wait showWhile: 
							[self defaultTriangulationClass = JunFormTriangulation2 
								ifTrue: 
									[formTriangulation trianglesInterim: 
											[:triangles :triangle :pending | 
											formTriangulation 
												displayOn: graphicsContext
												triangles: triangles
												triangle: triangle
												pending: pending.
											JunApplicationModel displayPendingInvalidation.
											aWindow raise.
											aWindow graphicsContext displayPixmap: aPixmap at: Point zero]].
							self defaultTriangulationClass = JunFormTriangulation3 
								ifTrue: 
									[formTriangulation trianglesInterim: 
											[:triangles | 
											formTriangulation displayOn: graphicsContext triangles: triangles.
											JunApplicationModel displayPendingInvalidation.
											aWindow raise.
											aWindow graphicsContext displayPixmap: aPixmap at: Point zero]]].
					formTriangulation displayOn: graphicsContext.
					JunApplicationModel displayPendingInvalidation.
					aWindow raise.
					aWindow graphicsContext displayPixmap: aPixmap at: Point zero.
					aWindow component: aPixmap asImage.
					aWindow display.
					JunApplicationModel displayPendingInvalidation]] 
					ensure: [aPixmap close]].
	^formTriangulation</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>testing</category>

<body package="ChemoJun-Abstract-Objects" selector="is2d">is2d
	^false</body>

<body package="ChemoJun-Abstract-Objects" selector="is3d">is3d
	^true</body>

<body package="ChemoJun-Abstract-Objects" selector="isElectroViewer">isElectroViewer
	^false</body>

<body package="ChemoJun-Abstract-Objects" selector="isFeaturesViewer">isFeaturesViewer
	^false</body>

<body package="ChemoJun-Abstract-Objects" selector="isMoleculeViewer">isMoleculeViewer
	^false</body>

<body package="ChemoJun-Abstract-Objects" selector="isStericViewer">isStericViewer
	^false</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>updating</category>

<body package="ChemoJun-Abstract-Objects" selector="updateStringHolder:">updateStringHolder: aValue 
	^self</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewer</class-id> <category>private</category>

<body package="ChemoJun-Abstract-Objects" selector="classToSpawn">classToSpawn
	(JunSensorUtility shiftDown or: [JunSensorUtility altDown]) 
		ifTrue: [^JunOpenGLDisplayModel].
	^ChemoJunAbstractViewer</body>

<body package="ChemoJun-Abstract-Objects" selector="cloneViewer">cloneViewer
	^self cloneViewerUseDisplayList: self useDisplayList</body>

<body package="ChemoJun-Abstract-Objects" selector="cloneViewerUseDisplayList:">cloneViewerUseDisplayList: aBoolean 
	| aViewer |
	aViewer := self class new.
	aBoolean = true 
		ifTrue: [aViewer useDisplayList: true]
		ifFalse: [aViewer useDisplayList: false].
	aViewer displayObject: self displayObject.
	aViewer defaultProjectionTable: self projectionTable.
	aViewer allButOpenInterface: #windowSpec.
	aViewer projectionTable: self projectionTable.
	^aViewer</body>

<body package="ChemoJun-Abstract-Objects" selector="getInformationView">getInformationView
	| window |
	window := self informationHolder dependents detect: [:each | each isKindOf: ComposedTextView]
				ifNone: [nil].
	window isNil ifTrue: [^nil].
	^window</body>

<body package="ChemoJun-Abstract-Objects" selector="getInformationWindow">getInformationWindow
	| window |
	window := self informationHolder dependents detect: [:each | each isKindOf: ScheduledWindow]
				ifNone: [nil].
	window isNil ifTrue: [^nil].
	^window</body>

<body package="ChemoJun-Abstract-Objects" selector="setInformationWindowLabel">setInformationWindowLabel
	| aWindow aString |
	aWindow := self getInformationWindow.
	aWindow isNil ifTrue: [^nil].
	aString := (#chemoJun_Information &gt;&gt; 'Information') asString.
	self fileName notNil ifTrue: [aString := aString , ' [' , (Filename splitPath: self fileName asString) last , ']'].
	aWindow label: aString</body>
</methods>


</st-source>
