<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76976 "21:22:56"))'</do-it>



<class>
<name>ChemoJunAbstractViewerController</name>
<environment>ChemoJun</environment>
<super>Jun.JunOpenGLDisplayController</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars></inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Abstract-Objects</category>
<attributes>
<package>ChemoJun-Abstract-Objects</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunAbstractViewerController class</class-id> <category>copyright</category>

<body package="ChemoJun-Abstract-Objects" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Abstract-Objects" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Abstract-Objects" selector="version">version
	^'071'
</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunAbstractViewerController</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewerController</class-id> <category>control defaults</category>

<body package="ChemoJun-Abstract-Objects" selector="boundsActivity">boundsActivity
	self flushMovementVector.
	self sensor waitNoButton</body>

<body package="ChemoJun-Abstract-Objects" selector="clickActivity">clickActivity
	self flushMovementVector.
	self model clickAt: self mouse2dPoint.
	self sensor waitNoButton</body>

<body package="ChemoJun-Abstract-Objects" selector="pencilActivity">pencilActivity
	| mouse gc pointCollection current previous index array4 array3 array2 points viewSize |
	self flushMovementVector.
	mouse := self sensor.
	gc := self view graphicsContext.
	gc paint: self nibColor.
	gc lineWidth: self nibWidth.
	gc capStyle: gc class capRound.
	gc joinStyle: gc class joinRound.
	pointCollection := OrderedCollection new: 1024.
	current := previous := mouse cursorPoint.
	pointCollection add: current.
	index := 1.
	array4 := Array new: 4.
	array3 := Array new: 3.
	array2 := Array new: 2.
	self view displayOn: gc
		dotBox: ((current extent: 1 @ 1) expandedBy: (self nibWidth // 2 max: 0)).
	[mouse redButtonPressed] whileTrue: 
			[current := mouse cursorPoint.
			((current = previous) not and: [(current dist: previous) &gt;= 8]) 
				ifTrue: 
					[pointCollection add: current.
					index := index + 1.
					index &gt;= 4 
						ifTrue: 
							[array4 at: 1 put: (pointCollection at: index - 3).
							array4 at: 2 put: (pointCollection at: index - 2).
							array4 at: 3 put: (pointCollection at: index - 1).
							array4 at: 4 put: (pointCollection at: index).
							points := array4]
						ifFalse: 
							[index &gt;= 3 
								ifTrue: 
									[array3 at: 1 put: (pointCollection at: index - 2).
									array3 at: 2 put: (pointCollection at: index - 1).
									array3 at: 3 put: (pointCollection at: index).
									points := array3]
								ifFalse: 
									[array2 at: 1 put: (pointCollection at: index - 1).
									array2 at: 2 put: (pointCollection at: index).
									points := array2]].
					gc displayPolyline: points.
					previous := current].
			Processor yield].
	viewSize := self view bounds width max: self view bounds height.
	(pointCollection first dist: pointCollection last) &gt; (viewSize / 2) 
		ifTrue: 
			[gc displayPolyline: pointCollection.
			self sensor shiftDown 
				ifFalse: [self model pencilOpenedPointCollection: pointCollection from: self].
			self view redisplay]
		ifFalse: 
			[pointCollection first = pointCollection last 
				ifFalse: [pointCollection add: pointCollection first].
			gc displayPolyline: pointCollection.
			self sensor shiftDown 
				ifFalse: [self model pencilClosedPointCollection: pointCollection from: self].
			self view redisplay]</body>

<body package="ChemoJun-Abstract-Objects" selector="redButtonActivity">redButtonActivity
	| state |
	state := self model buttonState.
	state = #pick 
		ifTrue: 
			[(self model pickButton respondsTo: #selectedSelector) 
				ifTrue: 
					[| symbol |
					symbol := self model pickButton selectedSelector.
					symbol = #pickNormal 
						ifTrue: [^Cursor normal showWhile: [self pickActivity]].
					symbol = #pickBounds 
						ifTrue: [^JunCursors crossCursor showWhile: [self boundsActivity]].
					symbol = #pickPencil 
						ifTrue: [^JunCursors pencilCursor showWhile: [self pencilActivity]]]
				ifFalse: [^Cursor normal showWhile: [self pickActivity]]].
	state = #grab 
		ifTrue: [^JunCursors handCursor showWhile: [self grabActivity]].
	state = #drag 
		ifTrue: [^JunCursors quartersCursor showWhile: [self dragActivity]].
	state = #focus 
		ifTrue: [^JunCursors glassCursor showWhile: [self focusActivity]].
	^Cursor bull showWhile: [self clickActivity]</body>

<body package="ChemoJun-Abstract-Objects" selector="yellowButtonActivity">yellowButtonActivity
	super yellowButtonActivity ifNil: [^nil].
	"self model is3d 
		ifTrue: 
			[| state |
			self 
				assert: 
					[state := self model buttonState.
					state = #grab ifFalse: [self model buttonState: #grab]]
				do: [JunCursors handCursor showWhile: [self grabActivity]]
				ensure: [self model buttonState: state]]."
	^self processMenuAt: self sensor globalCursorPoint centered: true</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewerController</class-id> <category>events</category>

<body package="ChemoJun-Abstract-Objects" selector="mouseMovedEvent:">mouseMovedEvent: event 
	self viewHasCursor 
		ifTrue: 
			[| state |
			state := self model buttonState.
			state isNil ifTrue: [JunCursors crossCursor show].
			state = #pick ifTrue: [Cursor normal show].
			state = #grab ifTrue: [JunCursors handCursor show].
			state = #drag ifTrue: [JunCursors quartersCursor show].
			state = #focus ifTrue: [JunCursors glassCursor show]]
		ifFalse: [Cursor normal show].
	^nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunAbstractViewerController</class-id> <category>private</category>

<body package="ChemoJun-Abstract-Objects" selector="nibColor">nibColor
	^ColorValue magenta</body>

<body package="ChemoJun-Abstract-Objects" selector="nibWidth">nibWidth
	^3</body>
</methods>


</st-source>
