<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76977 "21:22:57"))'</do-it>



<class>
<name>ChemoJunImageCatalogElement</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunImageCatalogVoid</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>preferenceTable moleculeFilename thumbnailImage mappingPoints </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Catalog-Image</category>
<attributes>
<package>ChemoJun-Catalog-Image</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement class</class-id> <category>instance creation</category>

<body package="ChemoJun-Catalog-Image" selector="filename:">filename: aFilename 
	^(self new)
		filename: aFilename;
		yourself</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement class</class-id> <category>copyright</category>

<body package="ChemoJun-Catalog-Image" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Catalog-Image" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Catalog-Image" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement class</class-id> <category>defaults</category>

<body package="ChemoJun-Catalog-Image" selector="defaultEmptyColor">defaultEmptyColor
	| colorValue |
	colorValue := ColorValue blue.
	2 timesRepeat: [colorValue := colorValue blendWith: ColorValue white].
	^colorValue</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement class</class-id> <category>examples</category>

<body package="ChemoJun-Catalog-Image" selector="example1">example1
	"ChemoJunImageCatalogElement example1."

	| moleculeObject catalogElement |
	(moleculeObject := ChemoJunMoleculeObject request) ifNil: [^nil].
	catalogElement := ChemoJunImageCatalogElement 
				filename: moleculeObject fileName.
	JunImageDisplayModel show: catalogElement thumbnail.
	^catalogElement</body>

<body package="ChemoJun-Catalog-Image" selector="example2">example2
	"ChemoJunImageCatalogElement example2."

	| moleculeObject catalogElement |
	(moleculeObject := ChemoJunMoleculeObject request) ifNil: [^nil].
	catalogElement := ChemoJunImageCatalogElement 
				filename: moleculeObject fileName.
	catalogElement moleculePresentation: #moleculeAsSpaceFill.
	catalogElement viewerExtent: 256 @ 256.
	catalogElement projectionTable: ((Core.Dictionary new)
				add: #sightPoint -&gt; (-0.6d , 2.9d , 1.5d);
				add: #presentation -&gt; #solidPresentation;
				add: #eyePoint -&gt; (0 , 0 , 10);
				add: #zoomHeight -&gt; 4;
				add: #shading -&gt; #smoothShading;
				add: #viewFactor -&gt; 10;
				add: #projection -&gt; #perspectiveProjection;
				add: #upVector -&gt; (0 , 1 , 0);
				yourself).
	"JunImageDisplayModel show: catalogElement thumbnail."
	^catalogElement</body>

<body package="ChemoJun-Catalog-Image" selector="example3">example3
	"ChemoJunImageCatalogElement example3."

	| moleculeObject catalogElement lispList |
	(moleculeObject := ChemoJunMoleculeObject request) ifNil: [^nil].
	catalogElement := ChemoJunImageCatalogElement 
				filename: moleculeObject fileName.
	catalogElement moleculePresentation: #moleculeAsSpaceFill.
	catalogElement viewerExtent: 256 @ 256.
	catalogElement projectionTable: ((Core.Dictionary new)
				add: #sightPoint -&gt; (-0.6d , 2.9d , 1.5d);
				add: #presentation -&gt; #solidPresentation;
				add: #eyePoint -&gt; (0 , 0 , 10);
				add: #zoomHeight -&gt; 4;
				add: #shading -&gt; #smoothShading;
				add: #viewFactor -&gt; 10;
				add: #projection -&gt; #perspectiveProjection;
				add: #upVector -&gt; (0 , 1 , 0);
				yourself).
	lispList := catalogElement toLispList.
	Transcript
		clear;
		show: lispList saveString.
	catalogElement := catalogElement class fromLispList: lispList.
	lispList := catalogElement toLispList.
	Transcript
		cr;
		show: lispList saveString.
	^catalogElement</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement class</class-id> <category>lisp support</category>

<body package="ChemoJun-Catalog-Image" selector="fromLispList:for:">fromLispList: aList for: anElement 
	| aTable |
	aTable := self tableFromLispList: aList tail.
	self preferenceTableFromTable: aTable for: anElement.
	self moleculeFilenameFromTable: aTable for: anElement.
	^anElement</body>

<body package="ChemoJun-Catalog-Image" selector="moleculeFilenameFromTable:for:">moleculeFilenameFromTable: aTable for: anElement 
	| moleculeFilename |
	moleculeFilename := aTable at: #moleculeFilename ifAbsent: [^anElement].
	anElement moleculeFilename: moleculeFilename.
	^anElement</body>

<body package="ChemoJun-Catalog-Image" selector="preferenceTableFromTable:for:">preferenceTableFromTable: aTable for: anElement 
	| aList preferenceTable |
	aList := aTable at: #preferenceTable ifAbsent: [^anElement].
	preferenceTable := JunAttributeTable fromLispList: aList.
	anElement preferenceTable: preferenceTable.
	^anElement</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id> <category>initialize-release</category>

<body package="ChemoJun-Catalog-Image" selector="initialize">initialize
	super initialize.
	preferenceTable := nil.
	moleculeFilename := nil.
	thumbnailImage := nil.
	mappingPoints := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id> <category>accessing</category>

<body package="ChemoJun-Catalog-Image" selector="filename">filename
	self moleculeFilename ifNil: [^nil].
	self moleculeFilename isEmpty ifTrue: [^self moleculeFilename].
	self moleculeFilename first = JunUniFileName uniSeparator 
		ifTrue: [^(JunUniFileName named: self moleculeFilename) asFilename].
	^(JunUniFileName 
		named: ChemoJunUtility defaultDirectoryString , self moleculeFilename) asFilename</body>

<body package="ChemoJun-Catalog-Image" selector="filename:">filename: aFilename 
	| defaultDirectoryString fileNameString |
	defaultDirectoryString := ChemoJunUtility defaultDirectoryString.
	fileNameString := (JunUniFileName fromPlatformFilename: aFilename) 
				uniFileName asString.
	(fileNameString findString: defaultDirectoryString startingAt: 1) = 1 
		ifTrue: 
			[fileNameString := fileNameString copyFrom: defaultDirectoryString size + 1
						to: fileNameString size.
			
			[fileNameString isEmpty not 
				and: [fileNameString first = JunUniFileName uniSeparator]] 
					whileTrue: 
						[fileNameString := fileNameString copyFrom: 2 to: fileNameString size]].
	self moleculeFilename: fileNameString</body>

<body package="ChemoJun-Catalog-Image" selector="image">image
	| moleculeObject anImage moleculeViewer |
	self filename asFilename exists ifFalse: [^nil].
	self errorSignal handle: 
			[:exception | 
			anImage := nil.
			exception reject]
		do: 
			[moleculeObject := self moleculeObject.
			moleculeObject ifNil: [^nil].
			moleculeObject atomObjects isEmpty ifTrue: [^nil].
			moleculeViewer := self class defaultMoleculeViewerClass 
						moleculeObject: moleculeObject.
			self toPreferences: moleculeViewer.
			anImage := moleculeViewer asImageExtent: (self viewerExtent 
								ifNil: [self extent * self defaultImageMagnifyingFactor]
								ifNotNil: [:it | it]).
			self computeMappingPoints: moleculeViewer].
	^anImage</body>

<body package="ChemoJun-Catalog-Image" selector="mappingPoints">mappingPoints
	mappingPoints ifNil: [mappingPoints := Array new].
	^mappingPoints</body>

<body package="ChemoJun-Catalog-Image" selector="moleculeObject">moleculeObject
	| moleculeObject |
	self filename ifNil: [^nil].
	self filename asFilename exists ifFalse: [^nil].
	moleculeObject := self class defaultMoleculeObjectClass 
				fileName: self filename asFilename.
	^moleculeObject</body>

<body package="ChemoJun-Catalog-Image" selector="thumbnail">thumbnail
	thumbnailImage ifNil: 
			[self image 
				ifNotNil: [:image | self thumbnail: (self decoratedImage: image)]].
	^thumbnailImage</body>

<body package="ChemoJun-Catalog-Image" selector="thumbnail:">thumbnail: anImage 
	thumbnailImage := anImage ifNil: [nil]
				ifNotNil: [:it | CachedImage on: (it convertForGraphicsDevice: Screen default)]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id> <category>bounds accessing</category>

<body package="ChemoJun-Catalog-Image" selector="bounds:">bounds: newBounds 
	super bounds: newBounds.
	thumbnailImage ifNotNil: 
			[thumbnailImage extent = displayBox extent ifTrue: [^displayBox].
			thumbnailImage := nil].
	self thumbnail.
	^displayBox</body>

<body package="ChemoJun-Catalog-Image" selector="preferredBounds">preferredBounds
	displayBox ifNil: 
			[displayBox := self thumbnail ifNil: [Point zero extent: Point zero]
						ifNotNil: [:it | Point zero extent: it extent]].
	^displayBox</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id> <category>copying</category>

<body package="ChemoJun-Catalog-Image" selector="postCopy">postCopy
	super postCopy.
	preferenceTable := preferenceTable copy.
	moleculeFilename := moleculeFilename copy.
	thumbnailImage := thumbnailImage copy.
	mappingPoints := self mappingPoints collect: [:each | each copy]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id> <category>lisp support</category>

<body package="ChemoJun-Catalog-Image" selector="moleculeFilenameToLispList">moleculeFilenameToLispList
	| alist |
	alist := self lispCons.
	alist head: #moleculeFilename.
	alist tail: self moleculeFilename asString.
	^alist</body>

<body package="ChemoJun-Catalog-Image" selector="preferenceTableToLispList">preferenceTableToLispList
	| alist |
	alist := self lispCons.
	alist head: #preferenceTable.
	alist tail: self preferenceTable toLispList.
	^alist</body>

<body package="ChemoJun-Catalog-Image" selector="toLispList">toLispList
	| aList |
	aList := self lispCons.
	aList head: self class name.
	self preferenceTable isEmpty 
		ifFalse: [aList add: self preferenceTableToLispList].
	self moleculeFilename 
		ifNotNil: [aList add: self moleculeFilenameToLispList].
	^aList</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id> <category>preferences</category>

<body package="ChemoJun-Catalog-Image" selector="atomResolution">atomResolution
	^self preferenceTable at: #atomResolution ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Image" selector="atomResolution:">atomResolution: aSymbol 
	self preferenceTable at: #atomResolution put: aSymbol</body>

<body package="ChemoJun-Catalog-Image" selector="exceptHydrogen">exceptHydrogen
	^self preferenceTable at: #exceptHydrogen ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Image" selector="exceptHydrogen:">exceptHydrogen: aBoolean 
	self preferenceTable at: #exceptHydrogen put: aBoolean = true</body>

<body package="ChemoJun-Catalog-Image" selector="exceptIndex">exceptIndex
	^self preferenceTable at: #exceptIndex ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Image" selector="exceptIndex:">exceptIndex: aBoolean 
	self preferenceTable at: #exceptIndex put: aBoolean = true</body>

<body package="ChemoJun-Catalog-Image" selector="moleculePresentation">moleculePresentation
	^self preferenceTable at: #moleculePresentation ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Image" selector="moleculePresentation:">moleculePresentation: messageSymbol 
	self preferenceTable at: #moleculePresentation put: messageSymbol</body>

<body package="ChemoJun-Catalog-Image" selector="preferenceTable">preferenceTable
	preferenceTable ifNil: [preferenceTable := JunAttributeTable new].
	^preferenceTable</body>

<body package="ChemoJun-Catalog-Image" selector="preferenceTable:">preferenceTable: attributeTable 
	preferenceTable := attributeTable</body>

<body package="ChemoJun-Catalog-Image" selector="projectionTable">projectionTable
	^self preferenceTable at: #projectionTable ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Image" selector="projectionTable:">projectionTable: aDictionary 
	self preferenceTable at: #projectionTable put: aDictionary</body>

<body package="ChemoJun-Catalog-Image" selector="serialNumberSetting">serialNumberSetting
	^self preferenceTable at: #serialNumberSetting ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Image" selector="serialNumberSetting:">serialNumberSetting: settingCollection 
	self preferenceTable at: #serialNumberSetting put: settingCollection</body>

<body package="ChemoJun-Catalog-Image" selector="viewerExtent">viewerExtent
	^self preferenceTable at: #viewerExtent ifAbsent: [nil]</body>

<body package="ChemoJun-Catalog-Image" selector="viewerExtent:">viewerExtent: aPoint 
	self preferenceTable at: #viewerExtent put: aPoint</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id> <category>testing</category>

<body package="ChemoJun-Catalog-Image" selector="is2d">is2d
	^self filename ifNil: [false]
		ifNotNil: 
			[:it | 
			| tailName |
			tailName := (Filename splitPath: it asString) last asString asLowercase.
			(JunStringUtility stringMatch: tailName and: '*2d.mol') yourself]</body>

<body package="ChemoJun-Catalog-Image" selector="is3d">is3d
	^self is2d not</body>

<body package="ChemoJun-Catalog-Image" selector="isVoid">isVoid
	^false</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunImageCatalogElement</class-id> <category>private</category>

<body package="ChemoJun-Catalog-Image" selector="baseNameString">baseNameString
	^(Filename 
		splitExtension: (Filename splitPath: self filename asString) last asString) 
			first asString</body>

<body package="ChemoJun-Catalog-Image" selector="computeMappingPoints:">computeMappingPoints: moleculeViewer 
	| atomObjects atomicPoints |
	atomObjects := moleculeViewer moleculeObject atomObjects asArray.
	atomicPoints := atomObjects 
				collect: [:atomObject | atomObject atomicPoint].
	mappingPoints := moleculeViewer 
				convertModelPointsToViewPoints: atomicPoints
				in: (Point zero extent: self extent).
	^mappingPoints</body>

<body package="ChemoJun-Catalog-Image" selector="decoratedImage:">decoratedImage: anImage 
	| decoratedImage thumbnailExtent |
	decoratedImage := anImage.
	thumbnailExtent := self extent.
	decoratedImage extent = thumbnailExtent 
		ifFalse: 
			[decoratedImage := JunImageAdjuster 
						adjustImage: decoratedImage
						extent: thumbnailExtent
						keepAspect: true
						alignmentSymbol: #center].
	^decoratedImage</body>

<body package="ChemoJun-Catalog-Image" selector="fromPreferences:">fromPreferences: moleculeViewer 
	self moleculePresentation: moleculeViewer messageSymbol.
	self viewerExtent: (moleculeViewer getWindow 
				ifNil: [self class defaultCatalogClass defaultViewerExtent]
				ifNotNil: [:aWindow | aWindow displayBox extent]).
	self projectionTable: moleculeViewer projectionTable.
	self exceptHydrogen: moleculeViewer exceptHydrogen.
	self exceptIndex: moleculeViewer exceptIndex.
	self atomResolution: moleculeViewer moleculeObject atomResolution.
	self serialNumberSetting: moleculeViewer serialNumberSetting setting</body>

<body package="ChemoJun-Catalog-Image" selector="moleculeFilename">moleculeFilename
	^moleculeFilename</body>

<body package="ChemoJun-Catalog-Image" selector="moleculeFilename:">moleculeFilename: aString 
	moleculeFilename := aString</body>

<body package="ChemoJun-Catalog-Image" selector="toPreferences:">toPreferences: moleculeViewer 
	| tailName |
	tailName := (Filename 
				splitPath: moleculeViewer moleculeObject fileName asString) last 
				asString.
	(JunStringUtility stringMatch: tailName asLowercase and: '*2d.mol') 
		ifTrue: [moleculeViewer messageSymbol: #moleculeAsPlane]
		ifFalse: 
			[moleculeViewer messageSymbol: (self moleculePresentation 
						ifNil: [self class defaultMoleculePresentation]
						ifNotNil: [:it | it yourself])].
	self exceptHydrogen ifNil: [moleculeViewer exceptHydrogen: false]
		ifNotNil: [:it | moleculeViewer exceptHydrogen: it].
	self exceptIndex ifNil: [moleculeViewer exceptIndex: true]
		ifNotNil: [:it | moleculeViewer exceptIndex: it].
	self atomResolution 
		ifNil: [moleculeViewer moleculeObject atomResolution: #medium]
		ifNotNil: [:it | moleculeViewer moleculeObject atomResolution: it].
	self serialNumberSetting 
		ifNil: [moleculeViewer serialNumberSetting setting]
		ifNotNil: [:it | moleculeViewer serialNumberSetting setting: it].
	self projectionTable ifNil: [moleculeViewer resetView]
		ifNotNil: 
			[:it | 
			moleculeViewer
				defaultProjectionTable: it;
				projectionTable: it]</body>
</methods>


</st-source>
