<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76985 "21:23:05"))'</do-it>



<class>
<name>ChemoJunMolFileWriter</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunAbstractFileWriter</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>moleculeObject atomList connectionList </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-File-IO</category>
<attributes>
<package>ChemoJun-File-IO</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunMolFileWriter class</class-id> <category>instance creation</category>

<body package="ChemoJun-File-IO" selector="moleculeObject:">moleculeObject: moleculeObject 
	^(self new)
		moleculeObject: moleculeObject;
		yourself</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileWriter class</class-id> <category>copyright</category>

<body package="ChemoJun-File-IO" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-File-IO" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-File-IO" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileWriter class</class-id> <category>defaults</category>

<body package="ChemoJun-File-IO" selector="defaultFileDescriptions">defaultFileDescriptions
	^Array with: (Array 
				with: (#chemoJun_Molecular_structure_files &gt;&gt; 'Molecular structure files') 
						asString)
		with: (Array with: (#jun_All_files &gt;&gt; 'All files') asString)</body>

<body package="ChemoJun-File-IO" selector="defaultFilePatterns">defaultFilePatterns
	^Array with: #('*.mol' '*.MOL') with: #('*')</body>

<body package="ChemoJun-File-IO" selector="defaultRequestMessageString">defaultRequestMessageString
	^(#chemoJun_Input_a_molecular_file_ &gt;&gt; 'Input a molecular file.') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileWriter class</class-id> <category>examples</category>

<body package="ChemoJun-File-IO" selector="example1">example1
	"ChemoJunMolFileWriter example1."

	| aReader moleculeObject aWriter |
	aReader := ChemoJunMolFileReader request.
	aReader isNil ifTrue: [^nil].
	moleculeObject := ChemoJunMoleculeObject fromReader: aReader.
	aWriter := ChemoJunMolFileWriter 
				requestInitialFileName: moleculeObject baseName , '_' 
						, JunSystem defaultBaseName , moleculeObject extension.
	aWriter isNil ifTrue: [^nil].
	aWriter moleculeObject: moleculeObject.
	aWriter write.
	^aWriter</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunMolFileWriter</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunMolFileWriter</class-id> <category>initialize-release</category>

<body package="ChemoJun-File-IO" selector="initialize">initialize
	super initialize.
	moleculeObject := nil.
	atomList := nil.
	connectionList := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileWriter</class-id> <category>accessing</category>

<body package="ChemoJun-File-IO" selector="atomList">atomList
	atomList isNil 
		ifTrue: 
			[| aCollection |
			aCollection := SortedCollection new: self numberOfAtoms.
			self moleculeObject atomObjectsDo: 
					[:atomObject | 
					aCollection 
						add: (atomObject perform: self defaultSymbolOfSerialNumber) -&gt; atomObject].
			atomList := aCollection asArray collect: [:assoc | assoc value]].
	^atomList</body>

<body package="ChemoJun-File-IO" selector="connectionList">connectionList
	connectionList isNil 
		ifTrue: 
			[| aCollection atomObject |
			aCollection := SortedCollection new: self numberOfConnections.
			self moleculeObject atomConnections do: 
					[:atomConnection | 
					atomObject := atomConnection fromAtom.
					aCollection 
						add: (atomObject attributeTable at: self defaultSymbolOfSerialNumber) 
								-&gt; atomConnection].
			connectionList := aCollection asArray collect: [:assoc | assoc value]].
	^connectionList</body>

<body package="ChemoJun-File-IO" selector="indexOf:">indexOf: theAtomObject 
	self atomList with: (1 to: self atomList size)
		do: [:atomObject :anIndex | atomObject = theAtomObject ifTrue: [^anIndex]].
	^0</body>

<body package="ChemoJun-File-IO" selector="moleculeObject">moleculeObject
	^moleculeObject</body>

<body package="ChemoJun-File-IO" selector="moleculeObject:">moleculeObject: aMolecule 
	moleculeObject := aMolecule.
	atomList := nil.
	connectionList := nil</body>

<body package="ChemoJun-File-IO" selector="numberOfAtoms">numberOfAtoms
	^self moleculeObject ifNil: [0] ifNotNil: [:it | it numberOfAtoms]</body>

<body package="ChemoJun-File-IO" selector="numberOfConnections">numberOfConnections
	^self moleculeObject ifNil: [0] ifNotNil: [:it | it numberOfConnections]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileWriter</class-id> <category>defaults</category>

<body package="ChemoJun-File-IO" selector="defaultSymbolOfSerialNumber">defaultSymbolOfSerialNumber
	^#serialNumber</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMolFileWriter</class-id> <category>writing</category>

<body package="ChemoJun-File-IO" selector="writeAtomBlockOn:">writeAtomBlockOn: aStream 
	self atomList do: 
			[:atomObject | 
			aStream nextPutAll: (self format: 'f10.4' value: atomObject atomicPoint x).
			aStream nextPutAll: (self format: 'f10.4' value: atomObject atomicPoint y).
			aStream nextPutAll: (self format: 'f10.4' value: atomObject atomicPoint z).
			aStream nextPutAll: (self format: 'x1' value: nil).
			aStream nextPutAll: (self format: 'a3' value: atomObject atomicSymbol).
			aStream nextPutAll: (self format: 'i2' value: 0).
			11 timesRepeat: [aStream nextPutAll: (self format: 'i3' value: 0)].
			aStream cr]</body>

<body package="ChemoJun-File-IO" selector="writeBondBlockOn:">writeBondBlockOn: aStream 
	self connectionList do: 
			[:atomConnection | 
			aStream nextPutAll: (self format: 'i3'
						value: (self indexOf: atomConnection fromAtom)).
			aStream 
				nextPutAll: (self format: 'i3' value: (self indexOf: atomConnection toAtom)).
			aStream nextPutAll: (self format: 'i3' value: atomConnection bondType).
			aStream nextPutAll: (self format: 'i3' value: atomConnection stereoType).
			3 timesRepeat: [aStream nextPutAll: (self format: 'i3' value: 0)].
			aStream cr]</body>

<body package="ChemoJun-File-IO" selector="writeCountsLineOn:">writeCountsLineOn: aStream 
	aStream nextPutAll: (self format: 'i3' value: self numberOfAtoms).
	aStream nextPutAll: (self format: 'i3' value: self numberOfConnections).
	8 timesRepeat: [aStream nextPutAll: (self format: 'i3' value: 0)].
	aStream nextPutAll: (self format: 'i3' value: 1).
	aStream nextPutAll: (self format: 'x1' value: nil).
	aStream nextPutAll: (self format: 'a5' value: 'V2000').
	aStream cr</body>

<body package="ChemoJun-File-IO" selector="writeHeaderBlockOn:">writeHeaderBlockOn: aStream 
	| firstBlock secondBlock thirdBlock |
	firstBlock := 
			[aStream nextPutAll: '  - ' , self baseName , ' -  '.
			aStream cr].
	secondBlock := 
			[| aString |
			aStream nextPutAll: (self format: 'a2' value: '  ').
			aStream nextPutAll: (self format: 'a8' value: 'ChemoJun').
			aString := Date today monthIndex printString.
			2 - aString size timesRepeat: [aString := '0' , aString].
			aStream nextPutAll: (self format: 'a2' value: aString).
			aString := Date today dayOfMonth printString.
			2 - aString size timesRepeat: [aString := '0' , aString].
			aStream nextPutAll: (self format: 'a2' value: aString).
			aString := Date today year printString.
			aString := aString copyFrom: aString size - 1 to: aString size.
			aStream nextPutAll: (self format: 'a2' value: aString).
			aString := Time now hours printString.
			2 - aString size timesRepeat: [aString := '0' , aString].
			aStream nextPutAll: (self format: 'a2' value: aString).
			aString := Time now minutes printString.
			2 - aString size timesRepeat: [aString := '0' , aString].
			aStream nextPutAll: (self format: 'a2' value: aString).
			self moleculeObject is2d 
				ifTrue: [aStream nextPutAll: (self format: 'a2' value: '2D')]
				ifFalse: [aStream nextPutAll: (self format: 'a2' value: '3D')].
			aStream nextPutAll: (self format: 'i2' value: 1).
			aStream nextPutAll: (self format: 'f10.5' value: 1).
			aStream nextPutAll: (self format: 'f12.5' value: 0).
			aStream nextPutAll: (self format: 'i6' value: 0).
			aStream cr].
	thirdBlock := 
			[aStream
				space;
				space.
			aStream nextPutAll: 'This molfile was created by '.
			aStream nextPutAll: ChemoJunSystem system.
			aStream nextPutAll: ChemoJunSystem version.
			aStream nextPutAll: ' at '.
			aStream nextPutAll: JunCalendarModel stringFromDateAndTime.
			aStream cr].
	firstBlock value.
	secondBlock value.
	thirdBlock value</body>

<body package="ChemoJun-File-IO" selector="writeOn:">writeOn: aStream 
	self writeHeaderBlockOn: aStream.
	self writeCountsLineOn: aStream.
	self writeAtomBlockOn: aStream.
	self writeBondBlockOn: aStream.
	self writePropertiesBlockOn: aStream</body>

<body package="ChemoJun-File-IO" selector="writePropertiesBlockOn:">writePropertiesBlockOn: aStream 
	aStream nextPutAll: 'M  END'.
	aStream cr</body>
</methods>


</st-source>
