<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76985 "21:23:05"))'</do-it>



<class>
<name>ChemoJunMoleculeObject</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunAbstractObject</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>atomObjects atomConnections atomResolution exceptHydrogen attributeTable </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Basic-Objects</category>
<attributes>
<package>ChemoJun-Basic-Objects</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject class</class-id> <category>instance creation</category>

<body package="ChemoJun-Basic-Objects" selector="fileName:">fileName: aFilename 
	^self fromReader: (self defaultMolFileReaderClass fileName: aFilename)</body>

<body package="ChemoJun-Basic-Objects" selector="fromReader:">fromReader: aReader 
	^self moleculeObjectFromReader: aReader</body>

<body package="ChemoJun-Basic-Objects" selector="fromString:">fromString: aString 
	| aReader |
	self 
		assert: [aString readStream]
		do: 
			[:aStream | 
			aReader := self defaultMolFileReaderClass new.
			aReader readFrom: aStream]
		ensure: [:aStream | aStream close].
	^aReader moleculeObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject class</class-id> <category>copyright</category>

<body package="ChemoJun-Basic-Objects" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Basic-Objects" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Basic-Objects" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject class</class-id> <category>defaults</category>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomConnectionClass">defaultAtomConnectionClass
	^ChemoJunAtomConnection</body>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomObjectClass">defaultAtomObjectClass
	^ChemoJunAtomObject</body>

<body package="ChemoJun-Basic-Objects" selector="defaultExceptHydrogen">defaultExceptHydrogen
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="defaultGraphClass">defaultGraphClass
	^ChemoJunGraph</body>

<body package="ChemoJun-Basic-Objects" selector="defaultGrapherClass">defaultGrapherClass
	^ChemoJunGrapher</body>

<body package="ChemoJun-Basic-Objects" selector="defaultMolFileReaderClass">defaultMolFileReaderClass
	^ChemoJunMolFileReader</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject class</class-id> <category>examples</category>

<body package="ChemoJun-Basic-Objects" selector="example1">example1
	"ChemoJunMoleculeObject example1."

	| moleculeObject |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	^moleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="example2">example2
	"ChemoJunMoleculeObject example2."

	| moleculeObject |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	ChemoJunAbstractViewer show: moleculeObject moleculeAsStick.
	^moleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="example3">example3
	"ChemoJunMoleculeObject example3."

	| moleculeObject |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	moleculeObject exceptHydrogen: true.
	ChemoJunAbstractViewer show: moleculeObject moleculeAsStick.
	^moleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="example4">example4
	"ChemoJunMoleculeObject example4."

	| moleculeObject |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	ChemoJunAbstractViewer show: moleculeObject moleculeAsSpaceFill.
	^moleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="example5">example5
	"ChemoJunMoleculeObject example5."

	| moleculeObject |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	ChemoJunAbstractViewer show: moleculeObject moleculeAsStickAndSpaceFill.
	^moleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="example6">example6
	"ChemoJunMoleculeObject example6."

	| moleculeObject molecule3dObject offsetValue offset3dObject compoundObject |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	molecule3dObject := moleculeObject moleculeAsSpaceFill.
	offsetValue := 1.	"Angstrom"
	offset3dObject := moleculeObject 
				moleculeAsSpaceFill: moleculeObject defaultSpaceFillDivisionNumber
				offsetValue: offsetValue.
	offset3dObject polygonsDo: 
			[:aPolygon | 
			aPolygon paint: ColorValue lightGray.
			aPolygon halftone: moleculeObject defaultHalftoneValue].
	compoundObject := JunOpenGL3dCompoundObject new.
	compoundObject add: molecule3dObject.
	compoundObject add: offset3dObject.
	ChemoJunAbstractViewer show: compoundObject.
	^moleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="example7">example7
	"ChemoJunMoleculeObject example7."

	| moleculeObject molecule3dObject offsetValue offset3dObject compoundObject |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	molecule3dObject := moleculeObject moleculeAsStickAndSpaceFill.
	offsetValue := 1.	"Angstrom"
	offset3dObject := moleculeObject 
				moleculeAsSpaceFill: moleculeObject defaultSpaceFillDivisionNumber
				offsetValue: offsetValue.
	offset3dObject polygonsDo: 
			[:aPolygon | 
			aPolygon paint: ColorValue lightGray.
			aPolygon halftone: moleculeObject defaultHalftoneValue / 2].
	compoundObject := JunOpenGL3dCompoundObject new.
	compoundObject add: molecule3dObject.
	compoundObject add: offset3dObject.
	ChemoJunAbstractViewer show: compoundObject.
	^moleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="example8">example8
	"ChemoJunMoleculeObject example8."

	| firstMoleculeObject secondMoleculeObject firstMolecule3dObject secondMolecule3dObject compoundObject |
	firstMoleculeObject := ChemoJunMoleculeObject request.
	firstMoleculeObject isNil ifTrue: [^nil].
	secondMoleculeObject := ChemoJunMoleculeObject request.
	secondMoleculeObject isNil ifTrue: [^nil].
	firstMolecule3dObject := firstMoleculeObject moleculeAsSpaceFill.
	secondMolecule3dObject := secondMoleculeObject moleculeAsSpaceFill 
				translatedBy: 0 , 10 , 0.
	compoundObject := JunOpenGL3dCompoundObject new.
	compoundObject add: firstMolecule3dObject.
	compoundObject add: secondMolecule3dObject.
	ChemoJunAbstractViewer show: compoundObject.
	^Array with: firstMoleculeObject with: secondMoleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="example9">example9
	"ChemoJunMoleculeObject example9."

	| firstMoleculeObject secondMoleculeObject firstMolecule3dObject secondMolecule3dObject offsetValue firstOffset3dObject secondOffset3dObject compoundObject |
	firstMoleculeObject := ChemoJunMoleculeObject request.
	firstMoleculeObject isNil ifTrue: [^nil].
	secondMoleculeObject := ChemoJunMoleculeObject request.
	secondMoleculeObject isNil ifTrue: [^nil].
	firstMolecule3dObject := firstMoleculeObject moleculeAsSpaceFill.
	secondMolecule3dObject := secondMoleculeObject moleculeAsSpaceFill 
				translatedBy: 0 , 10 , 0.
	offsetValue := 1.	"Angstrom"
	firstOffset3dObject := firstMoleculeObject 
				moleculeAsSpaceFill: firstMoleculeObject 
						defaultSpaceFillDivisionNumber
				offsetValue: offsetValue.
	firstOffset3dObject polygonsDo: 
			[:aPolygon | 
			aPolygon paint: ColorValue lightGray.
			aPolygon halftone: firstMoleculeObject defaultHalftoneValue].
	secondOffset3dObject := (secondMoleculeObject 
				moleculeAsSpaceFill: secondMoleculeObject 
						defaultSpaceFillDivisionNumber
				offsetValue: offsetValue) translatedBy: 0 , 10 , 0.
	secondOffset3dObject polygonsDo: 
			[:aPolygon | 
			aPolygon paint: ColorValue lightGray.
			aPolygon halftone: secondMoleculeObject defaultHalftoneValue].
	compoundObject := JunOpenGL3dCompoundObject new.
	compoundObject add: firstMolecule3dObject.
	compoundObject add: secondMolecule3dObject.
	compoundObject add: firstOffset3dObject.
	compoundObject add: secondOffset3dObject.
	ChemoJunAbstractViewer show: compoundObject.
	^Array with: firstMoleculeObject with: secondMoleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="exampleA">exampleA
	"ChemoJunMoleculeObject exampleA."

	| moleculeObject moleculeViewer |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	moleculeViewer := ChemoJunMoleculeViewer moleculeObject: moleculeObject.
	moleculeViewer openAt: 100 @ 250.
	^moleculeObject</body>

<body package="ChemoJun-Basic-Objects" selector="exampleB">exampleB
	"ChemoJunMoleculeObject exampleB."

	| moleculeObject moleculeViewer messageSelectors |
	moleculeObject := ChemoJunMoleculeObject request.
	moleculeObject isNil ifTrue: [^nil].
	moleculeViewer := ChemoJunMoleculeViewer moleculeObject: moleculeObject.
	moleculeViewer indexExpression: '[:index | true]'.
	moleculeViewer openAt: 100 @ 250.
	messageSelectors := #(#isMethyl: #isHydroxyl: #isCarboxyl: #isCarbonyl: #isAldehyde: #hasHydroxyl:).
	Transcript clear.
	Transcript
		show: 'Serial';
		tab.
	messageSelectors do: [:each | Transcript show: each asString]
		separatedBy: [Transcript tab].
	Transcript cr.
	moleculeObject atomObjectsDo: 
			[:atomObject | 
			Transcript show: atomObject serialNumber printString.
			Transcript tab.
			messageSelectors do: 
					[:each | 
					Transcript 
						show: (moleculeObject perform: each with: atomObject) printString]
				separatedBy: [Transcript tab].
			Transcript cr].
	^moleculeObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject class</class-id> <category>utilities</category>

<body package="ChemoJun-Basic-Objects" selector="request">request
	"ChemoJunMoleculeObject request."

	| aReader moleculeObject |
	aReader := self defaultMolFileReaderClass request.
	aReader isNil ifTrue: [^nil].
	moleculeObject := self moleculeObjectFromReader: aReader.
	^moleculeObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject class</class-id> <category>private</category>

<body package="ChemoJun-Basic-Objects" selector="moleculeObjectFromReader:">moleculeObjectFromReader: aReader 
	| atomObjects atomConnections moleculeObject |
	self 
		assert: [(Array new: aReader numberOfAtoms) writeStream]
		do: 
			[:aStream | 
			| atomObject |
			1 to: aReader numberOfAtoms
				do: 
					[:index | 
					| atom |
					atom := aReader atomList at: index.
					atomObject := self defaultAtomObjectClass atomicSymbol: atom first
								atomicPoint: atom last.
					atomObject serialNumber: index.
					aStream nextPut: atomObject].
			atomObjects := aStream contents]
		ensure: [:aStream | aStream close].
	self 
		assert: [(Array new: aReader numberOfConnections) writeStream]
		do: 
			[:aStream | 
			| fromAtom toAtom bondType stereoType atomConnection |
			1 to: aReader numberOfConnections
				do: 
					[:index | 
					| connection |
					connection := aReader connectionList at: index.
					fromAtom := atomObjects at: (connection at: 1).
					toAtom := atomObjects at: (connection at: 2).
					connection size &gt;= 3 
						ifTrue: 
							[bondType := connection at: 3.
							connection size &gt;= 4 
								ifTrue: 
									[stereoType := connection at: 4.
									atomConnection := self defaultAtomConnectionClass 
												fromAtom: fromAtom
												toAtom: toAtom
												bondType: bondType
												stereoType: stereoType]
								ifFalse: 
									[atomConnection := self defaultAtomConnectionClass 
												fromAtom: fromAtom
												toAtom: toAtom
												bondType: bondType]]
						ifFalse: 
							[atomConnection := self defaultAtomConnectionClass fromAtom: fromAtom
										toAtom: toAtom].
					aStream nextPut: atomConnection].
			atomConnections := aStream contents]
		ensure: [:aStream | aStream close].
	moleculeObject := self new.
	moleculeObject fileName: aReader fileName.
	moleculeObject atomObjects: atomObjects.
	moleculeObject atomConnections: atomConnections.
	moleculeObject molfileHeaderBlock: aReader commentList.
	^moleculeObject</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>initialize-release</category>

<body package="ChemoJun-Basic-Objects" selector="initialize">initialize
	super initialize.
	atomObjects := nil.
	atomConnections := nil.
	atomResolution := nil.
	exceptHydrogen := self class defaultExceptHydrogen.
	attributeTable := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>3d accessing</category>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsBallAndStick">moleculeAsBallAndStick
	self atomResolution = #low 
		ifTrue: [^self moleculeAsBallAndStick: self defaultTubeDivisionNumberLow].
	self atomResolution = #medium 
		ifTrue: 
			[^self moleculeAsBallAndStick: self defaultTubeDivisionNumberMedium].
	self atomResolution = #high 
		ifTrue: [^self moleculeAsBallAndStick: self defaultTubeDivisionNumberHigh].
	^self moleculeAsBallAndStick: self defaultTubeDivisionNumber</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsBallAndStick:">moleculeAsBallAndStick: divisionNumber 
	| aBall compoundObject |
	aBall := self basicMoleculeBall: divisionNumber.
	compoundObject := self basicMoleculeAsStick: divisionNumber.
	self atomObjectsDo: 
			[:atomObject | 
			(atomObject isHydrogen and: [self exceptHydrogen]) 
				ifFalse: 
					[| centerPoint radiusValue colorValue aTransformation aSphere |
					centerPoint := atomObject atomicPoint.
					radiusValue := atomObject atomicRadius * (1 / 8).
					colorValue := atomObject atomicColor blendWith: ColorValue white.
					aTransformation := (Jun3dTransformation 
								scale: radiusValue , radiusValue , radiusValue) 
									product: (Jun3dTransformation translate: centerPoint).
					aSphere := aBall transform: aTransformation.
					aSphere polygonsDo: 
							[:polygon | 
							polygon normalVectors: (polygon vertexes 
										collect: [:p | (centerPoint to: p) normalUnitVector])].
					aSphere paint: colorValue.
					compoundObject add: aSphere]].
	^compoundObject</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsPlane">moleculeAsPlane
	| compoundObject bondTypeSymbol firstPolylines secondPolylines thirdPolylines stereoTypeSymbol |
	compoundObject := JunOpenGL3dCompoundObject new.
	self atomConnections do: 
			[:atomConnection | 
			bondTypeSymbol := atomConnection bondTypeSymbol.
			(bondTypeSymbol = #single or: [bondTypeSymbol = #any]) 
				ifTrue: 
					[| anArray |
					anArray := self arrayOfPolylinesForSingleBondAsPlane: atomConnection.
					firstPolylines := anArray at: 1].
			bondTypeSymbol = #double 
				ifTrue: 
					[| anArray |
					anArray := self arrayOfPolylinesForDoubleBondAsPlane: atomConnection.
					firstPolylines := anArray at: 1.
					secondPolylines := anArray at: 2].
			bondTypeSymbol = #triple 
				ifTrue: 
					[| anArray |
					anArray := self arrayOfPolylinesForTripleBondAsPlane: atomConnection.
					firstPolylines := anArray at: 1.
					secondPolylines := anArray at: 2.
					thirdPolylines := anArray at: 3].
			(#(#aromatic #singleORdouble #singleORaromatic #doubeORaromatic) 
				includes: bondTypeSymbol) 
					ifTrue: 
						[| anArray |
						anArray := self arrayOfPolylinesForAromaticBondAsPlane: atomConnection.
						firstPolylines := anArray at: 1.
						secondPolylines := anArray at: 2].
			stereoTypeSymbol := atomConnection stereoTypeSymbol.
			(stereoTypeSymbol = #up or: [stereoTypeSymbol = #down]) 
				ifTrue: 
					[(stereoTypeSymbol = #up or: [stereoTypeSymbol = #down]) 
						ifTrue: 
							[firstPolylines do: [:each | each lineWidth: 4].
							stereoTypeSymbol = #down 
								ifTrue: [firstPolylines do: [:each | each halftone: 0.25]]]].
			((atomConnection fromAtom isHydrogen 
				or: [atomConnection toAtom isHydrogen]) and: [self exceptHydrogen]) 
				ifFalse: 
					[compoundObject addAll: firstPolylines.
					bondTypeSymbol = #double ifTrue: [compoundObject addAll: secondPolylines].
					bondTypeSymbol = #triple 
						ifTrue: 
							[compoundObject addAll: secondPolylines.
							compoundObject addAll: thirdPolylines].
					(#(#aromatic #singleORdouble #singleORaromatic #doubeORaromatic) 
						includes: bondTypeSymbol) ifTrue: [compoundObject addAll: secondPolylines]]].
	self isolatedAtoms do: 
			[:atomObject | 
			compoundObject add: ((JunOpenGL3dVertex point: atomObject atomicPoint
						paint: ColorValue black)
						size: 3;
						yourself)].
	^compoundObject</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsSpaceFill">moleculeAsSpaceFill
	^self moleculeAsSpaceFill: self defaultSpaceFillDivisionNumber</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsSpaceFill:">moleculeAsSpaceFill: divisionNumber 
	^self moleculeAsSpaceFill: divisionNumber offsetValue: 0</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsSpaceFill:offsetValue:">moleculeAsSpaceFill: divisionNumber offsetValue: offsetValue 
	^self 
		moleculeAsSpaceFill: divisionNumber
		offsetValue: offsetValue
		smoothShading: true</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsSpaceFill:offsetValue:smoothShading:">moleculeAsSpaceFill: divisionNumber offsetValue: offsetValue smoothShading: aBoolean 
	| aBall areaCoefficient compoundObject |
	aBall := JunOpenGL3dObject ball: divisionNumber.
	areaCoefficient := (Jun3dBoundingBall center: 0 , 0 , 0 radius: 1) area 
				/ aBall area.
	compoundObject := JunOpenGL3dCompoundObject new.
	self atomObjectsDo: 
			[:atomObject | 
			| centerPoint radiusValue colorValue aTransformation aSphere aBody |
			centerPoint := atomObject atomicPoint.
			radiusValue := atomObject atomicRadius + offsetValue.
			colorValue := atomObject atomicColor blendWith: ColorValue white.
			aTransformation := (Jun3dTransformation 
						scale: radiusValue , radiusValue , radiusValue) 
							product: (Jun3dTransformation translate: centerPoint).
			aSphere := aBall transform: aTransformation.
			aBody := JunOpenGL3dCompoundObject new.
			aSphere polygonsDo: 
					[:aPolygon | 
					aBoolean 
						ifTrue: 
							[| collectionOfPolygons |
							collectionOfPolygons := self 
										frontierPolygons: aPolygon
										of: atomObject
										offset: offsetValue.
							collectionOfPolygons do: 
									[:each | 
									each colors: (Array new: each vertexes size withAll: colorValue).
									each 
										normalVectors: (each vertexes 
												collect: [:p | (atomObject atomicPoint to: p) normalUnitVector]) asArray].
							aBody addAll: collectionOfPolygons]
						ifFalse: 
							[aPolygon paint: colorValue.
							aBody addAll: (self 
										frontierPolygons: aPolygon
										of: atomObject
										offset: offsetValue)]].
			atomObject atomicBody: aBody.
			atomObject areaCoefficient: areaCoefficient.
			compoundObject add: aBody].
	^compoundObject</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsStick">moleculeAsStick
	self atomResolution = #low 
		ifTrue: [^self moleculeAsStick: self defaultTubeDivisionNumberLow].
	self atomResolution = #medium 
		ifTrue: [^self moleculeAsStick: self defaultTubeDivisionNumberMedium].
	self atomResolution = #high 
		ifTrue: [^self moleculeAsStick: self defaultTubeDivisionNumberHigh].
	^self moleculeAsStick: self defaultTubeDivisionNumber</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsStick:">moleculeAsStick: divisionNumber 
	| compoundObject isolatedAtoms |
	compoundObject := self basicMoleculeAsStick: divisionNumber.
	(isolatedAtoms := self isolatedAtoms) isEmpty 
		ifFalse: 
			[| aBall |
			aBall := self basicMoleculeBall: divisionNumber.
			isolatedAtoms do: 
					[:atomObject | 
					(atomObject isHydrogen and: [self exceptHydrogen]) 
						ifFalse: 
							[| centerPoint radiusValue colorValue aTransformation aSphere |
							centerPoint := atomObject atomicPoint.
							radiusValue := atomObject atomicRadius * (1 / 12).
							colorValue := atomObject atomicColor blendWith: ColorValue white.
							aTransformation := (Jun3dTransformation 
										scale: radiusValue , radiusValue , radiusValue) 
											product: (Jun3dTransformation translate: centerPoint).
							aSphere := aBall transform: aTransformation.
							aSphere polygonsDo: 
									[:polygon | 
									polygon normalVectors: (polygon vertexes 
												collect: [:p | (centerPoint to: p) normalUnitVector])].
							aSphere paint: colorValue.
							compoundObject add: aSphere]]].
	^compoundObject</body>

<body package="ChemoJun-Basic-Objects" selector="moleculeAsStickAndSpaceFill">moleculeAsStickAndSpaceFill
	| molecule3dObject skeleton3dObject |
	molecule3dObject := self moleculeAsSpaceFill.
	molecule3dObject polygonsDo: [:polygon | polygon halftone: self defaultHalftoneValue].
	skeleton3dObject := self basicMoleculeAsStick.
	skeleton3dObject components do: [:each | molecule3dObject add: each].
	^molecule3dObject</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>3d aux</category>

<body package="ChemoJun-Basic-Objects" selector="arrayOfPolylinesForAromaticBondAsPlane:">arrayOfPolylinesForAromaticBondAsPlane: atomConnection 
	| fromAtom toAtom fromPoint toPoint centerPoint firstPolylines aLine offsetPoint secondPolylines aPlane connectedAtoms positiveAtoms negativeAtoms |
	(#(#aromatic #singleORdouble #singleORaromatic #doubeORaromatic) 
		includes: atomConnection bondTypeSymbol) 
			ifFalse: [^self error: 'connection is not aromatic bond.'].
	fromAtom := atomConnection fromAtom.
	toAtom := atomConnection toAtom.
	fromPoint := fromAtom atomicPoint.
	toPoint := toAtom atomicPoint.
	centerPoint := fromPoint center: toPoint.
	firstPolylines := Array with: (JunOpenGL3dPolyline 
						vertexes: (Array with: fromPoint with: centerPoint))
				with: (JunOpenGL3dPolyline 
						vertexes: (Array with: centerPoint with: toPoint)).
	atomConnection hasConnectionColor 
		ifTrue: 
			[firstPolylines first paint: atomConnection connectionColor.
			firstPolylines last paint: atomConnection connectionColor]
		ifFalse: 
			[fromAtom hasAtomicColor 
				ifTrue: [firstPolylines first paint: fromAtom atomicColor]
				ifFalse: [firstPolylines first paint: atomConnection defaultConnectionColor].
			toAtom hasAtomicColor 
				ifTrue: [firstPolylines last paint: toAtom atomicColor]
				ifFalse: [firstPolylines last paint: atomConnection defaultConnectionColor]].
	firstPolylines first lineWidth: 2.
	firstPolylines last lineWidth: 2.
	aLine := (fromPoint as2dPoint bisector: toPoint as2dPoint) normalized.
	offsetPoint := ((aLine atT: 0.075) - (aLine atT: 0)) as3dPoint.
	secondPolylines := firstPolylines collect: 
					[:each | 
					| polyline from to line |
					polyline := each copy.
					from := polyline vertexes first.
					to := polyline vertexes last.
					line := from to: to.
					from = centerPoint ifFalse: [from := line atT: 0.12].
					to = centerPoint ifFalse: [to := line atT: 0.88].
					polyline vertexes: (Array with: from with: to).
					polyline yourself].
	aPlane := fromPoint plane: toPoint and: fromPoint x , fromPoint y , 1.
	connectedAtoms := self connectedAromaticAtomsAround: atomConnection.
	positiveAtoms := connectedAtoms 
				select: [:atom | (atom atomicPoint whichSideOf: aPlane) &gt;= 0].
	negativeAtoms := connectedAtoms 
				select: [:atom | (atom atomicPoint whichSideOf: aPlane) &lt; 0].
	secondPolylines := secondPolylines collect: 
					[:each | 
					| polyline |
					positiveAtoms size &gt;= negativeAtoms size 
						ifTrue: [polyline := each translatedBy: (offsetPoint * 2) negated]
						ifFalse: [polyline := each translatedBy: (offsetPoint * 2) yourself].
					polyline yourself].
	secondPolylines do: [:each | each halftone: 0.25].
	^Array with: firstPolylines with: secondPolylines</body>

<body package="ChemoJun-Basic-Objects" selector="arrayOfPolylinesForDoubleBondAsPlane:">arrayOfPolylinesForDoubleBondAsPlane: atomConnection 
	| fromAtom toAtom fromPoint toPoint centerPoint firstPolylines secondPolylines aLine offsetPoint |
	atomConnection bondTypeSymbol = #double 
		ifFalse: [^self error: 'connection is not double bond.'].
	fromAtom := atomConnection fromAtom.
	toAtom := atomConnection toAtom.
	fromPoint := fromAtom atomicPoint.
	toPoint := toAtom atomicPoint.
	centerPoint := fromPoint center: toPoint.
	firstPolylines := Array with: (JunOpenGL3dPolyline 
						vertexes: (Array with: fromPoint with: centerPoint))
				with: (JunOpenGL3dPolyline 
						vertexes: (Array with: centerPoint with: toPoint)).
	atomConnection hasConnectionColor 
		ifTrue: 
			[firstPolylines first paint: atomConnection connectionColor.
			firstPolylines last paint: atomConnection connectionColor]
		ifFalse: 
			[fromAtom hasAtomicColor 
				ifTrue: [firstPolylines first paint: fromAtom atomicColor]
				ifFalse: [firstPolylines first paint: atomConnection defaultConnectionColor].
			toAtom hasAtomicColor 
				ifTrue: [firstPolylines last paint: toAtom atomicColor]
				ifFalse: [firstPolylines last paint: atomConnection defaultConnectionColor]].
	firstPolylines first lineWidth: 2.
	firstPolylines last lineWidth: 2.
	secondPolylines := firstPolylines collect: [:each | each copy].
	aLine := (fromPoint as2dPoint bisector: toPoint as2dPoint) normalized.
	offsetPoint := ((aLine atT: 0.075) - (aLine atT: 0)) as3dPoint.
	(fromPoint z isZero not or: [toPoint z isZero not]) 
		ifTrue: 
			[firstPolylines := firstPolylines 
						collect: [:each | each translatedBy: offsetPoint negated].
			secondPolylines := secondPolylines 
						collect: [:each | each translatedBy: offsetPoint yourself].
			^Array with: firstPolylines with: secondPolylines].
	firstPolylines := firstPolylines collect: 
					[:each | 
					| aPolyline |
					aPolyline := each translatedBy: offsetPoint negated.
					each vertexes first = fromPoint 
						ifTrue: 
							[self modifiedFromPolyline: aPolyline forDoubleBondAsPlane: atomConnection].
					each vertexes last = toPoint 
						ifTrue: 
							[self modifiedToPolyline: aPolyline forDoubleBondAsPlane: atomConnection].
					aPolyline yourself].
	secondPolylines := secondPolylines collect: 
					[:each | 
					| aPolyline |
					aPolyline := each translatedBy: offsetPoint yourself.
					each vertexes first = fromPoint 
						ifTrue: 
							[self modifiedFromPolyline: aPolyline forDoubleBondAsPlane: atomConnection].
					each vertexes last = toPoint 
						ifTrue: 
							[self modifiedToPolyline: aPolyline forDoubleBondAsPlane: atomConnection].
					aPolyline yourself].
	^Array with: firstPolylines with: secondPolylines</body>

<body package="ChemoJun-Basic-Objects" selector="arrayOfPolylinesForSingleBondAsPlane:">arrayOfPolylinesForSingleBondAsPlane: atomConnection 
	| fromAtom toAtom fromPoint toPoint centerPoint firstPolylines |
	(atomConnection bondTypeSymbol = #single 
		or: [atomConnection bondTypeSymbol = #any]) 
			ifFalse: [^self error: 'connection is not single bond.'].
	fromAtom := atomConnection fromAtom.
	toAtom := atomConnection toAtom.
	fromPoint := fromAtom atomicPoint.
	toPoint := toAtom atomicPoint.
	centerPoint := fromPoint center: toPoint.
	firstPolylines := Array with: (JunOpenGL3dPolyline 
						vertexes: (Array with: fromPoint with: centerPoint))
				with: (JunOpenGL3dPolyline 
						vertexes: (Array with: centerPoint with: toPoint)).
	atomConnection hasConnectionColor 
		ifTrue: 
			[firstPolylines first paint: atomConnection connectionColor.
			firstPolylines last paint: atomConnection connectionColor]
		ifFalse: 
			[fromAtom hasAtomicColor 
				ifTrue: [firstPolylines first paint: fromAtom atomicColor]
				ifFalse: [firstPolylines first paint: atomConnection defaultConnectionColor].
			toAtom hasAtomicColor 
				ifTrue: [firstPolylines last paint: toAtom atomicColor]
				ifFalse: [firstPolylines last paint: atomConnection defaultConnectionColor]].
	firstPolylines first lineWidth: 2.
	firstPolylines last lineWidth: 2.
	^Array with: firstPolylines</body>

<body package="ChemoJun-Basic-Objects" selector="arrayOfPolylinesForTripleBondAsPlane:">arrayOfPolylinesForTripleBondAsPlane: atomConnection 
	| fromAtom toAtom fromPoint toPoint centerPoint firstPolylines secondPolylines thirdPolylines aLine offsetPoint |
	atomConnection bondTypeSymbol = #triple 
		ifFalse: [^self error: 'connection is not triple bond.'].
	fromAtom := atomConnection fromAtom.
	toAtom := atomConnection toAtom.
	fromPoint := fromAtom atomicPoint.
	toPoint := toAtom atomicPoint.
	centerPoint := fromPoint center: toPoint.
	firstPolylines := Array with: (JunOpenGL3dPolyline 
						vertexes: (Array with: fromPoint with: centerPoint))
				with: (JunOpenGL3dPolyline 
						vertexes: (Array with: centerPoint with: toPoint)).
	atomConnection hasConnectionColor 
		ifTrue: 
			[firstPolylines first paint: atomConnection connectionColor.
			firstPolylines last paint: atomConnection connectionColor]
		ifFalse: 
			[fromAtom hasAtomicColor 
				ifTrue: [firstPolylines first paint: fromAtom atomicColor]
				ifFalse: [firstPolylines first paint: atomConnection defaultConnectionColor].
			toAtom hasAtomicColor 
				ifTrue: [firstPolylines last paint: toAtom atomicColor]
				ifFalse: [firstPolylines last paint: atomConnection defaultConnectionColor]].
	firstPolylines first lineWidth: 2.
	firstPolylines last lineWidth: 2.
	secondPolylines := firstPolylines collect: [:each | each copy].
	thirdPolylines := firstPolylines collect: [:each | each copy].
	aLine := (fromPoint as2dPoint bisector: toPoint as2dPoint) normalized.
	offsetPoint := ((aLine atT: 0.075) - (aLine atT: 0)) as3dPoint.
	secondPolylines := secondPolylines 
				collect: [:each | each translatedBy: offsetPoint negated].
	thirdPolylines := thirdPolylines 
				collect: [:each | each translatedBy: offsetPoint yourself].
	^Array 
		with: firstPolylines
		with: secondPolylines
		with: thirdPolylines</body>

<body package="ChemoJun-Basic-Objects" selector="basicMoleculeAsStick">basicMoleculeAsStick
	self atomResolution = #low 
		ifTrue: [^self basicMoleculeAsStick: self defaultTubeDivisionNumberLow].
	self atomResolution = #medium 
		ifTrue: [^self basicMoleculeAsStick: self defaultTubeDivisionNumberMedium].
	self atomResolution = #high 
		ifTrue: [^self basicMoleculeAsStick: self defaultTubeDivisionNumberHigh].
	^self basicMoleculeAsStick: self defaultTubeDivisionNumber</body>

<body package="ChemoJun-Basic-Objects" selector="basicMoleculeAsStick:">basicMoleculeAsStick: divisionNumber 
	| compoundObject |
	compoundObject := JunOpenGL3dCompoundObject new.
	self atomConnections do: 
			[:atomConnection | 
			| aSymbol fromPoint toPoint midPoint aCylinder aColor aPoint |
			aSymbol := atomConnection bondTypeSymbol.
			fromPoint := atomConnection fromAtom atomicPoint.
			toPoint := atomConnection toAtom atomicPoint.
			midPoint := (toPoint - fromPoint) / 2 + fromPoint.
			aCylinder := JunOpenGL3dObject 
						cylinderFrom: fromPoint
						to: midPoint
						radius: self defaultBondThickness / 2
						by: divisionNumber.
			atomConnection hasConnectionColor 
				ifTrue: [aColor := atomConnection connectionColor]
				ifFalse: [aColor := atomConnection fromAtom atomicColor].
			aCylinder polygonsDo: [:aPolygon | aPolygon paint: aColor].
			((atomConnection fromAtom isHydrogen 
				or: [atomConnection toAtom isHydrogen]) and: [self exceptHydrogen]) 
				ifFalse: 
					[(aSymbol = #single or: [aSymbol = #any]) 
						ifTrue: [compoundObject add: aCylinder].
					aSymbol = #double 
						ifTrue: 
							[aPoint := self translationOffsetOf: atomConnection.
							compoundObject add: (aCylinder translatedBy: aPoint).
							compoundObject add: (aCylinder translatedBy: aPoint negated)].
					aSymbol = #triple 
						ifTrue: 
							[aPoint := self translationOffsetOf: atomConnection.
							compoundObject add: (aCylinder translatedBy: aPoint).
							compoundObject add: aCylinder.
							compoundObject add: (aCylinder translatedBy: aPoint negated)].
					(#(#aromatic #singleORdouble #singleORaromatic #doubeORaromatic) 
						includes: aSymbol) 
							ifTrue: 
								[aPoint := self translationOffsetOf: atomConnection.
								compoundObject add: (aCylinder translatedBy: aPoint).
								aCylinder := JunOpenGL3dObject 
											cylinderFrom: fromPoint
											to: midPoint
											radius: self defaultBondThickness / 6
											by: divisionNumber.
								aCylinder polygonsDo: [:aPolygon | aPolygon paint: aColor].
								compoundObject add: (aCylinder translatedBy: aPoint negated)]].
			aCylinder := JunOpenGL3dObject 
						cylinderFrom: midPoint
						to: toPoint
						radius: self defaultBondThickness / 2
						by: divisionNumber.
			atomConnection hasConnectionColor 
				ifTrue: [aColor := atomConnection connectionColor]
				ifFalse: [aColor := atomConnection toAtom atomicColor].
			aCylinder polygonsDo: [:aPolygon | aPolygon paint: aColor].
			((atomConnection toAtom isHydrogen 
				or: [atomConnection fromAtom isHydrogen]) and: [self exceptHydrogen]) 
				ifFalse: 
					[(aSymbol = #single or: [aSymbol = #any]) 
						ifTrue: [compoundObject add: aCylinder].
					aSymbol = #double 
						ifTrue: 
							[aPoint := self translationOffsetOf: atomConnection.
							compoundObject add: (aCylinder translatedBy: aPoint).
							compoundObject add: (aCylinder translatedBy: aPoint negated)].
					aSymbol = #triple 
						ifTrue: 
							[aPoint := self translationOffsetOf: atomConnection.
							compoundObject add: (aCylinder translatedBy: aPoint).
							compoundObject add: aCylinder.
							compoundObject add: (aCylinder translatedBy: aPoint negated)].
					(#(#aromatic #singleORdouble #singleORaromatic #doubeORaromatic) 
						includes: aSymbol) 
							ifTrue: 
								[aPoint := self translationOffsetOf: atomConnection.
								compoundObject add: (aCylinder translatedBy: aPoint).
								aCylinder := JunOpenGL3dObject 
											cylinderFrom: midPoint
											to: toPoint
											radius: self defaultBondThickness / 3
											by: divisionNumber.
								aCylinder polygonsDo: [:aPolygon | aPolygon paint: aColor].
								compoundObject add: (aCylinder translatedBy: aPoint negated)]]].
	^compoundObject</body>

<body package="ChemoJun-Basic-Objects" selector="basicMoleculeBall:">basicMoleculeBall: divisionNumber 
	| aBall |
	aBall := nil.
	divisionNumber = self defaultTubeDivisionNumberLow 
		ifTrue: [aBall := JunOpenGL3dObject ball: self defaultBallDivisionNumberLow].
	divisionNumber = self defaultTubeDivisionNumberMedium 
		ifTrue: 
			[aBall := JunOpenGL3dObject ball: self defaultBallDivisionNumberMedium].
	divisionNumber = self defaultTubeDivisionNumberHigh 
		ifTrue: [aBall := JunOpenGL3dObject ball: self defaultBallDivisionNumberHigh].
	aBall isNil 
		ifTrue: [aBall := JunOpenGL3dObject ball: self defaultBallDivisionNumberLow].
	^aBall</body>

<body package="ChemoJun-Basic-Objects" selector="cylinderFrom:to:width:by:">cylinderFrom: fromPoint to: toPoint width: widthValue by: divisionNumber 
	| aCylinder aRadius fromCircle fromPoints aPolygon toPoints |
	aCylinder := JunOpenGL3dCompoundObject new.
	aRadius := widthValue / 2.
	fromCircle := Jun3dCircle 
				center: fromPoint
				radius: aRadius
				upVector: (toPoint to: fromPoint) normalUnitVector.
	fromPoints := fromCircle trackPointsBy: (360 / divisionNumber) rounded.
	aPolygon := JunOpenGL3dPolygon vertexes: fromPoints.
	aPolygon paint: ColorValue red.
	aCylinder add: aPolygon.
	toPoints := fromPoints collect: [:p | p translatedBy: toPoint - fromPoint].
	aPolygon := JunOpenGL3dPolygon vertexes: toPoints reverse.
	aPolygon paint: ColorValue red.
	aCylinder add: aPolygon.
	(1 to: fromPoints size - 1) with: (1 to: toPoints size - 1)
		do: 
			[:i :j | 
			| p1 p2 p3 p4 points vectors |
			p1 := fromPoints at: i.
			p2 := fromPoints at: i + 1.
			p3 := toPoints at: j.
			p4 := toPoints at: j + 1.
			points := Array 
						with: p1
						with: p3
						with: p4
						with: p2.
			vectors := Array 
						with: (fromPoint to: p1) normalUnitVector
						with: (toPoint to: p3) normalUnitVector
						with: (toPoint to: p4) normalUnitVector
						with: (fromPoint to: p2) normalUnitVector.
			aPolygon := JunOpenGL3dPolygon vertexes: points.
			aPolygon normalVectors: vectors.
			aPolygon paint: ColorValue red.
			aCylinder add: aPolygon].
	^aCylinder</body>

<body package="ChemoJun-Basic-Objects" selector="modifiedFromPolyline:forDoubleBondAsPlane:">modifiedFromPolyline: aPolyline forDoubleBondAsPlane: atomConnection 
	| fromAtom toAtom fromPoint toPoint fromConnections aPlane from to |
	fromAtom := atomConnection fromAtom.
	toAtom := atomConnection toAtom.
	fromPoint := fromAtom atomicPoint.
	toPoint := toAtom atomicPoint.
	fromConnections := (self connectionsWith: fromAtom) 
				reject: [:each | each = atomConnection].
	aPlane := fromPoint plane: toPoint and: fromPoint x , fromPoint y , 1.
	from := aPolyline vertexes first.
	to := aPolyline vertexes last.
	fromConnections isEmpty 
		ifTrue: 
			[| line |
			line := from to: to.
			from := line atT: 0.12.
			aPolyline vertexes: (Array with: from with: to)]
		ifFalse: 
			[| sign connections |
			sign := from whichSideOf: aPlane.
			connections := fromConnections select: 
							[:connection | 
							| target |
							target := connection toAtom.
							target = fromAtom ifTrue: [target := connection fromAtom].
							(target atomicPoint whichSideOf: aPlane) = sign and: 
									[| line1 line2 angle |
									line1 := connection fromAtom atomicPoint as2dPoint 
												to: connection toAtom atomicPoint as2dPoint.
									line2 := from as2dPoint to: to as2dPoint.
									angle := (line1 angleWithLine: line2) degrees.
									angle between: 10 and: 170]].
			connections isEmpty 
				ifTrue: 
					[aPolyline vertexes: (Array 
								with: fromPoint
								with: ((from to: to) atT: 0.06)
								with: to)]
				ifFalse: 
					[| points |
					points := connections collect: 
									[:connection | 
									| line1 line2 |
									line1 := connection fromAtom atomicPoint as2dPoint 
												to: connection toAtom atomicPoint as2dPoint.
									line2 := from as2dPoint to: to as2dPoint.
									line1 intersectingPointWithLine: line2].
					points := (points reject: [:p | p isNil]) collect: [:p | p as3dPoint].
					points isEmpty 
						ifFalse: 
							[points := points 
										asSortedCollection: [:p1 :p2 | (p1 distance: from) &lt; (p2 distance: from)].
							aPolyline vertexes: (Array with: points first with: to)]]].
	^aPolyline</body>

<body package="ChemoJun-Basic-Objects" selector="modifiedToPolyline:forDoubleBondAsPlane:">modifiedToPolyline: aPolyline forDoubleBondAsPlane: atomConnection 
	| fromAtom toAtom fromPoint toPoint toConnections aPlane from to |
	fromAtom := atomConnection fromAtom.
	toAtom := atomConnection toAtom.
	fromPoint := fromAtom atomicPoint.
	toPoint := toAtom atomicPoint.
	toConnections := (self connectionsWith: toAtom) 
				reject: [:each | each = atomConnection].
	aPlane := fromPoint plane: toPoint and: fromPoint x , fromPoint y , 1.
	from := aPolyline vertexes first.
	to := aPolyline vertexes last.
	toConnections isEmpty 
		ifTrue: 
			[| line |
			line := from to: to.
			to := line atT: 0.88.
			aPolyline vertexes: (Array with: from with: to)]
		ifFalse: 
			[| sign connections |
			sign := to whichSideOf: aPlane.
			connections := toConnections select: 
							[:connection | 
							| target |
							target := connection fromAtom.
							target = toAtom ifTrue: [target := connection toAtom].
							(target atomicPoint whichSideOf: aPlane) = sign and: 
									[| line1 line2 angle |
									line1 := connection fromAtom atomicPoint as2dPoint 
												to: connection toAtom atomicPoint as2dPoint.
									line2 := from as2dPoint to: to as2dPoint.
									angle := (line1 angleWithLine: line2) degrees.
									angle between: 10 and: 170]].
			connections isEmpty 
				ifTrue: 
					[aPolyline vertexes: (Array 
								with: from
								with: ((from to: to) atT: 0.94)
								with: toPoint)]
				ifFalse: 
					[| points |
					points := connections collect: 
									[:connection | 
									| line1 line2 |
									line1 := connection fromAtom atomicPoint as2dPoint 
												to: connection toAtom atomicPoint as2dPoint.
									line2 := from as2dPoint to: to as2dPoint.
									line1 intersectingPointWithLine: line2].
					points := (points reject: [:p | p isNil]) collect: [:p | p as3dPoint].
					points isEmpty 
						ifFalse: 
							[points := points 
										asSortedCollection: [:p1 :p2 | (p1 distance: to) &lt; (p2 distance: to)].
							aPolyline vertexes: (Array with: from with: points first)]]]</body>

<body package="ChemoJun-Basic-Objects" selector="translationOffsetOf:">translationOffsetOf: atomConnection 
	| translationOffset aSymbol connectedAtoms anotherAtom aLine aPoint aPlane aCollection |
	translationOffset := 0 , 0 , 0.
	aSymbol := atomConnection bondTypeSymbol.
	(aSymbol = #single or: [aSymbol = #any]) 
		ifTrue: [translationOffset := 0 , 0 , 0].
	(aSymbol = #double or: [aSymbol = #triple]) 
		ifTrue: 
			[aSymbol = #double 
				ifTrue: [translationOffset := 0 , 0 , 0.075]
				ifFalse: [translationOffset := 0 , 0 , 0.1].
			connectedAtoms := Set new.
			connectedAtoms 
				addAll: ((self connectedAtomsWith: atomConnection fromAtom) 
						reject: [:each | each = atomConnection fromAtom or: [each = atomConnection toAtom]]).
			connectedAtoms addAll: ((self connectedAtomsWith: atomConnection toAtom) 
						reject: [:each | each = atomConnection fromAtom or: [each = atomConnection toAtom]]).
			connectedAtoms := connectedAtoms asArray.
			connectedAtoms isEmpty 
				ifFalse: 
					[anotherAtom := connectedAtoms first.
					aLine := atomConnection fromAtom atomicPoint 
								to: atomConnection toAtom atomicPoint.
					aPoint := aLine nearestPointFromPoint: anotherAtom atomicPoint.
					(aPoint distance: anotherAtom atomicPoint) &lt; JunGeometry accuracy 
						ifFalse: 
							[aLine := aPoint to: anotherAtom atomicPoint.
							aPoint := aLine normalUnitVector.
							aSymbol = #double 
								ifTrue: [translationOffset := aPoint * 0.075]
								ifFalse: [translationOffset := aPoint * 0.1]]]].
	(#(#aromatic #singleORdouble #singleORaromatic #doubeORaromatic) 
		includes: aSymbol) 
			ifTrue: 
				[translationOffset := 0 , 0 , 0.075.
				connectedAtoms := Set new.
				connectedAtoms 
					addAll: ((self connectedAtomsWith: atomConnection fromAtom) 
							reject: [:each | each = atomConnection fromAtom or: [each = atomConnection toAtom]]).
				connectedAtoms addAll: ((self connectedAtomsWith: atomConnection toAtom) 
							reject: [:each | each = atomConnection fromAtom or: [each = atomConnection toAtom]]).
				connectedAtoms := connectedAtoms asArray select: 
								[:each | 
								((self connectionsWith: each) 
									detect: [:it | it bondTypeSymbol = #aromatic]
									ifNone: [nil]) notNil].
				connectedAtoms isEmpty 
					ifFalse: 
						[anotherAtom := connectedAtoms first.
						connectedAtoms size &lt; 2 
							ifTrue: 
								[aLine := atomConnection fromAtom atomicPoint 
											to: atomConnection toAtom atomicPoint.
								aPoint := aLine nearestPointFromPoint: anotherAtom atomicPoint.
								aLine := aPoint to: anotherAtom atomicPoint.
								aPoint := aLine normalUnitVector]
							ifFalse: 
								[aPlane := atomConnection fromAtom atomicPoint 
											plane: atomConnection toAtom atomicPoint
											and: anotherAtom atomicPoint.
								aPlane := atomConnection fromAtom atomicPoint 
											plane: atomConnection toAtom atomicPoint
											and: atomConnection toAtom atomicPoint + aPlane normalUnitVector.
								aCollection := connectedAtoms 
											select: [:each | (each atomicPoint whichSideOf: aPlane) &gt;= 0].
								aCollection size &gt; 1 
									ifFalse: 
										[aCollection := connectedAtoms 
													select: [:each | (each atomicPoint whichSideOf: aPlane) &lt; 0]].
								aCollection isEmpty ifFalse: [anotherAtom := aCollection first].
								aLine := atomConnection fromAtom atomicPoint 
											to: atomConnection toAtom atomicPoint.
								aPoint := aLine nearestPointFromPoint: anotherAtom atomicPoint.
								aLine := anotherAtom atomicPoint to: aPoint.
								aPoint := aLine normalUnitVector].
						translationOffset := aPoint * 0.075]].
	^translationOffset</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>accessing</category>

<body package="ChemoJun-Basic-Objects" selector="atomResolution">atomResolution
	atomResolution isNil ifTrue: [atomResolution := #medium].
	^atomResolution</body>

<body package="ChemoJun-Basic-Objects" selector="atomResolution:">atomResolution: aSymbol 
	(#(#low #medium #high) includes: aSymbol)
		ifTrue: [atomResolution := aSymbol]</body>

<body package="ChemoJun-Basic-Objects" selector="atomTable">atomTable
	| aTable |
	aTable := Dictionary new.
	self atomObjectsDo: 
			[:atomObject | 
			(aTable includesKey: atomObject atomicSymbol) 
				ifTrue: 
					[aTable at: atomObject atomicSymbol
						put: 1 + (aTable at: atomObject atomicSymbol)]
				ifFalse: [aTable at: atomObject atomicSymbol put: 1]].
	^aTable</body>

<body package="ChemoJun-Basic-Objects" selector="exceptHydrogen">exceptHydrogen
	^exceptHydrogen = true</body>

<body package="ChemoJun-Basic-Objects" selector="exceptHydrogen:">exceptHydrogen: aBoolean 
	exceptHydrogen := aBoolean = true</body>

<body package="ChemoJun-Basic-Objects" selector="fileNameFromHeader">fileNameFromHeader
	| aFilename aString aCollection |
	aFilename := nil.
	aString := self molfileHeaderBlock at: 2.
	(aString size &gt;= 10 and: [(aString copyFrom: 3 to: 10) = 'ChemoJun']) 
		ifTrue: 
			[aString := self molfileHeaderBlock at: 1.
			aCollection := JunStringUtility separate: aString.
			(aCollection size = 3 
				and: [aCollection first = '-' and: [aCollection last = '-']]) 
					ifTrue: [aFilename := ((aCollection at: 2) , '.mol') asFilename]].
	^aFilename</body>

<body package="ChemoJun-Basic-Objects" selector="informationString">informationString
	| aString |
	self 
		assert: [String new writeStream]
		do: 
			[:aStream | 
			| aCollection |
			aStream nextPutAll: super informationString.
			aStream tab.
			aStream 
				nextPutAll: (#chemoJun_number_of_atoms__ &gt;&gt; 'number of atoms: ') asString.
			aStream nextPutAll: self numberOfAtoms printString.
			aStream cr.
			aStream tab.
			aStream 
				nextPutAll: (#chemoJun_number_of_connections__ &gt;&gt; 'number of connections: ') 
						asString.
			aStream nextPutAll: self numberOfConnections printString.
			aStream cr.
			aStream tab.
			aStream nextPutAll: (#chemoJun_atoms__ &gt;&gt; 'atoms: ') asString.
			aCollection := self atomTable associations asSortedCollection.
			aCollection with: (1 to: aCollection size)
				do: 
					[:assoc :index | 
					aStream nextPutAll: assoc key asString.
					aStream space.
					aStream nextPutAll: assoc value printString.
					index &lt; aCollection size ifTrue: [aStream nextPutAll: ', ']].
			aStream cr.
			aStream tab.
			aStream nextPutAll: (#chemoJun_connections__ &gt;&gt; 'connections: ') asString.
			aCollection := self connectionTable associations asSortedCollection.
			aCollection with: (1 to: aCollection size)
				do: 
					[:assoc :index | 
					aStream nextPutAll: assoc key asString.
					aStream space.
					aStream nextPutAll: assoc value printString.
					index &lt; aCollection size ifTrue: [aStream nextPutAll: ', ']].
			aStream cr.
			aString := aStream contents]
		ensure: [:aStream | aStream close].
	^aString</body>

<body package="ChemoJun-Basic-Objects" selector="numberOfHydrogens:">numberOfHydrogens: atomObject 
	^(self numberOfHydrogensTable: atomObject) at: #numberOfHydrogens</body>

<body package="ChemoJun-Basic-Objects" selector="numberOfNitrogens:">numberOfNitrogens: atomObject 
	| aTable numberOfNitrogens |
	aTable := self connectedAtomsAndConnectionsWith: atomObject.
	numberOfNitrogens := 0.
	aTable keysAndValuesDo: 
			[:connectedAtom :connectedBond | 
			connectedAtom isNitrogen 
				ifTrue: [numberOfNitrogens := numberOfNitrogens + 1]].
	^numberOfNitrogens</body>

<body package="ChemoJun-Basic-Objects" selector="numberOfOxygens:">numberOfOxygens: atomObject 
	| aTable numberOfOxygens |
	aTable := self connectedAtomsAndConnectionsWith: atomObject.
	numberOfOxygens := 0.
	aTable keysAndValuesDo: 
			[:connectedAtom :connectedBond | 
			connectedAtom isOxygen ifTrue: [numberOfOxygens := numberOfOxygens + 1]].
	^numberOfOxygens</body>

<body package="ChemoJun-Basic-Objects" selector="surfaceInformationString">surfaceInformationString
	| aString |
	self 
		assert: [String new writeStream]
		do: 
			[:aStream | 
			aStream 
				nextPutAll: (#chemoJun_Surface_Information_ &gt;&gt; 'Surface Information:') 
						asString.
			aStream cr.
			self atomObjectsAndIndexesDo: 
					[:atomObject :atomIndex | 
					aStream tab.
					aStream nextPutAll: atomIndex printString , ':'.
					aStream space.
					aStream nextPutAll: atomObject atomicSymbol.
					aStream space.
					aStream nextPutAll: '('.
					aStream 
						nextPutAll: (atomObject atomicArea roundTo: 0.1) asFloat printString.
					aStream nextPutAll: ' = '.
					aStream 
						nextPutAll: (atomObject interierArea roundTo: 0.1) asFloat printString.
					aStream nextPutAll: ' + '.
					aStream 
						nextPutAll: (atomObject frontierArea roundTo: 0.1) asFloat printString.
					aStream nextPutAll: ')'.
					aStream cr].
			aString := aStream contents]
		ensure: [:aStream | aStream close].
	^aString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>accessing atom</category>

<body package="ChemoJun-Basic-Objects" selector="atomObjectAt:">atomObjectAt: serialNumber 
	^self atomObjects 
		detect: [:atomObject | atomObject serialNumber = serialNumber]
		ifNone: [nil]</body>

<body package="ChemoJun-Basic-Objects" selector="atomObjects">atomObjects
	atomObjects isNil ifTrue: [atomObjects := Array new].
	^atomObjects</body>

<body package="ChemoJun-Basic-Objects" selector="atomObjects:">atomObjects: atomObjectCollection 
	atomObjects := atomObjectCollection asArray</body>

<body package="ChemoJun-Basic-Objects" selector="connectedAromaticAtomsAround:">connectedAromaticAtomsAround: atomConnection 
	| connectedAtoms |
	connectedAtoms := Set new.
	(self connectedAtomsAndConnectionsWith: atomConnection fromAtom) 
		associations do: 
				[:assoc | 
				| atom connection |
				atom := assoc key.
				connection := assoc value.
				connection bondTypeSymbol = #aromatic 
					ifTrue: 
						[(atom = atomConnection fromAtom or: [atom = atomConnection toAtom]) 
							ifFalse: [connectedAtoms add: atom]]].
	(self connectedAtomsAndConnectionsWith: atomConnection toAtom) 
		associations do: 
				[:assoc | 
				| atom connection |
				atom := assoc key.
				connection := assoc value.
				connection bondTypeSymbol = #aromatic 
					ifTrue: 
						[(atom = atomConnection fromAtom or: [atom = atomConnection toAtom]) 
							ifFalse: [connectedAtoms add: atom]]].
	^(connectedAtoms 
		asSortedCollection: [:a1 :a2 | a1 serialNumber &lt; a2 serialNumber]) asArray</body>

<body package="ChemoJun-Basic-Objects" selector="connectedAtomsAndConnectionsWith:">connectedAtomsAndConnectionsWith: atomObject 
	| aTable |
	aTable := Dictionary new.
	self atomConnections do: 
			[:atomConnection | 
			atomConnection fromAtom = atomObject 
				ifTrue: [aTable add: atomConnection toAtom -&gt; atomConnection].
			atomConnection toAtom = atomObject 
				ifTrue: [aTable add: atomConnection fromAtom -&gt; atomConnection]].
	^aTable</body>

<body package="ChemoJun-Basic-Objects" selector="connectedAtomsAround:">connectedAtomsAround: atomConnection 
	| connectedAtoms |
	connectedAtoms := Set new.
	(self connectedAtomsWith: atomConnection fromAtom) do: 
			[:each | 
			(each = atomConnection fromAtom or: [each = atomConnection toAtom]) 
				ifFalse: [connectedAtoms add: each]].
	(self connectedAtomsWith: atomConnection toAtom) do: 
			[:each | 
			(each = atomConnection fromAtom or: [each = atomConnection toAtom]) 
				ifFalse: [connectedAtoms add: each]].
	^(connectedAtoms 
		asSortedCollection: [:a1 :a2 | a1 serialNumber &lt; a2 serialNumber]) asArray</body>

<body package="ChemoJun-Basic-Objects" selector="connectedAtomsWith:">connectedAtomsWith: atomObject 
	^(self connectedAtomsAndConnectionsWith: atomObject) keys</body>

<body package="ChemoJun-Basic-Objects" selector="isolatedAtoms">isolatedAtoms
	| isolatedAtoms |
	isolatedAtoms := self atomObjects copy asOrderedCollection.
	self atomConnections do: 
			[:atomConnection | 
			isolatedAtoms remove: atomConnection fromAtom ifAbsent: [nil].
			isolatedAtoms remove: atomConnection toAtom ifAbsent: [nil]].
	^isolatedAtoms</body>

<body package="ChemoJun-Basic-Objects" selector="numberOfAtoms">numberOfAtoms
	^self atomObjects size</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>accessing connection</category>

<body package="ChemoJun-Basic-Objects" selector="atomConnection:with:">atomConnection: atomObject with: anotherAtomObject 
	self atomConnections do: 
			[:atomConnection | 
			(atomConnection fromAtom = atomObject 
				and: [atomConnection toAtom = anotherAtomObject]) ifTrue: [^atomConnection].
			(atomConnection fromAtom = anotherAtomObject 
				and: [atomConnection toAtom = atomObject]) ifTrue: [^atomConnection]].
	^nil</body>

<body package="ChemoJun-Basic-Objects" selector="atomConnections">atomConnections
	atomConnections isNil ifTrue: [atomConnections := Array new].
	^atomConnections</body>

<body package="ChemoJun-Basic-Objects" selector="atomConnections:">atomConnections: atomConnectionCollection 
	atomConnections := atomConnectionCollection asArray</body>

<body package="ChemoJun-Basic-Objects" selector="averageLengthOfConnections">averageLengthOfConnections
	^self attributeTable at: #averageLengthOfConnections
		ifAbsentPut: 
			[| average |
			self atomConnections isEmpty 
				ifTrue: [average := 0]
				ifFalse: 
					[| total |
					total := 0.
					self atomConnections collect: [:each | total := total + each length].
					average := total / self atomConnections size].
			average yourself]</body>

<body package="ChemoJun-Basic-Objects" selector="connectedConnectionsAround:">connectedConnectionsAround: atomConnection 
	| connectedConnections |
	connectedConnections := Set new.
	(self connectedAtomsAndConnectionsWith: atomConnection fromAtom) 
		associations do: 
				[:assoc | 
				| connection |
				connection := assoc value.
				connection = atomConnection 
					ifFalse: [connectedConnections add: connection]].
	(self connectedAtomsAndConnectionsWith: atomConnection toAtom) 
		associations do: 
				[:assoc | 
				| connection |
				connection := assoc value.
				connection = atomConnection 
					ifFalse: [connectedConnections add: connection]].
	^(connectedConnections asSortedCollection: 
			[:c1 :c2 | 
			c1 fromAtom serialNumber = c2 fromAtom serialNumber 
				ifTrue: [c1 toAtom serialNumber &lt; c2 toAtom serialNumber]
				ifFalse: [c1 fromAtom serialNumber &lt; c2 fromAtom serialNumber]]) 
		asArray</body>

<body package="ChemoJun-Basic-Objects" selector="connectionsWith:">connectionsWith: atomObject 
	^(self connectedAtomsAndConnectionsWith: atomObject) values</body>

<body package="ChemoJun-Basic-Objects" selector="connectionTable">connectionTable
	| aTable aCollection aString |
	aTable := Dictionary new.
	self atomConnections
		do: 
			[:each | 
			aCollection := SortedCollection new: 2.
			aCollection add: each fromAtom atomicSymbol.
			aCollection add: each toAtom atomicSymbol.
			aString := (aCollection at: 1)
						, '-' , (aCollection at: 2).
			(aTable includesKey: aString)
				ifTrue: [aTable at: aString put: 1 + (aTable at: aString)]
				ifFalse: [aTable at: aString put: 1]].
	^aTable</body>

<body package="ChemoJun-Basic-Objects" selector="numberOfConnections">numberOfConnections
	^self atomConnections size</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>attribute accessing</category>

<body package="ChemoJun-Basic-Objects" selector="attributeTable">attributeTable
	attributeTable isNil ifTrue: [attributeTable := JunAttributeTable new].
	^attributeTable</body>

<body package="ChemoJun-Basic-Objects" selector="molfileHeaderBlock">molfileHeaderBlock
	^self attributeTable at: #molfileHeaderBlock
		ifAbsent: 
			[OrderedCollection 
				with: (String with: Character cr)
				with: (String with: Character cr)
				with: (String with: Character cr)]</body>

<body package="ChemoJun-Basic-Objects" selector="molfileHeaderBlock:">molfileHeaderBlock: aCollection 
	self attributeTable at: #molfileHeaderBlock
		put: aCollection asOrderedCollection</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>coloring</category>

<body package="ChemoJun-Basic-Objects" selector="changeColor:serialNumberPairs:nestLevel:">changeColor: colorValue serialNumberPairs: serialNumberPairs nestLevel: nestLevel 
	| collectionOfAtomConnections |
	collectionOfAtomConnections := self atomConnections select: 
					[:atomConnection | 
					| aPair |
					aPair := Array with: atomConnection fromAtom serialNumber
								with: atomConnection toAtom serialNumber.
					(serialNumberPairs includes: aPair) 
						or: [serialNumberPairs includes: aPair reverse]].
	collectionOfAtomConnections 
		do: [:atomConnection | atomConnection connectionColor: colorValue].
	nestLevel &gt; 0 
		ifTrue: 
			[collectionOfAtomConnections do: 
					[:atomConnection | 
					self 
						changeColor: colorValue
						serialNumberPairs: ((self connectionsWith: atomConnection fromAtom) asArray 
								, (self connectionsWith: atomConnection toAtom) asArray collect: 
										[:each | 
										Array with: each fromAtom serialNumber with: each toAtom serialNumber])
						nestLevel: nestLevel - 1]]</body>

<body package="ChemoJun-Basic-Objects" selector="changeColor:serialNumbers:nestLevel:">changeColor: colorValue serialNumbers: serialNumbers nestLevel: nestLevel 
	| collectionOfAtomObjects |
	collectionOfAtomObjects := self atomObjects 
				select: [:atomObject | serialNumbers includes: atomObject serialNumber].
	collectionOfAtomObjects 
		do: [:atomObject | atomObject atomicColor: colorValue].
	nestLevel &gt; 0 
		ifTrue: 
			[collectionOfAtomObjects do: 
					[:atomObject | 
					self 
						changeColor: colorValue
						serialNumbers: ((self connectedAtomsWith: atomObject) 
								collect: [:each | each serialNumber])
						nestLevel: nestLevel - 1]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>converting</category>

<body package="ChemoJun-Basic-Objects" selector="asGraph">asGraph
	| aGraph nodeClass aNode fromAtom toAtom nodeTable fromNode toNode |
	aGraph := self defaultGraphClass new.
	aGraph beUndirectedGraph.
	nodeClass := aGraph class defaultNodeClass.
	nodeTable := Dictionary new.
	self atomObjectsAndIndexesDo: 
			[:atomObject :serialNumber | 
			aNode := nodeClass 
						label: atomObject atomicSymbol , '-' , serialNumber printString.
			aGraph add: aNode.
			nodeTable at: atomObject put: aNode].
	self atomConnectionsDo: 
			[:atomConnection | 
			fromAtom := atomConnection fromAtom.
			toAtom := atomConnection toAtom.
			fromNode := nodeTable at: fromAtom.
			toNode := nodeTable at: toAtom.
			aGraph connect: fromNode with: toNode].
	aGraph arrange: #concentric.
	^aGraph</body>

<body package="ChemoJun-Basic-Objects" selector="asGrapher">asGrapher
	^self defaultGrapherClass graph: self asGraph</body>

<body package="ChemoJun-Basic-Objects" selector="asString">asString
	| aWriter aString |
	self 
		assert: [String new writeStream]
		do: 
			[:aStream | 
			aWriter := ChemoJunMolFileWriter moleculeObject: self.
			self fileName ifNotNil: [:filename | aWriter fileName: filename].
			aWriter writeOn: aStream.
			aString := aStream contents]
		ensure: [:aStream | aStream close].
	^aString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>copying</category>

<body package="ChemoJun-Basic-Objects" selector="postCopy">postCopy
	| aTable |
	super postCopy.
	aTable := Dictionary new.
	self atomObjects do: [:each | aTable at: each put: each copy].
	atomObjects := self atomObjects collect: [:each | aTable at: each].
	atomConnections := self atomConnections collect: [:each | each copy].
	atomConnections do: 
			[:each | 
			each fromAtom: (aTable at: each fromAtom).
			each toAtom: (aTable at: each toAtom)].
	attributeTable := attributeTable copy</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>defaults</category>

<body package="ChemoJun-Basic-Objects" selector="default2dMolfilePatterns">default2dMolfilePatterns
	^#('*.2d.mol')</body>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomConnectionClass">defaultAtomConnectionClass
	^self class defaultAtomConnectionClass</body>

<body package="ChemoJun-Basic-Objects" selector="defaultAtomObjectClass">defaultAtomObjectClass
	^self class defaultAtomObjectClass</body>

<body package="ChemoJun-Basic-Objects" selector="defaultBallDivisionNumberHigh">defaultBallDivisionNumberHigh
	^2</body>

<body package="ChemoJun-Basic-Objects" selector="defaultBallDivisionNumberLow">defaultBallDivisionNumberLow
	^0</body>

<body package="ChemoJun-Basic-Objects" selector="defaultBallDivisionNumberMedium">defaultBallDivisionNumberMedium
	^1</body>

<body package="ChemoJun-Basic-Objects" selector="defaultBondThickness">defaultBondThickness
	^0.09</body>

<body package="ChemoJun-Basic-Objects" selector="defaultFrontierMinimumDistance">defaultFrontierMinimumDistance
	self atomResolution = #high ifTrue: [^0.001d].
	self atomResolution = #medium ifTrue: [^0.01d].
	self atomResolution = #low ifTrue: [^0.1d].
	^0.01d</body>

<body package="ChemoJun-Basic-Objects" selector="defaultFrontierRevisedCoeffcient">defaultFrontierRevisedCoeffcient
	self atomResolution = #high ifTrue: [^0.997d].
	self atomResolution = #medium ifTrue: [^0.983d].
	self atomResolution = #low ifTrue: [^0.900d].
	^0.983d</body>

<body package="ChemoJun-Basic-Objects" selector="defaultGraphClass">defaultGraphClass
	^self class defaultGraphClass</body>

<body package="ChemoJun-Basic-Objects" selector="defaultGrapherClass">defaultGrapherClass
	^self class defaultGrapherClass</body>

<body package="ChemoJun-Basic-Objects" selector="defaultHalftoneValue">defaultHalftoneValue
	^0.5</body>

<body package="ChemoJun-Basic-Objects" selector="defaultMinimumTriangleArea">defaultMinimumTriangleArea
	self atomResolution = #high ifTrue: [^0.001d].
	self atomResolution = #medium ifTrue: [^0.01d].
	self atomResolution = #low ifTrue: [^0.1d].
	^0.01d</body>

<body package="ChemoJun-Basic-Objects" selector="defaultMolFileReaderClass">defaultMolFileReaderClass
	^self class defaultMolFileReaderClass</body>

<body package="ChemoJun-Basic-Objects" selector="defaultSpaceFillDivisionNumber">defaultSpaceFillDivisionNumber
	self atomResolution = #low 
		ifTrue: [^self defaultSpaceFillDivisionNumberLow].
	self atomResolution = #medium 
		ifTrue: [^self defaultSpaceFillDivisionNumberMedium].
	self atomResolution = #high 
		ifTrue: [^self defaultSpaceFillDivisionNumberHigh].
	^self defaultSpaceFillDivisionNumber</body>

<body package="ChemoJun-Basic-Objects" selector="defaultSpaceFillDivisionNumberHigh">defaultSpaceFillDivisionNumberHigh
	^3</body>

<body package="ChemoJun-Basic-Objects" selector="defaultSpaceFillDivisionNumberLow">defaultSpaceFillDivisionNumberLow
	^1</body>

<body package="ChemoJun-Basic-Objects" selector="defaultSpaceFillDivisionNumberMedium">defaultSpaceFillDivisionNumberMedium
	^2</body>

<body package="ChemoJun-Basic-Objects" selector="defaultTubeDivisionNumber">defaultTubeDivisionNumber
	^self defaultTubeDivisionNumberMedium</body>

<body package="ChemoJun-Basic-Objects" selector="defaultTubeDivisionNumberHigh">defaultTubeDivisionNumberHigh
	^60</body>

<body package="ChemoJun-Basic-Objects" selector="defaultTubeDivisionNumberLow">defaultTubeDivisionNumberLow
	^120</body>

<body package="ChemoJun-Basic-Objects" selector="defaultTubeDivisionNumberMedium">defaultTubeDivisionNumberMedium
	^90</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>enumerating</category>

<body package="ChemoJun-Basic-Objects" selector="atomConnectionsDo:">atomConnectionsDo: aBlock 
	self atomConnections do: [:atomConnection | aBlock value: atomConnection]</body>

<body package="ChemoJun-Basic-Objects" selector="atomObjectsAndIndexesDo:">atomObjectsAndIndexesDo: aBlock 
	self atomObjects 
		do: [:atomObject | aBlock value: atomObject value: atomObject serialNumber]</body>

<body package="ChemoJun-Basic-Objects" selector="atomObjectsDo:">atomObjectsDo: aBlock 
	self atomObjects do: [:atomObject | aBlock value: atomObject]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>frontier</category>

<body package="ChemoJun-Basic-Objects" selector="frontierPoint:rejectedBy:">frontierPoint: aLine rejectedBy: aBall 
	| incrementValue firstDistance firstPoint lastDistance lastPoint |
	firstPoint := aLine first.
	lastPoint := aLine last.
	(firstPoint distance: lastPoint) &lt; self defaultFrontierMinimumDistance 
		ifTrue: [^firstPoint center: lastPoint].
	incrementValue := 0.5.
	(0 to: 1 - incrementValue by: incrementValue) 
		with: (0 + incrementValue to: 1 by: incrementValue)
		do: 
			[:firstT :lastT | 
			firstDistance := (firstPoint := aLine atT: firstT) distance: aBall center.
			lastDistance := (lastPoint := aLine atT: lastT) distance: aBall center.
			(aBall radius between: (firstDistance min: lastDistance)
				and: (firstDistance max: lastDistance)) 
					ifTrue: [^self frontierPoint: (firstPoint to: lastPoint) rejectedBy: aBall]].
	^firstPoint center: lastPoint</body>

<body package="ChemoJun-Basic-Objects" selector="frontierPolygons:of:offset:">frontierPolygons: aPolygon of: atomObject offset: offsetValue 
	| aTriangle triangleCollection intersectedAtoms aBall aCollection frontierPolygons |
	aTriangle := Jun3dTriangle 
				on: (aPolygon vertexes at: 1)
				on: (aPolygon vertexes at: 2)
				on: (aPolygon vertexes at: 3).
	aBall := Jun3dBoundingBall center: atomObject atomicPoint
				radius: atomObject atomicRadius + offsetValue.
	intersectedAtoms := self atomObjects select: 
					[:eachAtom | 
					(eachAtom = atomObject) not and: 
							[aBall intersects: (Jun3dBoundingBall center: eachAtom atomicPoint
										radius: eachAtom atomicRadius + offsetValue)]].
	triangleCollection := OrderedCollection with: aTriangle.
	intersectedAtoms do: 
			[:eachAtom | 
			aBall := Jun3dBoundingBall center: eachAtom atomicPoint
						radius: eachAtom atomicRadius + offsetValue.
			aCollection := OrderedCollection new.
			triangleCollection do: 
					[:eachTriangle | 
					aCollection 
						addAll: (self frontierTriangles: eachTriangle rejectedBy: aBall)].
			triangleCollection := aCollection].
	frontierPolygons := triangleCollection collect: 
					[:eachTriangle | 
					(JunOpenGL3dPolygon vertexes: (Array 
								with: eachTriangle p1
								with: eachTriangle p2
								with: eachTriangle p3))
						paint: aPolygon paint;
						yourself].
	^frontierPolygons</body>

<body package="ChemoJun-Basic-Objects" selector="frontierTriangles:rejectedBy:">frontierTriangles: aTriangle rejectedBy: aBall 
	| aCollection trueCollection falseCollection firstPoint secondPoint thirdPoint aPoint aLine aPlane aTable |
	aCollection := (Array 
				with: aTriangle first
				with: aTriangle second
				with: aTriangle third) 
					collect: [:eachPoint | (aBall containsPoint: eachPoint) -&gt; eachPoint].
	trueCollection := aCollection 
				select: [:anAssociation | anAssociation key = true].
	falseCollection := aCollection 
				select: [:anAssociation | anAssociation key = false].
	trueCollection size = 3 ifTrue: [^Array new].
	falseCollection size = 3 ifTrue: [^Array with: aTriangle].
	firstPoint := nil.
	secondPoint := nil.
	thirdPoint := nil.
	trueCollection size = 2 
		ifTrue: 
			[firstPoint := falseCollection first value.
			secondPoint := trueCollection first value.
			thirdPoint := trueCollection last value].
	falseCollection size = 2 
		ifTrue: 
			[firstPoint := trueCollection first value.
			secondPoint := falseCollection first value.
			thirdPoint := falseCollection last value].
	secondPoint := self frontierPoint: (firstPoint to: secondPoint)
				rejectedBy: aBall.
	thirdPoint := self frontierPoint: (firstPoint to: thirdPoint)
				rejectedBy: aBall.
	aPoint := secondPoint center: thirdPoint.
	aLine := aBall center to: aPoint.
	aPoint := aLine atT: self defaultFrontierRevisedCoeffcient.
	aPlane := aPoint plane: aLine normalUnitVector.
	aTable := aTriangle tableDividedBy: aPlane.
	^aTable at: #positives</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>functions</category>

<body package="ChemoJun-Basic-Objects" selector="distancesFrom:">distancesFrom: aPoint 
	| collection |
	collection := OrderedCollection new: self numberOfAtoms.
	self atomObjectsAndIndexesDo: 
			[:atom :index | 
			| distance |
			distance := atom distanceFrom: aPoint.
			collection add: distance -&gt; (Array with: atom with: index)].
	collection := collection asSortedCollection: [:d1 :d2 | d1 &lt; d2].
	^collection</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>printing</category>

<body package="ChemoJun-Basic-Objects" selector="printOn:">printOn: aStream 
	aStream nextPutAll: self asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>testing</category>

<body package="ChemoJun-Basic-Objects" selector="hasHydroxyl:">hasHydroxyl: atomObject 
	"
	*-OH
	^
	"

	| aTable |
	aTable := self connectedAtomsAndConnectionsWith: atomObject.
	aTable keysAndValuesDo: 
			[:connectedAtom :connectedBond | 
			(connectedBond isSingle and: [connectedAtom isOxygen]) 
				ifTrue: [^self isHydroxyl: connectedAtom]].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="is2d">is2d
	self fileName ifNil: [^false].
	^(self default2dMolfilePatterns detect: 
			[:patternString | 
			JunStringUtility stringMatch: self fileName asString asLowercase
				and: patternString asLowercase]
		ifNone: [nil]) notNil</body>

<body package="ChemoJun-Basic-Objects" selector="is3d">is3d
	^self is2d not</body>

<body package="ChemoJun-Basic-Objects" selector="isAldehyde:">isAldehyde: atomObject 
	"
	-CHO
	 ^
	"

	| aBoolean |
	aBoolean := false.
	atomObject isCarbon 
		ifTrue: 
			[| aTable |
			aTable := self connectedAtomsAndConnectionsWith: atomObject.
			aTable keysAndValuesDo: 
					[:connectedAtom :connectedBond | 
					(connectedBond isDouble and: [connectedAtom isOxygen]) 
						ifTrue: [aBoolean := true]]].
	(aBoolean and: [(self numberOfHydrogens: atomObject) = 1]) ifTrue: [^true].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isAmino:">isAmino: atomObject 
	"
	-NH2 or -NH
	 ^       ^
	"

	(atomObject isNitrogen and: 
			[(self numberOfHydrogens: atomObject) = 2 
				or: [(self numberOfHydrogens: atomObject) = 1]]) 
		ifTrue: [^true].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isCarbonWithTwoDoubleBonds:">isCarbonWithTwoDoubleBonds: atomObject 
	"
	=C=
	 ^
	"

	atomObject isCarbon 
		ifTrue: 
			[| aCollection |
			aCollection := self connectionsWith: atomObject.
			2 = (aCollection select: [:connectedBond | connectedBond isDouble]) size 
				ifTrue: [^true]].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isCarbonyl:">isCarbonyl: atomObject 
	"
	-C=O
	 ^
	"

	(self isCarboxyl: atomObject) ifTrue: [^false].
	(self isAldehyde: atomObject) ifTrue: [^false].
	atomObject isCarbon 
		ifTrue: 
			[| aTable |
			aTable := self connectedAtomsAndConnectionsWith: atomObject.
			aTable keysAndValuesDo: 
					[:connectedAtom :connectedBond | 
					(connectedBond isDouble and: [connectedAtom isOxygen]) ifTrue: [^true]]].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isCarboxyl:">isCarboxyl: atomObject 
	"
	-COOH
	 ^
	"

	| aBoolean |
	aBoolean := false.
	atomObject isCarbon 
		ifTrue: 
			[| aTable |
			aTable := self connectedAtomsAndConnectionsWith: atomObject.
			aTable keysAndValuesDo: 
					[:connectedAtom :connectedBond | 
					(connectedBond isDouble and: [connectedAtom isOxygen]) 
						ifTrue: [aBoolean := true]]].
	(aBoolean and: [self hasHydroxyl: atomObject]) ifTrue: [^true].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isHydroxyl:">isHydroxyl: atomObject 
	"
	-OH
	 ^
	"

	(atomObject isOxygen and: [(self numberOfHydrogens: atomObject) = 1]) 
		ifTrue: [^true].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isMethyl:">isMethyl: atomObject 
	"
	-CH3
	 ^  
	"

	(atomObject isCarbon and: [(self numberOfHydrogens: atomObject) = 3]) 
		ifTrue: [^true].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isMethylene:">isMethylene: atomObject 
	"
	-CH2
	 ^  
	"

	(atomObject isCarbon and: [(self numberOfHydrogens: atomObject) = 2]) 
		ifTrue: [^true].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isMethylidene:">isMethylidene: atomObject 
	"
	=CH2
	 ^  
	"

	^(self isMethylene: atomObject) and: 
			[| aCollection |
			aCollection := self connectionsWith: atomObject.
			aCollection do: [:connectedBond | connectedBond isDouble ifTrue: [^true]]]</body>

<body package="ChemoJun-Basic-Objects" selector="isMethylidyne:">isMethylidyne: atomObject 
	"
	triple-bound-CH1
	             ^  
	"

	^(self isMethyne: atomObject) and: 
			[| aCollection |
			aCollection := self connectionsWith: atomObject.
			aCollection do: [:connectedBond | connectedBond isTriple ifTrue: [^true]]]</body>

<body package="ChemoJun-Basic-Objects" selector="isMethyne:">isMethyne: atomObject 
	"
	-CH1
	 ^  
	"

	(atomObject isCarbon and: [(self numberOfHydrogens: atomObject) = 1]) 
		ifTrue: [^true].
	^false</body>

<body package="ChemoJun-Basic-Objects" selector="isSulfanyl:">isSulfanyl: atomObject 
	"
	-SH
	 ^
	"

	(atomObject isSulfur and: [(self numberOfHydrogens: atomObject) = 1]) 
		ifTrue: [^true].
	^false</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunMoleculeObject</class-id> <category>private</category>

<body package="ChemoJun-Basic-Objects" selector="modifierAssociation:normalPresentation:">modifierAssociation: atomObject normalPresentation: aBoolean 
	| anAssociation fakeNumberOfHydrogens |
	anAssociation := atomObject atomicSymbol asString -&gt; 1.
	fakeNumberOfHydrogens := (self numberOfHydrogensTable: atomObject) 
				at: #fakeNumberOfHydrogens.
	aBoolean 
		ifTrue: 
			[((self isMethyl: atomObject) 
				or: [self isCarbonWithTwoDoubleBonds: atomObject]) 
					ifTrue: 
						[fakeNumberOfHydrogens = 0 ifTrue: [anAssociation := 'C' -&gt; 1].
						fakeNumberOfHydrogens = 1 ifTrue: [anAssociation := 'CH' -&gt; 1].
						fakeNumberOfHydrogens = 2 ifTrue: [anAssociation := 'CH2' -&gt; 1].
						fakeNumberOfHydrogens = 3 ifTrue: [anAssociation := 'CH3' -&gt; 1]].
			(self isHydroxyl: atomObject) 
				ifTrue: 
					[fakeNumberOfHydrogens = 0 ifTrue: [anAssociation := 'O' -&gt; 1].
					fakeNumberOfHydrogens = 1 ifTrue: [anAssociation := 'OH' -&gt; 1]].
			(self isAmino: atomObject) 
				ifTrue: 
					[fakeNumberOfHydrogens = 0 ifTrue: [anAssociation := 'N' -&gt; 1].
					fakeNumberOfHydrogens = 1 ifTrue: [anAssociation := 'NH' -&gt; 1].
					fakeNumberOfHydrogens = 2 ifTrue: [anAssociation := 'NH2' -&gt; 1]].
			(self isSulfanyl: atomObject) 
				ifTrue: 
					[fakeNumberOfHydrogens = 0 ifTrue: [anAssociation := 'S' -&gt; 1].
					fakeNumberOfHydrogens = 1 ifTrue: [anAssociation := 'SH' -&gt; 1]]]
		ifFalse: 
			[((self isMethyl: atomObject) 
				or: [self isCarbonWithTwoDoubleBonds: atomObject]) 
					ifTrue: 
						[fakeNumberOfHydrogens = 0 ifTrue: [anAssociation := 'C' -&gt; 1].
						fakeNumberOfHydrogens = 1 ifTrue: [anAssociation := 'HC' -&gt; 2].
						fakeNumberOfHydrogens = 2 ifTrue: [anAssociation := 'H2C' -&gt; 3].
						fakeNumberOfHydrogens = 3 ifTrue: [anAssociation := 'H3C' -&gt; 3]].
			(self isHydroxyl: atomObject) 
				ifTrue: 
					[fakeNumberOfHydrogens = 0 ifTrue: [anAssociation := 'O' -&gt; 1].
					fakeNumberOfHydrogens = 1 ifTrue: [anAssociation := 'HO' -&gt; 2]].
			(self isAmino: atomObject) 
				ifTrue: 
					[fakeNumberOfHydrogens = 0 ifTrue: [anAssociation := 'N' -&gt; 1].
					fakeNumberOfHydrogens = 1 ifTrue: [anAssociation := 'HN' -&gt; 2].
					fakeNumberOfHydrogens = 2 ifTrue: [anAssociation := 'H2N' -&gt; 3]].
			(self isSulfanyl: atomObject) 
				ifTrue: 
					[fakeNumberOfHydrogens = 0 ifTrue: [anAssociation := 'S' -&gt; 1].
					fakeNumberOfHydrogens = 1 ifTrue: [anAssociation := 'HS' -&gt; 2]]].
	^anAssociation</body>

<body package="ChemoJun-Basic-Objects" selector="numberOfHydrogensTable:">numberOfHydrogensTable: atomObject 
	| aTable numberOfBonds realNumberOfHydrogens fakeNumberOfHydrogens numberOfHydrogens numberOfConnections |
	aTable := self connectedAtomsAndConnectionsWith: atomObject.
	numberOfBonds := self defaultAtomObjectClass 
				atomicBondsAt: atomObject atomicSymbol.
	realNumberOfHydrogens := 0.
	fakeNumberOfHydrogens := 0.
	numberOfHydrogens := 0.
	numberOfConnections := 0.
	aTable keysAndValuesDo: 
			[:connectedAtom :connectedBond | 
			connectedAtom isHydrogen 
				ifTrue: [realNumberOfHydrogens := realNumberOfHydrogens + 1].
			numberOfConnections := numberOfConnections + connectedBond bondType].
	fakeNumberOfHydrogens := numberOfBonds - numberOfConnections.
	numberOfHydrogens := realNumberOfHydrogens + fakeNumberOfHydrogens.
	^(Dictionary new)
		add: #numberOfHydrogens -&gt; numberOfHydrogens;
		add: #realNumberOfHydrogens -&gt; realNumberOfHydrogens;
		add: #fakeNumberOfHydrogens -&gt; fakeNumberOfHydrogens;
		yourself</body>
</methods>


</st-source>
