<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76985 "21:23:05"))'</do-it>



<class>
<name>ChemoJunSdFileReader</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunAbstractFileReader</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>molFileReaders </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-File-IO</category>
<attributes>
<package>ChemoJun-File-IO</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunSdFileReader class</class-id> <category>copyright</category>

<body package="ChemoJun-File-IO" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-File-IO" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-File-IO" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileReader class</class-id> <category>defaults</category>

<body package="ChemoJun-File-IO" selector="defaultFileDescriptions">defaultFileDescriptions
	^Array with: (Array 
				with: (#chemoJun_SD_files &gt;&gt; 'SD files') asString)
		with: (Array with: (#jun_All_files &gt;&gt; 'All files') asString)</body>

<body package="ChemoJun-File-IO" selector="defaultFilePatterns">defaultFilePatterns
	^Array with: #('*.sdf' '*.SDF') with: #('*')</body>

<body package="ChemoJun-File-IO" selector="defaultMoleculeObjectClass">defaultMoleculeObjectClass
	^ChemoJunMoleculeObject</body>

<body package="ChemoJun-File-IO" selector="defaultMolFileReaderClass">defaultMolFileReaderClass
	^ChemoJunMolFileReader</body>

<body package="ChemoJun-File-IO" selector="defaultRequestMessageString">defaultRequestMessageString
	^(#chemoJun_Select_a_SD_file_ &gt;&gt; 'Select a SD file.') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileReader class</class-id> <category>examples</category>

<body package="ChemoJun-File-IO" selector="example1">example1
	"ChemoJunSdFileReader example1."

	| aReader |
	aReader := ChemoJunSdFileReader request.
	aReader isNil ifTrue: [^nil].
	^aReader</body>

<body package="ChemoJun-File-IO" selector="example2">example2
	"ChemoJunSdFileReader example2."

	| aReader |
	aReader := ChemoJunSdFileReader request.
	aReader isNil ifTrue: [^nil].
	aReader moleculeObjects 
		do: [:moleculeObject | (ChemoJunMoleculeViewer moleculeObject: moleculeObject) open]</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunSdFileReader</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunSdFileReader</class-id> <category>initialize-release</category>

<body package="ChemoJun-File-IO" selector="initialize">initialize
	super initialize.
	molFileReaders := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileReader</class-id> <category>accessing</category>

<body package="ChemoJun-File-IO" selector="moleculeObjects">moleculeObjects
	^self molFileReaders 
		collect: [:aReader | self class defaultMoleculeObjectClass fromReader: aReader]</body>

<body package="ChemoJun-File-IO" selector="molFileReaders">molFileReaders
	molFileReaders ifNil: [molFileReaders := OrderedCollection new].
	^molFileReaders</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileReader</class-id> <category>reading</category>

<body package="ChemoJun-File-IO" selector="readDataItemFrom:">readDataItemFrom: aStream 
	^self</body>

<body package="ChemoJun-File-IO" selector="readDataItemsFrom:">readDataItemsFrom: aStream 
	^self</body>

<body package="ChemoJun-File-IO" selector="readDelimiterFrom:">readDelimiterFrom: aStream 
	[aStream atEnd not] whileTrue: 
			[| aString aCollection |
			aString := self getLine: aStream.
			aCollection := self separate: aString.
			(aCollection size &gt;= 1 and: [aCollection first = '$$$$']) ifTrue: [^self]].
	^self</body>

<body package="ChemoJun-File-IO" selector="readFrom:">readFrom: aStream 
	[aStream atEnd not] whileTrue: 
			[self readMolfileFrom: aStream.
			self readNonStructuredDataFrom: aStream.
			self readDelimiterFrom: aStream]</body>

<body package="ChemoJun-File-IO" selector="readMolfileFrom:">readMolfileFrom: aStream 
	| molFileReader |
	molFileReader := self class defaultMolFileReaderClass new.
	molFileReader readFrom: aStream.
	self molFileReaders add: molFileReader</body>

<body package="ChemoJun-File-IO" selector="readNonStructuredDataFrom:">readNonStructuredDataFrom: aStream 
	[aStream atEnd not] whileTrue: 
			[| aString aPosition aCollection |
			self readDataItemFrom: aStream.
			self readDataItemsFrom: aStream.
			aPosition := aStream position.
			aString := self getLine: aStream.
			"aString = (String with: Character cr) ifTrue: [^self]."
			aCollection := self separate: aString.
			(aCollection size &gt;= 1 and: [aCollection first = '$$$$']) 
				ifTrue: 
					[aStream position: aPosition.
					^self]].
	^self</body>
</methods>


</st-source>
