<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76985 "21:23:05"))'</do-it>



<class>
<name>ChemoJunSdFileWriter</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunAbstractFileWriter</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>moleculeObjects </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-File-IO</category>
<attributes>
<package>ChemoJun-File-IO</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunSdFileWriter class</class-id> <category>instance creation</category>

<body package="ChemoJun-File-IO" selector="moleculeObjects:">moleculeObjects: collectionOfMoleculeObjects 
	^(self new)
		moleculeObjects: collectionOfMoleculeObjects;
		yourself</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileWriter class</class-id> <category>copyright</category>

<body package="ChemoJun-File-IO" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-File-IO" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-File-IO" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileWriter class</class-id> <category>defaults</category>

<body package="ChemoJun-File-IO" selector="defaultFileDescriptions">defaultFileDescriptions
	^Array with: (Array with: (#chemoJun_SD_files &gt;&gt; 'SD files') asString)
		with: (Array with: (#jun_All_files &gt;&gt; 'All files') asString)</body>

<body package="ChemoJun-File-IO" selector="defaultFilePatterns">defaultFilePatterns
	^Array with: #('*.sdf' '*.SDF') with: #('*')</body>

<body package="ChemoJun-File-IO" selector="defaultMolFileWriterClass">defaultMolFileWriterClass
	^ChemoJunMolFileWriter</body>

<body package="ChemoJun-File-IO" selector="defaultRequestMessageString">defaultRequestMessageString
	^(#chemoJun_Input_a_SD_file_ &gt;&gt; 'Input a SD file.') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileWriter class</class-id> <category>examples</category>

<body package="ChemoJun-File-IO" selector="example1">example1
	"ChemoJunSdFileWriter example1."

	| aReader moleculeObjects aWriter |
	aReader := ChemoJunSdFileReader request.
	aReader isNil ifTrue: [^nil].
	moleculeObjects := aReader moleculeObjects.
	aWriter := ChemoJunSdFileWriter 
				requestInitialFileName: aReader baseName , '_' , JunSystem defaultBaseName 
						, aReader extension.
	aWriter isNil ifTrue: [^nil].
	aWriter moleculeObjects: moleculeObjects.
	aWriter write.
	^aWriter</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunSdFileWriter</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunSdFileWriter</class-id> <category>initialize-release</category>

<body package="ChemoJun-File-IO" selector="initialize">initialize
	super initialize.
	moleculeObjects := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileWriter</class-id> <category>accessing</category>

<body package="ChemoJun-File-IO" selector="moleculeObjects">moleculeObjects
	moleculeObjects ifNil: [moleculeObjects := OrderedCollection new].
	^moleculeObjects</body>

<body package="ChemoJun-File-IO" selector="moleculeObjects:">moleculeObjects: collectionOfMoleculeObject 
	collectionOfMoleculeObject 
		do: [:moleculeObject | self moleculeObjects add: moleculeObject]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSdFileWriter</class-id> <category>writing</category>

<body package="ChemoJun-File-IO" selector="writeOn:">writeOn: aStream 
	self moleculeObjects 
		do: [:moleculeObject | self writeOn: aStream moleculeObject: moleculeObject]</body>

<body package="ChemoJun-File-IO" selector="writeOn:moleculeObject:">writeOn: aStream moleculeObject: moleculeObject 
	| moleFileWriter |
	moleFileWriter := self class defaultMolFileWriterClass new.
	moleFileWriter moleculeObject: moleculeObject.
	moleFileWriter fileName: moleculeObject fileName.
	moleFileWriter writeOn: aStream.
	"aStream cr."
	aStream
		nextPutAll: '$$$$';
		cr</body>
</methods>


</st-source>
