<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76977 "21:22:57"))'</do-it>



<class>
<name>ChemoJunSerialNumberSetting</name>
<environment>ChemoJun</environment>
<super>Jun.JunApplicationModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>carbonValueHolder oxygenValueHolder nitrogenValueHolder hydrogenValueHolder othersValueHolder expressionValueHolder </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Goodies-UI</category>
<attributes>
<package>ChemoJun-Goodies-UI</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting class</class-id> <category>instance creation</category>

<body package="ChemoJun-Goodies-UI" selector="setting:">setting: settingCollection 
	^(self new)
		setting: settingCollection;
		yourself</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting class</class-id> <category>copyright</category>

<body package="ChemoJun-Goodies-UI" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Goodies-UI" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Goodies-UI" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting class</class-id> <category>examples</category>

<body package="ChemoJun-Goodies-UI" selector="example1">example1
	"ChemoJunSerialNumberSetting example1."

	| serialNumberSetting |
	serialNumberSetting := ChemoJunSerialNumberSetting new.
	serialNumberSetting open.
	^serialNumberSetting</body>

<body package="ChemoJun-Goodies-UI" selector="example2">example2
	"ChemoJunSerialNumberSetting example2."

	| serialNumberSetting |
	serialNumberSetting := ChemoJunSerialNumberSetting new.
	serialNumberSetting compute: 
			[:expression | 
			Transcript
				cr;
				show: expression].
	serialNumberSetting open.
	^serialNumberSetting</body>

<body package="ChemoJun-Goodies-UI" selector="example3">example3
	"ChemoJunSerialNumberSetting example3."

	| settingCollection serialNumberSetting |
	settingCollection := OrderedCollection new.
	settingCollection add: #carbon: -&gt; true.
	settingCollection add: #oxygen: -&gt; false.
	settingCollection add: #nitrogen: -&gt; false.
	settingCollection add: #hydrogen: -&gt; false.
	settingCollection add: #others: -&gt; false.
	serialNumberSetting := ChemoJunSerialNumberSetting 
				setting: settingCollection.
	serialNumberSetting compute: 
			[:expression | 
			Transcript
				cr;
				show: expression].
	serialNumberSetting open.
	^serialNumberSetting</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting class</class-id> <category>interface specs</category>

<body package="ChemoJun-Goodies-UI" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 
			#(#{Kernel.UserMessage} 
				#key: #chemoJun_Serial_Number_Setting 
				#defaultString: 'Serial Number Setting' ) 
			#min: #(#{Core.Point} 144 144 ) 
			#max: #(#{Core.Point} 144 144 ) 
			#bounds: #(#{Graphics.Rectangle} 700 525 844 669 ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.CheckBoxSpec} 
					#layout: #(#{Core.Point} 32 16 ) 
					#name: #carbonCheckBox 
					#model: #carbonValueHolder 
					#label: 
					#(#{Kernel.UserMessage} 
						#key: #chemoJun_carbon 
						#defaultString: 'carbon' ) 
					#style: #default ) 
				#(#{UI.CheckBoxSpec} 
					#layout: #(#{Core.Point} 32 40 ) 
					#name: #oxygenCheckBox 
					#model: #oxygenValueHolder 
					#label: 
					#(#{Kernel.UserMessage} 
						#key: #chemoJun_oxygen 
						#defaultString: 'oxygen' ) 
					#style: #default ) 
				#(#{UI.CheckBoxSpec} 
					#layout: #(#{Core.Point} 32 64 ) 
					#name: #nitrogenCheckBox 
					#model: #nitrogenValueHolder 
					#label: 
					#(#{Kernel.UserMessage} 
						#key: #chemoJun_nitrogen 
						#defaultString: 'nitrogen' ) 
					#style: #default ) 
				#(#{UI.CheckBoxSpec} 
					#layout: #(#{Core.Point} 32 88 ) 
					#name: #hydrogenCheckBox 
					#model: #hydrogenValueHolder 
					#label: 
					#(#{Kernel.UserMessage} 
						#key: #chemoJun_hydrogen 
						#defaultString: 'hydrogen' ) 
					#style: #default ) 
				#(#{UI.CheckBoxSpec} 
					#layout: #(#{Core.Point} 32 112 ) 
					#name: #othersCheckBox 
					#model: #othersValueHolder 
					#label: 
					#(#{Kernel.UserMessage} 
						#key: #chemoJun_others 
						#defaultString: 'others' ) 
					#style: #default ) ) ) )</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunSerialNumberSetting</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting</class-id> <category>initialize-release</category>

<body package="ChemoJun-Goodies-UI" selector="initialize">initialize
	super initialize.
	carbonValueHolder := nil.
	oxygenValueHolder := nil.
	nitrogenValueHolder := nil.
	hydrogenValueHolder := nil.
	othersValueHolder := nil.
	expressionValueHolder := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting</class-id> <category>accessing</category>

<body package="ChemoJun-Goodies-UI" selector="carbon">carbon
	^self carbonValueHolder value</body>

<body package="ChemoJun-Goodies-UI" selector="carbon:">carbon: aBoolean 
	^self carbonValueHolder value: aBoolean = true</body>

<body package="ChemoJun-Goodies-UI" selector="expression">expression
	^self expressionValueHolder value</body>

<body package="ChemoJun-Goodies-UI" selector="hydrogen">hydrogen
	^self hydrogenValueHolder value</body>

<body package="ChemoJun-Goodies-UI" selector="hydrogen:">hydrogen: aBoolean 
	^self hydrogenValueHolder value: aBoolean = true</body>

<body package="ChemoJun-Goodies-UI" selector="nitrogen">nitrogen
	^self nitrogenValueHolder value</body>

<body package="ChemoJun-Goodies-UI" selector="nitrogen:">nitrogen: aBoolean 
	^self nitrogenValueHolder value: aBoolean = true</body>

<body package="ChemoJun-Goodies-UI" selector="others">others
	^self othersValueHolder value</body>

<body package="ChemoJun-Goodies-UI" selector="others:">others: aBoolean 
	^self othersValueHolder value: aBoolean = true</body>

<body package="ChemoJun-Goodies-UI" selector="oxygen">oxygen
	^self oxygenValueHolder value</body>

<body package="ChemoJun-Goodies-UI" selector="oxygen:">oxygen: aBoolean 
	^self oxygenValueHolder value: aBoolean = true</body>

<body package="ChemoJun-Goodies-UI" selector="setting">setting
	| aCollection |
	aCollection := OrderedCollection new: 5.
	aCollection add: #carbon: -&gt; self carbon.
	aCollection add: #oxygen: -&gt; self oxygen.
	aCollection add: #nitrogen: -&gt; self nitrogen.
	aCollection add: #hydrogen: -&gt; self hydrogen.
	aCollection add: #others: -&gt; self others.
	^aCollection</body>

<body package="ChemoJun-Goodies-UI" selector="setting:">setting: settingCollection 
	settingCollection do: 
			[:anAssociation | 
			| aSelector aBoolean |
			aSelector := anAssociation key asSymbol.
			aBoolean := anAssociation value = true.
			self perform: aSelector with: aBoolean]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting</class-id> <category>aspects</category>

<body package="ChemoJun-Goodies-UI" selector="carbonValueHolder">carbonValueHolder
	carbonValueHolder ifNil: 
			[carbonValueHolder := ValueHolder with: true.
			carbonValueHolder 
				compute: [:value | self expressionValueHolder value: self computeExpression]].
	^carbonValueHolder</body>

<body package="ChemoJun-Goodies-UI" selector="expressionValueHolder">expressionValueHolder
	expressionValueHolder 
		ifNil: [expressionValueHolder := ValueHolder with: self computeExpression].
	^expressionValueHolder</body>

<body package="ChemoJun-Goodies-UI" selector="hydrogenValueHolder">hydrogenValueHolder
	hydrogenValueHolder ifNil: 
			[hydrogenValueHolder := ValueHolder with: false.
			hydrogenValueHolder 
				compute: [:value | self expressionValueHolder value: self computeExpression]].
	^hydrogenValueHolder</body>

<body package="ChemoJun-Goodies-UI" selector="nitrogenValueHolder">nitrogenValueHolder
	nitrogenValueHolder ifNil: 
			[nitrogenValueHolder := ValueHolder with: true.
			nitrogenValueHolder 
				compute: [:value | self expressionValueHolder value: self computeExpression]].
	^nitrogenValueHolder</body>

<body package="ChemoJun-Goodies-UI" selector="othersValueHolder">othersValueHolder
	othersValueHolder ifNil: 
			[othersValueHolder := ValueHolder with: true.
			othersValueHolder 
				compute: [:value | self expressionValueHolder value: self computeExpression]].
	^othersValueHolder</body>

<body package="ChemoJun-Goodies-UI" selector="oxygenValueHolder">oxygenValueHolder
	oxygenValueHolder ifNil: 
			[oxygenValueHolder := ValueHolder with: true.
			oxygenValueHolder 
				compute: [:value | self expressionValueHolder value: self computeExpression]].
	^oxygenValueHolder</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting</class-id> <category>constructing</category>

<body package="ChemoJun-Goodies-UI" selector="compute:">compute: aBlock 
	self expressionValueHolder compute: aBlock</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting</class-id> <category>converting</category>

<body package="ChemoJun-Goodies-UI" selector="asSettingArray">asSettingArray
	| aCollection |
	aCollection := OrderedCollection new.
	aCollection add: #carbon: -&gt; self carbon.
	aCollection add: #oxygen: -&gt; self oxygen.
	aCollection add: #nitrogen: -&gt; self nitrogen.
	aCollection add: #hydrogen: -&gt; self hydrogen.
	aCollection add: #others: -&gt; self others.
	^aCollection asArray</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting</class-id> <category>testing</category>

<body package="ChemoJun-Goodies-UI" selector="allFalse">allFalse
	^self carbon ~= true and: 
			[self oxygen ~= true and: 
					[self nitrogen ~= true 
						and: [self hydrogen ~= true and: [self others ~= true]]]]</body>

<body package="ChemoJun-Goodies-UI" selector="allTrue">allTrue
	^self carbon = true and: 
			[self oxygen = true and: 
					[self nitrogen = true and: [self hydrogen = true and: [self others = true]]]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunSerialNumberSetting</class-id> <category>private</category>

<body package="ChemoJun-Goodies-UI" selector="computeExpression">computeExpression
	| aStream |
	aStream := String new writeStream.
	aStream nextPutAll: '[:index :atom | '.
	self allTrue 
		ifTrue: [aStream nextPutAll: 'true']
		ifFalse: 
			[self allFalse 
				ifTrue: [aStream nextPutAll: 'false']
				ifFalse: 
					[self carbon 
						ifTrue: [aStream nextPutAll: '(atom = ''C'')']
						ifFalse: [aStream nextPutAll: '(false)'].
					aStream nextPutAll: ' | '.
					self oxygen 
						ifTrue: [aStream nextPutAll: '(atom = ''O'')']
						ifFalse: [aStream nextPutAll: '(false)'].
					aStream nextPutAll: ' | '.
					self nitrogen 
						ifTrue: [aStream nextPutAll: '(atom = ''N'')']
						ifFalse: [aStream nextPutAll: '(false)'].
					aStream nextPutAll: ' | '.
					self hydrogen 
						ifTrue: [aStream nextPutAll: '(atom = ''H'')']
						ifFalse: [aStream nextPutAll: '(false)'].
					aStream nextPutAll: ' | '.
					self others 
						ifTrue: 
							[aStream 
								nextPutAll: '((atom ~= ''C'') &amp; (atom ~= ''O'') &amp; (atom ~= ''N'') &amp; (atom ~= ''H''))']
						ifFalse: [aStream nextPutAll: '(false)']]].
	aStream nextPutAll: ']'.
	^aStream contents</body>

<body package="ChemoJun-Goodies-UI" selector="getWindow">getWindow
	^(ScheduledControllers scheduledControllers 
		detect: [:controller | controller model == self]
		ifNone: [nil]) ifNil: [nil] ifNotNil: [:it | it view]</body>
</methods>


</st-source>
