<?xml version="1.0"?>

<st-source>

<do-it>'ChemoJun071 (Array with: (Date newDay: 28 monthNumber: 3 year: 2007 "2007/03/28") with: (Time fromSeconds: 76978 "21:22:58"))'</do-it>



<class>
<name>ChemoJunViewerCatalog</name>
<environment>ChemoJun</environment>
<super>ChemoJun.ChemoJunApplicationModel</super>
<private>false</private>
<indexed-type>none</indexed-type>
<inst-vars>columnSize rowSize catalogViewers catalogElements selectedElements catalogFilename preferenceTable catalogComposite catalogScroller startIndex </inst-vars>
<class-inst-vars></class-inst-vars>
<imports></imports>
<category>ChemoJun-Catalog-Viewer</category>
<attributes>
<package>ChemoJun-Catalog-Viewer</package>
</attributes>
</class>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog class</class-id> <category>instance creation</category>

<body package="ChemoJun-Catalog-Viewer" selector="directories:">directories: directoryFilenames 
	| filenameCollection |
	filenameCollection := OrderedCollection new.
	directoryFilenames do: 
			[:each | 
			| directoryName |
			directoryName := each asFilename.
			(directoryName exists and: [directoryName isDirectory]) 
				ifTrue: 
					[filenameCollection addAll: (JunFileModel 
								dive: directoryName
								level: 1
								patterns: #('*.mol' '*.MOL'))]].
	^(self new)
		elements: (self elementsFrom: filenameCollection);
		yourself</body>

<body package="ChemoJun-Catalog-Viewer" selector="directory:">directory: directoryFilename 
	^self directories: (Array with: directoryFilename)</body>

<body package="ChemoJun-Catalog-Viewer" selector="filename:">filename: catalogFilename 
	| aList aCatalog |
	self 
		assert: [catalogFilename asFilename readStream]
		do: [:aStream | Cursor read showWhile: [aList := JunLispParser parse: aStream]]
		ensure: [:aStream | aStream close].
	Cursor wait showWhile: 
			[aCatalog := (self fromLispList: aList)
						filename: catalogFilename;
						yourself].
	^aCatalog</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog class</class-id> <category>copyright</category>

<body package="ChemoJun-Catalog-Viewer" selector="copyright">copyright
	^'ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.'</body>

<body package="ChemoJun-Catalog-Viewer" selector="system">system
	^'ChemoJun'</body>

<body package="ChemoJun-Catalog-Viewer" selector="version">version
	^'071'
</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog class</class-id> <category>defaults</category>

<body package="ChemoJun-Catalog-Viewer" selector="defaultBorderNormalColor">defaultBorderNormalColor
	^ColorValue veryLightGray</body>

<body package="ChemoJun-Catalog-Viewer" selector="defaultBorderSelectedColor">defaultBorderSelectedColor
	^ColorValue red</body>

<body package="ChemoJun-Catalog-Viewer" selector="defaultCatalogElementClass">defaultCatalogElementClass
	^ChemoJunViewerCatalogElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="defaultCatalogViewerClass">defaultCatalogViewerClass
	^ChemoJunViewerCatalogViewer</body>

<body package="ChemoJun-Catalog-Viewer" selector="defaultColumnSize">defaultColumnSize
	^3</body>

<body package="ChemoJun-Catalog-Viewer" selector="defaultRowSize">defaultRowSize
	^3</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog class</class-id> <category>examples</category>

<body package="ChemoJun-Catalog-Viewer" selector="example">example
	"ChemoJunViewerCatalog example."

	| aCatalog |
	aCatalog := ChemoJunViewerCatalog new.
	aCatalog open.
	^aCatalog</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog class</class-id> <category>interface specs</category>

<body package="ChemoJun-Catalog-Viewer" selector="windowSpec">windowSpec
	"Tools.UIPainter new openOnClass: self andSelector: #windowSpec"

	&lt;resource: #canvas&gt;
	^#(#{UI.FullSpec} 
		#window: 
		#(#{UI.WindowSpec} 
			#label: 
			#(#{Kernel.UserMessage} 
				#key: #chemoJun_Molecular_Viewer_Catalog 
				#defaultString: 'Molecular Viewer Catalog' ) 
			#min: #(#{Core.Point} 300 300 ) 
			#max: #(#{Core.Point} 0 0 ) 
			#bounds: #(#{Graphics.Rectangle} 700 468 1397 1050 ) 
			#flags: 4 
			#menu: #menuBar 
			#colors: 
			#(#{UI.LookPreferences} 
				#setBackgroundColor: #(#{Graphics.ColorValue} 7700 7700 7700 ) ) ) 
		#component: 
		#(#{UI.SpecCollection} 
			#collection: #(
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} -17 1 1 0 -1 1 -1 1 ) 
					#name: #catalogScroller 
					#flags: 1 
					#component: #catalogScroller ) 
				#(#{UI.ArbitraryComponentSpec} 
					#layout: #(#{Graphics.LayoutFrame} 1 0 1 0 -18 1 -1 1 ) 
					#name: #catalogComposite 
					#flags: 0 
					#component: #catalogComposite ) ) ) )</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog class</class-id> <category>lisp support</category>

<body package="ChemoJun-Catalog-Viewer" selector="catalogElementsFromTable:for:">catalogElementsFromTable: aTable for: aCatalog 
	| aList catalogElements |
	aList := aTable at: #catalogElements ifAbsent: [^aCatalog].
	catalogElements := OrderedCollection new: aList size.
	aList do: 
			[:list | 
			| element |
			list ifNil: [element := nil]
				ifNotNil: [element := (Smalltalk at: list head) fromLispList: list].
			catalogElements add: element].
	aCatalog elements: catalogElements.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Viewer" selector="columnSizeFromTable:for:">columnSizeFromTable: aTable for: aCatalog 
	| columnSize |
	columnSize := aTable at: #columnSize ifAbsent: [^aCatalog].
	aCatalog columnSize: columnSize.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Viewer" selector="fromLispList:for:">fromLispList: aList for: aCatalog 
	| aTable |
	aTable := self tableFromLispList: aList tail.
	self columnSizeFromTable: aTable for: aCatalog.
	self rowSizeFromTable: aTable for: aCatalog.
	self catalogElementsFromTable: aTable for: aCatalog.
	self selectedElementsFromTable: aTable for: aCatalog.
	self preferenceTableFromTable: aTable for: aCatalog.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Viewer" selector="preferenceTableFromTable:for:">preferenceTableFromTable: aTable for: aCatalog 
	| aList preferenceTable |
	aList := aTable at: #preferenceTable ifAbsent: [^aCatalog].
	preferenceTable := JunAttributeTable fromLispList: aList.
	aCatalog preferenceTable: preferenceTable.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Viewer" selector="rowSizeFromTable:for:">rowSizeFromTable: aTable for: aCatalog 
	| rowSize |
	rowSize := aTable at: #rowSize ifAbsent: [^aCatalog].
	aCatalog rowSize: rowSize.
	^aCatalog</body>

<body package="ChemoJun-Catalog-Viewer" selector="selectedElementsFromTable:for:">selectedElementsFromTable: aTable for: aCatalog 
	| aList |
	aList := aTable at: #selectedElements ifAbsent: [^aCatalog].
	aCatalog 
		selections: (aList collect: [:index | aCatalog elements at: index]) asArray.
	^aCatalog</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog class</class-id> <category>resources</category>

<body package="ChemoJun-Catalog-Viewer" selector="menuBar">menuBar
	"Tools.MenuEditor new openOnClass: self andSelector: #menuBar"

	&lt;resource: #menu&gt;
	^#(#{UI.Menu} #(
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_File 
					#defaultString: 'File' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_New 
								#defaultString: 'New' ) 
							#value: #newModel ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Select_Directory 
								#defaultString: 'Select Directory' ) 
							#value: #selectDirectory ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Open_Catalog_File 
								#defaultString: 'Open Catalog File' ) 
							#value: #openCatalogFile ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Open_SD_File 
								#defaultString: 'Open SD File' ) 
							#value: #openSDFile ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_Catalog_File 
								#defaultString: 'Save Catalog File' ) 
							#value: #saveCatalog ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_Catalog_File 
								#defaultString: 'Save as Catalog File' ) 
							#value: #saveAsCatalog ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_SD_File 
								#defaultString: 'Save as SD File' ) 
							#value: #saveAsSDFile ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_Image 
								#defaultString: 'Save as Image' ) 
							#value: #saveAsImage ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Save_as_HTML 
								#defaultString: 'Save as HTML' ) 
							#value: #saveAsHTML ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Quit 
								#defaultString: 'Quit' ) 
							#value: #quitDoing ) ) #(1 3 3 2 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_Edit 
					#defaultString: 'Edit' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Open_Molecular_Viewer 
								#defaultString: 'Open Molecular Viewer' ) 
							#value: #openMoleculeViewer ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Remove 
								#defaultString: 'Remove' ) 
							#value: #removeElements ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Select_all 
								#defaultString: 'Select All' ) 
							#value: #selectAll ) ) #(2 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #chemoJun_View 
					#defaultString: 'View' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Serial_Nos__of_Atoms_On_Off
								#defaultString: 'Serial Nos. of Atoms On/Off' ) 
							#value: #toggleIndex ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Reset_Viewers 
								#defaultString: 'Reset Viewers' ) 
							#value: #resetViewers ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Show_Indexes 
								#defaultString: 'Indexes' ) 
							#value: #toggleCatalogIndex ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Show_File_Name 
								#defaultString: 'File Name' ) 
							#value: #toggleFileName ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #chemoJun_Column_Size___Row_Size 
								#defaultString: 'Column Size * Row Size' ) 
							#value: #arrangeColumnSizeAndRowSize ) ) #(2 2 1 ) nil ) ) 
			#(#{UI.MenuItem} 
				#rawLabel: 
				#(#{Kernel.UserMessage} 
					#key: #jun_Misc 
					#defaultString: 'Misc' ) 
				#submenu: #(#{UI.Menu} #(
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Manual 
								#defaultString: 'Manual' ) 
							#value: #browseManual ) 
						#(#{UI.MenuItem} 
							#rawLabel: 
							#(#{Kernel.UserMessage} 
								#key: #jun_Inspect 
								#defaultString: 'Inspect' ) 
							#value: #inspectModel ) ) #(1 1 ) nil ) ) ) #(4 ) nil ) decodeAsLiteralArray</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog class</class-id> <category>utilities</category>

<body package="ChemoJun-Catalog-Viewer" selector="elementsFrom:">elementsFrom: filenameCollection 
	| elementCollection |
	elementCollection := OrderedCollection new: filenameCollection size.
	filenameCollection do: 
			[:aFilename | 
			| anElement |
			aFilename ifNil: [anElement := self defaultCatalogElementClass new]
				ifNotNil: [anElement := self defaultCatalogElementClass filename: aFilename].
			elementCollection add: anElement.
			JunSensorUtility shiftDown ifTrue: [^elementCollection]].
	^elementCollection</body>

<body package="ChemoJun-Catalog-Viewer" selector="request">request
	"ChemoJunViewerCatalog request."

	| labels values menu filename catalog |
	labels := Array with: (Array 
						with: (#chemoJun_Molecular_viewer_catalog_files 
								&gt;&gt; 'Molecular viewer catalog files') asString).
	values := Array with: #('*.mvc' '*.mvc').
	menu := Menu labelList: labels values: values.
	filename := ChemoJunFileRequesterDialog 
				requestFilename: (#chemoJun_Select_a_molecular_viewer_catalog_file_ 
						&gt;&gt; 'Select a molecular viewer catalog file.') asString
				fileTypeMenu: menu
				initialFileType: values first.
	filename isNil ifTrue: [^nil].
	catalog := self filename: filename.
	^catalog</body>
</methods>

<!-- -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -   -->


<comment>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id>
<body>ChemoJun071 (2007/03/28) Copyright 2002-2007 National Institute of Informatics, Research Organization of Information and Systems.</body>
</comment>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>initialize-release</category>

<body package="ChemoJun-Catalog-Viewer" selector="initialize">initialize
	super initialize.
	columnSize := nil.
	rowSize := nil.
	catalogViewers := nil.
	catalogElements := nil.
	selectedElements := nil.
	catalogFilename := nil.
	preferenceTable := nil.
	catalogComposite := nil.
	catalogScroller := nil.
	startIndex := nil</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>accessing</category>

<body package="ChemoJun-Catalog-Viewer" selector="columnSize">columnSize
	columnSize ifNil: [columnSize := self class defaultColumnSize].
	^columnSize</body>

<body package="ChemoJun-Catalog-Viewer" selector="columnSize:">columnSize: numberOfColumns 
	columnSize := numberOfColumns.
	self elements: self elements</body>

<body package="ChemoJun-Catalog-Viewer" selector="elementOfViewer:">elementOfViewer: catalogViewer 
	| anIndex |
	anIndex := self viewers indexOf: catalogViewer.
	anIndex &lt;= 0 ifTrue: [^nil].
	anIndex := self startIndex + (anIndex - 1).
	anIndex &gt; self numberOfElements ifTrue: [^nil].
	^self elements at: anIndex</body>

<body package="ChemoJun-Catalog-Viewer" selector="elements">elements
	catalogElements ifNil: [catalogElements := OrderedCollection new].
	^catalogElements</body>

<body package="ChemoJun-Catalog-Viewer" selector="elements:">elements: aCollection 
	catalogElements := aCollection</body>

<body package="ChemoJun-Catalog-Viewer" selector="filename">filename
	^catalogFilename</body>

<body package="ChemoJun-Catalog-Viewer" selector="filename:">filename: aFilename 
	aFilename ifNil: [catalogFilename := nil]
		ifNotNil: [:it | catalogFilename := it asFilename].
	self setWindowLabel</body>

<body package="ChemoJun-Catalog-Viewer" selector="moleculeObjects">moleculeObjects
	| moleculeObjects |
	moleculeObjects := OrderedCollection new.
	self elements 
		do: [:element | element moleculeObject ifNotNil: [:it | moleculeObjects add: it]].
	^moleculeObjects</body>

<body package="ChemoJun-Catalog-Viewer" selector="numberOfElements">numberOfElements
	^self elements size</body>

<body package="ChemoJun-Catalog-Viewer" selector="numberOfViewers">numberOfViewers
	^self columnSize * self rowSize</body>

<body package="ChemoJun-Catalog-Viewer" selector="rowSize">rowSize
	rowSize ifNil: [rowSize := self class defaultRowSize].
	^rowSize</body>

<body package="ChemoJun-Catalog-Viewer" selector="rowSize:">rowSize: numberOfRows 
	rowSize := numberOfRows.
	self elements: self elements</body>

<body package="ChemoJun-Catalog-Viewer" selector="viewerOfElement:">viewerOfElement: catalogElement 
	| anIndex |
	anIndex := self elements indexOf: catalogElement.
	anIndex &lt;= 0 ifTrue: [^nil].
	(anIndex between: self startIndex and: self lastIndex) ifFalse: [^nil].
	^self viewers at: anIndex - (self startIndex - 1)</body>

<body package="ChemoJun-Catalog-Viewer" selector="viewers">viewers
	catalogViewers ifNil: [catalogViewers := OrderedCollection new].
	^catalogViewers</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>actions</category>

<body package="ChemoJun-Catalog-Viewer" selector="moveElement:">moveElement: catalogViewer 
	| aWindow catalogBoxes fromPoint fromBox fromViewer fromElement fromIndex toPoint toBox toViewer toElement toIndex headElements tailElements |
	(aWindow := self getWindow) ifNil: [^nil].
	catalogBoxes := self viewers collect: 
					[:viewer | 
					viewer getView ifNil: [Point zero extent: Point zero]
						ifNotNil: 
							[:view | 
							view bounds 
								translatedBy: (view localPointToGlobal: Point zero) + aWindow globalOrigin]].
	fromPoint := JunSensorUtility cursorPoint.
	fromBox := catalogBoxes detect: [:box | box containsPoint: fromPoint]
				ifNone: [^nil].
	fromViewer := self viewers at: (catalogBoxes indexOf: fromBox).
	(fromElement := self elementOfViewer: fromViewer) ifNil: [^nil].
	fromIndex := self elements indexOf: fromElement.
	self 
		assert: [Cursor currentCursor]
		do: 
			[Cursor standardDrag show.
			[JunSensorUtility anyButtonPressed] whileTrue: 
					[toPoint := JunSensorUtility cursorPoint.
					toBox := catalogBoxes detect: [:box | box containsPoint: toPoint]
								ifNone: [nil].
					toBox ifNil: [Cursor dropNotOk show]
						ifNotNil: 
							[toViewer := self viewers at: (catalogBoxes indexOf: toBox).
							(toElement := self elementOfViewer: toViewer) 
								ifNil: [Cursor dropNotOk show]
								ifNotNil: [Cursor standardDrag show]]]]
		ensure: [:savedCursor | savedCursor show].
	toPoint ifNil: [^nil].
	toBox := catalogBoxes detect: [:box | box containsPoint: toPoint]
				ifNone: [^nil].
	toViewer := self viewers at: (catalogBoxes indexOf: toBox).
	(toElement := self elementOfViewer: toViewer) ifNil: [^nil].
	toIndex := self elements indexOf: toElement.
	fromIndex = toIndex ifTrue: [^nil].
	fromIndex &lt; toIndex 
		ifTrue: 
			[headElements := self elements copyFrom: 1 to: toIndex.
			tailElements := self elements copyFrom: toIndex + 1 to: self elements size]
		ifFalse: 
			[headElements := self elements copyFrom: 1 to: toIndex - 1.
			tailElements := self elements copyFrom: toIndex to: self elements size].
	headElements remove: fromElement ifAbsent: [nil].
	tailElements remove: fromElement ifAbsent: [nil].
	self elements: headElements , (self elements class with: fromElement) 
				, tailElements.
	self updateViewers</body>

<body package="ChemoJun-Catalog-Viewer" selector="pressedCameraButtonOf:in:from:">pressedCameraButtonOf: catalogElement in: moleculeViewer from: catalogViewer 
	moleculeViewer ifNil: [^nil].
	catalogElement applyPreferencesFrom: moleculeViewer.
	catalogElement applyPreferencesTo: catalogViewer.
	catalogViewer changed: #object</body>

<body package="ChemoJun-Catalog-Viewer" selector="selectViewer:">selectViewer: catalogViewer 
	| shiftDown catalogElement isSelected |
	shiftDown := JunSensorUtility shiftDown.
	catalogElement := self elementOfViewer: catalogViewer.
	catalogElement ifNil: [^nil].
	isSelected := self selections includes: catalogElement.
	shiftDown 
		ifTrue: 
			[isSelected 
				ifTrue: [self removeSelection: catalogElement]
				ifFalse: [self addSelection: catalogElement]]
		ifFalse: 
			[isSelected 
				ifTrue: 
					[self selections size &lt;= 1 
						ifTrue: [self clearSelections]
						ifFalse: 
							[self
								clearSelections;
								addSelection: catalogElement]]
				ifFalse: 
					[self
						clearSelections;
						addSelection: catalogElement]].
	self catalogComposite displaySelections.
	self updateEditMenuIndication</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>converting</category>

<body package="ChemoJun-Catalog-Viewer" selector="asImage">asImage
	| marginPoint anImage |
	self 
		assert: 
			[marginPoint := 1 @ 1.
			Pixmap 
				extent: self catalogComposite bounds extent + (marginPoint + marginPoint)]
		do: 
			[:aPixmap | 
			| graphicsContext |
			graphicsContext := aPixmap graphicsContext.
			self catalogComposite displayOn: graphicsContext at: marginPoint.
			self viewers do: 
					[:aViewer | 
					aViewer getView ifNil: []
						ifNotNil: 
							[:aView | 
							aViewer asImage displayOn: graphicsContext
								at: (aView 
										localPointToGlobal: (self catalogComposite localPointToGlobal: Point zero) 
												negated) 
											+ marginPoint]].
			anImage := aPixmap asImage]
		ensure: [:aPixmap | aPixmap close].
	^anImage</body>

<body package="ChemoJun-Catalog-Viewer" selector="asImageOfElement:">asImageOfElement: element 
	^self asImageOfElement: element extent: self defaultEachImageExtent</body>

<body package="ChemoJun-Catalog-Viewer" selector="asImageOfElement:extent:">asImageOfElement: element extent: extent 
	| aViewer anImage |
	self 
		assert: [Pixmap extent: extent]
		do: 
			[:aPixmap | 
			| graphicsContext |
			graphicsContext := aPixmap graphicsContext.
			aViewer := self class defaultCatalogViewerClass 
						moleculeObject: element moleculeObject.
			aViewer moleculeCatalog: self.
			element applyPreferencesTo: aViewer.
			(aViewer asImageExtent: aPixmap extent) displayOn: graphicsContext.
			aViewer displaySuperimposeInView: aPixmap.
			anImage := aPixmap asImage]
		ensure: [:aPixmap | aPixmap close].
	^anImage</body>

<body package="ChemoJun-Catalog-Viewer" selector="asImageOfElements:">asImageOfElements: elements 
	| eachImageExtent anImage x y howManyRows marginPoint aBox |
	eachImageExtent := self defaultEachImageExtent.
	howManyRows := elements size // self columnSize.
	elements size \\ self columnSize &gt; 0 
		ifTrue: [howManyRows := howManyRows + 1].
	self 
		assert: 
			[marginPoint := 1 @ 1.
			Pixmap 
				extent: (eachImageExtent + marginPoint) * (self columnSize @ howManyRows) 
						+ marginPoint]
		do: 
			[:aPixmap | 
			| graphicsContext |
			graphicsContext := aPixmap graphicsContext.
			graphicsContext paint: ColorValue white.
			graphicsContext displayRectangle: aPixmap bounds.
			elements with: (0 to: elements size - 1)
				do: 
					[:element :n | 
					x := n \\ self columnSize * (eachImageExtent x + marginPoint x) 
								+ marginPoint x.
					y := n // self columnSize * (eachImageExtent y + marginPoint y) 
								+ marginPoint y.
					aBox := (x @ y extent: eachImageExtent) expandedBy: marginPoint.
					graphicsContext paint: ColorValue veryLightGray.
					graphicsContext displayRectangle: aBox.
					anImage := self asImageOfElement: element extent: eachImageExtent.
					anImage displayOn: graphicsContext at: x @ y].
			anImage := aPixmap asImage]
		ensure: [:aPixmap | aPixmap close].
	^anImage</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>defaults</category>

<body package="ChemoJun-Catalog-Viewer" selector="defaultEachImageExtent">defaultEachImageExtent
	| extent |
	extent := 256 @ 256.
	self viewers isEmpty 
		ifFalse: 
			[self viewers first getView 
				ifNotNil: [:aView | extent := aView bounds extent]].
	^extent</body>

<body package="ChemoJun-Catalog-Viewer" selector="defaultWindowLabel">defaultWindowLabel
	^(#chemoJun_Molecular_Viewer_Catalog &gt;&gt; 'Molecular Viewer Catalog') asString</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>displaying</category>

<body package="ChemoJun-Catalog-Viewer" selector="changedViewBox:">changedViewBox: newBounds 
	super changedViewBox: newBounds.
	self viewers do: [:viewer | viewer changedViewBox: newBounds]</body>

<body package="ChemoJun-Catalog-Viewer" selector="redisplay">redisplay
	self catalogComposite invalidateRectangle: self catalogComposite bounds
		repairNow: true.
	self updateMenuIndication.
	self catalogScroller fixScrollingOffset</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>interface opening</category>

<body package="ChemoJun-Catalog-Viewer" selector="catalogComposite">catalogComposite
	catalogComposite ifNil: 
			[catalogComposite := ChemoJunViewerCatalogComposite new.
			catalogComposite moleculeCatalog: self].
	^catalogComposite</body>

<body package="ChemoJun-Catalog-Viewer" selector="catalogScroller">catalogScroller
	catalogScroller 
		ifNil: [catalogScroller := ChemoJunViewerCatalogScroller model: self].
	^catalogScroller</body>

<body package="ChemoJun-Catalog-Viewer" selector="postBuildWith:">postBuildWith: aBuilder 
	super postBuildWith: aBuilder.
	self addCatalogViewers</body>

<body package="ChemoJun-Catalog-Viewer" selector="postOpenWith:">postOpenWith: aBuilder 
	super postOpenWith: aBuilder.
	(self catalogScroller scrollOffsetHolder)
		addDependent: self catalogScroller;
		grid: (self catalogComposite bounds width / self columnSize) 
					@ self catalogComposite bounds height / self rowSize.
	self catalogScroller fixScrollingOffset</body>

<body package="ChemoJun-Catalog-Viewer" selector="setWindowLabel">setWindowLabel
	| aWindow aFilename aString |
	aWindow := self getWindow.
	aWindow isNil ifTrue: [^nil].
	aWindow model = self ifFalse: [^nil].
	self filename isNil ifTrue: [^aWindow label: self defaultWindowLabel].
	aFilename := self filename asFilename.
	aString := (Filename splitPath: aFilename asString) last.
	aWindow label: self defaultWindowLabel , ' [' , aString , ']'</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>lisp support</category>

<body package="ChemoJun-Catalog-Viewer" selector="catalogElementsToLispList">catalogElementsToLispList
	| aList |
	aList := self lispCons.
	aList head: #catalogElements.
	self elements collect: [:element | aList add: element toLispList].
	^aList</body>

<body package="ChemoJun-Catalog-Viewer" selector="columnSizeToLispList">columnSizeToLispList
	| alist |
	alist := self lispCons.
	alist head: #columnSize.
	alist tail: self columnSize.
	^alist</body>

<body package="ChemoJun-Catalog-Viewer" selector="preferenceTableToLispList">preferenceTableToLispList
	| alist |
	alist := self lispCons.
	alist head: #preferenceTable.
	alist tail: self preferenceTable toLispList.
	^alist</body>

<body package="ChemoJun-Catalog-Viewer" selector="rowSizeToLispList">rowSizeToLispList
	| alist |
	alist := self lispCons.
	alist head: #rowSize.
	alist tail: self rowSize.
	^alist</body>

<body package="ChemoJun-Catalog-Viewer" selector="selectedElementsToLispList">selectedElementsToLispList
	| aList |
	aList := self lispCons.
	aList head: #selectedElements.
	self selections 
		collect: [:element | aList add: (self elements indexOf: element)].
	^aList</body>

<body package="ChemoJun-Catalog-Viewer" selector="toLispList">toLispList
	| aList |
	aList := self lispCons.
	aList head: self class name.
	aList add: self columnSizeToLispList.
	aList add: self rowSizeToLispList.
	aList add: self catalogElementsToLispList.
	aList add: self selectedElementsToLispList.
	self preferenceTable isEmpty 
		ifFalse: [aList add: self preferenceTableToLispList].
	^aList</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>menu accessing</category>

<body package="ChemoJun-Catalog-Viewer" selector="updateEditMenuIndication">updateEditMenuIndication
	| menuItem aMenu |
	menuItem := self menuItemLabeled: 'Edit' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #openMoleculeViewer ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[(self isEmpty or: [self selections isEmpty]) 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #removeElements ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[(self isEmpty or: [self selections isEmpty]) 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #selectAll ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[(self isEmpty or: [self isAllSelections]) 
						ifTrue: [menuItem disable]
						ifFalse: [menuItem enable]]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="updateFileMenuIndication">updateFileMenuIndication
	| menuItem aMenu |
	menuItem := self menuItemLabeled: 'File' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #saveCatalog ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #saveAsCatalog ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #saveAsSDFile ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #saveAsImage ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #saveAsHTML ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="updateMenuIndication">updateMenuIndication
	self updateFileMenuIndication.
	self updateEditMenuIndication.
	self updateViewMenuIndication</body>

<body package="ChemoJun-Catalog-Viewer" selector="updateViewMenuIndication">updateViewMenuIndication
	| menuItem aMenu |
	menuItem := self menuItemLabeled: 'View' inMenu: self menuBar.
	menuItem isNil ifTrue: [^self].
	aMenu := menuItem submenu.
	aMenu notNil 
		ifTrue: 
			[menuItem := aMenu menuItemWithValue: #toggleIndex ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self elements isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #resetViewers ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self elements isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #toggleCatalogIndex ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self visibleCatalogIndex ifTrue: [menuItem beOn] ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #toggleFileName ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[menuItem enable.
					self visibleFileName ifTrue: [menuItem beOn] ifFalse: [menuItem beOff]].
			menuItem := aMenu menuItemWithValue: #arrangeColumnSize ifNone: [nil].
			menuItem notNil 
				ifTrue: [self isEmpty ifTrue: [menuItem disable] ifFalse: [menuItem enable]].
			menuItem := aMenu menuItemWithValue: #condenseElements ifNone: [nil].
			menuItem notNil 
				ifTrue: 
					[self hasVoidElement ifTrue: [menuItem enable] ifFalse: [menuItem disable]]]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>menu messages</category>

<body package="ChemoJun-Catalog-Viewer" selector="arrangeColumnSizeAndRowSize">arrangeColumnSizeAndRowSize
	| numberOfColumns numberOfRows aString aCollection |
	numberOfColumns := self columnSize.
	numberOfRows := self rowSize.
	aString := JunDialog 
				request: (#chemoJun_How_many_column_size_and_row_size_ 
						&gt;&gt; 'How many column size and row size?') asString
				initialAnswer: numberOfColumns printString , ' * ' 
						, numberOfRows printString.
	(aString isNil or: [aString isEmpty]) ifTrue: [^nil].
	aCollection := JunStringUtility separate: aString
				dividers: JunStringUtility separators , '*x,'.
	aCollection size &lt; 2 ifTrue: [^nil].
	numberOfColumns := aCollection first asNumber asInteger.
	numberOfRows := aCollection last asNumber asInteger.
	numberOfColumns &lt; 1 ifTrue: [^nil].
	numberOfRows &lt; 1 ifTrue: [^nil].
	self columnSize: numberOfColumns.
	self rowSize: numberOfRows.
	self
		removeCatalogViewers;
		addCatalogViewers;
		updateViewers</body>

<body package="ChemoJun-Catalog-Viewer" selector="openCatalogFile">openCatalogFile
	| aCatalog |
	aCatalog := self class request.
	aCatalog ifNil: [^nil].
	self elements: aCatalog elements.
	self columnSize: aCatalog columnSize.
	self rowSize: aCatalog rowSize.
	self selections: aCatalog selections.
	self filename: aCatalog filename.
	self preferenceTable: aCatalog preferenceTable.
	self
		removeCatalogViewers;
		addCatalogViewers;
		updateViewers.
	self updateMenuIndication</body>

<body package="ChemoJun-Catalog-Viewer" selector="openMoleculeViewer">openMoleculeViewer
	self selections do: 
			[:element | 
			(self viewerOfElement: element) 
				ifNotNil: [:viewer | viewer openMoleculeViewer]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="openSDFile">openSDFile
	| aReader moleculeObjects elementCollection catalogElement |
	aReader := ChemoJunSdFileReader request.
	aReader isNil ifTrue: [^nil].
	(moleculeObjects := aReader moleculeObjects) isEmpty ifTrue: [^nil].
	elementCollection := OrderedCollection new: moleculeObjects size.
	moleculeObjects do: 
			[:moleculeObject | 
			catalogElement := self class defaultCatalogElementClass 
						moleculeObject: moleculeObject.
			elementCollection add: catalogElement].
	self elements: self elements , elementCollection.
	self updateViewers.
	self updateMenuIndication</body>

<body package="ChemoJun-Catalog-Viewer" selector="removeElements">removeElements
	| selections elements |
	(selections := self selections) isEmpty ifTrue: [^nil].
	(JunDialog confirm: #jun_Really_remove_ &gt;&gt; 'Really remove?') 
		ifFalse: [^nil].
	elements := self elements 
				reject: [:element | selections includes: element].
	self elements: elements.
	self clearSelections.
	self updateViewers.
	self updateMenuIndication</body>

<body package="ChemoJun-Catalog-Viewer" selector="requestNewImageFilename">requestNewImageFilename
	"ChemoJunViewerCatalog new requestNewImageFilename."

	| labels values menu message aFilename |
	labels := Array 
				with: (Array with: (#jun_Image_files &gt;&gt; 'Image files') asString).
	values := Array with: JunSystem defaultImageExtensionPatterns.
	menu := Menu labelList: labels values: values.
	message := #jun_Input_an_image_file_ &gt;&gt; 'Input an image file.' 
				expandMacrosWith: 'image'.
	aFilename := ChemoJunFileRequesterDialog 
				requestNewFilename: message
				initialFilename: self defaultBaseName , '.jpg'
				fileTypeMenu: menu
				initialFileType: values first.
	aFilename isNil ifTrue: [^nil].
	^aFilename</body>

<body package="ChemoJun-Catalog-Viewer" selector="resetViewers">resetViewers
	self elements 
		do: [:element | (self viewerOfElement: element) ifNotNil: [:viewer | viewer resetView]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="saveAsCatalog">saveAsCatalog
	| labels values menu filename |
	self isEmpty ifTrue: [^nil].
	labels := Array with: (Array 
						with: (#chemoJun_Molecular_viewer_catalog_files 
								&gt;&gt; 'Molecular viewer catalog files') asString)
				with: (Array with: (#jun_All_files &gt;&gt; 'All files') asString).
	values := Array with: #('*.mvc' '*.MVC') with: #('*').
	menu := Menu labelList: labels values: values.
	filename := ChemoJunFileRequesterDialog 
				requestNewFilename: (#chemoJun_Input_a_molecular_viewer_catalog_file_ 
						&gt;&gt; 'Input a molecular viewer catalog file.') asString
				initialFilename: self defaultBaseName , '.mvc'
				fileTypeMenu: menu
				initialFileType: values first.
	filename isNil ifTrue: [^nil].
	self saveCatalogTo: filename.
	self filename: filename</body>

<body package="ChemoJun-Catalog-Viewer" selector="saveAsHTML">saveAsHTML
	| baseDirectory imageDirectory thumbnailDirectory aCollection aFilename |
	self isEmpty ifTrue: [^nil].
	baseDirectory := ChemoJunFileRequesterDialog 
				requestNewDirectory: (#jun_Input_a_directory_ &gt;&gt; 'Input a directory.') 
						asString
				initialFilename: self defaultBaseName.
	baseDirectory ifNil: [^nil].
	baseDirectory exists ifFalse: [baseDirectory makeDirectory].
	imageDirectory := baseDirectory construct: 'images'.
	imageDirectory exists ifFalse: [imageDirectory makeDirectory].
	thumbnailDirectory := baseDirectory construct: 'thumbnails'.
	thumbnailDirectory exists ifFalse: [thumbnailDirectory makeDirectory].
	aCollection := OrderedCollection new: self elements size.
	self elements with: (1 to: self elements size)
		do: 
			[:element :index | 
			| aString imageFilename thumbnailFilename |
			aString := index printString.
			8 - aString size timesRepeat: [aString := '0' , aString].
			aString := aString , '.jpg'.
			imageFilename := imageDirectory construct: aString.
			thumbnailFilename := thumbnailDirectory construct: aString.
			aCollection 
				add: element -&gt; (Array with: imageFilename with: thumbnailFilename)].
	aFilename := baseDirectory construct: 'index.html'.
	Cursor write showWhile: [self htmlTo: aFilename with: aCollection].
	JunURL browse: aFilename asURI asString</body>

<body package="ChemoJun-Catalog-Viewer" selector="saveAsImage">saveAsImage
	| shiftDown altDown anImage aFilename |
	shiftDown := JunSensorUtility shiftDown.
	altDown := JunSensorUtility altDown.
	altDown 
		ifTrue: [anImage := self asImageOfElements: self elements]
		ifFalse: [anImage := self asImage].
	anImage isNil ifTrue: [^nil].
	shiftDown 
		ifTrue: 
			[anImage := anImage convertToPalette: JunImageProcessor grayPalette256
						renderedBy: NearestPaint new].
	aFilename := self requestNewImageFilename.
	aFilename isNil ifTrue: [^nil].
	self writeImage: anImage to: aFilename.
	^anImage</body>

<body package="ChemoJun-Catalog-Viewer" selector="saveAsSDFile">saveAsSDFile
	| aWriter moleculeObjects |
	self elements isEmpty ifTrue: [^nil].
	aWriter := ChemoJunSdFileWriter 
				requestInitialFileName: self defaultBaseName , '.sdf'.
	aWriter isNil ifTrue: [^nil].
	moleculeObjects := self moleculeObjects.
	aWriter moleculeObjects: moleculeObjects.
	aWriter write.
	^aWriter</body>

<body package="ChemoJun-Catalog-Viewer" selector="saveCatalog">saveCatalog
	self isEmpty ifTrue: [^nil].
	self filename ifNil: [self saveAsCatalog]
		ifNotNil: [:it | self saveCatalogTo: it]</body>

<body package="ChemoJun-Catalog-Viewer" selector="saveCatalogTo:">saveCatalogTo: aFilename 
	Cursor write showWhile: 
			[self 
				assert: [aFilename asFilename writeStream]
				do: 
					[:aStream | 
					aStream
						nextPutAll: '%';
						cr.
					aStream
						nextPutAll: '%';
						space;
						nextPutAll: 'Molecular Viewer Catalog';
						space;
						nextPutAll: '(created by';
						space;
						nextPutAll: ChemoJunSystem system , ChemoJunSystem version;
						space;
						nextPutAll: 'at';
						space;
						nextPutAll: JunCalendarModel stringFromDateAndTime;
						nextPutAll: ')';
						cr.
					aStream
						nextPutAll: '%';
						cr.
					self toLispList saveOn: aStream]
				ensure: [:aStream | aStream close]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="selectAll">selectAll
	self clearSelections.
	self elements do: [:element | self addSelection: element].
	self catalogComposite displaySelections.
	self updateEditMenuIndication</body>

<body package="ChemoJun-Catalog-Viewer" selector="selectDirectory">selectDirectory
	| directory catalog |
	directory := ChemoJunFileRequesterDialog requestDirectory.
	directory isNil ifTrue: [^nil].
	catalog := self class directory: directory.
	self elements: self elements , catalog elements.
	self filename: catalog filename.
	self updateViewers.
	self updateMenuIndication</body>

<body package="ChemoJun-Catalog-Viewer" selector="toggleCatalogIndex">toggleCatalogIndex
	self visibleCatalogIndex: self visibleCatalogIndex not.
	self redisplay</body>

<body package="ChemoJun-Catalog-Viewer" selector="toggleFileName">toggleFileName
	self visibleFileName: self visibleFileName not.
	self redisplay</body>

<body package="ChemoJun-Catalog-Viewer" selector="toggleIndex">toggleIndex
	| aBoolean |
	aBoolean := nil.
	self elements do: 
			[:element | 
			(self viewerOfElement: element) ifNotNil: 
					[:viewer | 
					viewer messageSymbol = #moleculeAsSpaceFill 
						ifFalse: 
							[aBoolean ifNil: [aBoolean := element exceptIndex not].
							element exceptIndex: aBoolean.
							viewer
								exceptIndex: element exceptIndex;
								redisplay;
								updateViewMenuIndication]]].
	self updateViewMenuIndication</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>preferences</category>

<body package="ChemoJun-Catalog-Viewer" selector="chemoJunJapanese">chemoJunJapanese
	^self preferenceTable at: #chemoJunJapanese ifAbsentPut: [false]</body>

<body package="ChemoJun-Catalog-Viewer" selector="chemoJunJapanese:">chemoJunJapanese: aBoolean 
	self preferenceTable at: #chemoJunJapanese put: aBoolean = true.
	self viewers 
		do: [:viewer | viewer chemoJunJapanese: self chemoJunJapanese]</body>

<body package="ChemoJun-Catalog-Viewer" selector="preferenceTable">preferenceTable
	preferenceTable ifNil: [preferenceTable := JunAttributeTable new].
	^preferenceTable</body>

<body package="ChemoJun-Catalog-Viewer" selector="preferenceTable:">preferenceTable: attributeTable 
	preferenceTable := attributeTable</body>

<body package="ChemoJun-Catalog-Viewer" selector="visibleCatalogIndex">visibleCatalogIndex
	^self preferenceTable at: #visibleCatalogIndex ifAbsentPut: [false]</body>

<body package="ChemoJun-Catalog-Viewer" selector="visibleCatalogIndex:">visibleCatalogIndex: aBoolean 
	self preferenceTable at: #visibleCatalogIndex put: aBoolean = true</body>

<body package="ChemoJun-Catalog-Viewer" selector="visibleFileName">visibleFileName
	^self preferenceTable at: #visibleFileName ifAbsentPut: [true]</body>

<body package="ChemoJun-Catalog-Viewer" selector="visibleFileName:">visibleFileName: aBoolean 
	self preferenceTable at: #visibleFileName put: aBoolean = true</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>scrolling</category>

<body package="ChemoJun-Catalog-Viewer" selector="scroll:">scroll: scrollAmount 
	| y howMany cellHeight height ratio newStartIndex catalogViewer catalogElement |
	self isEmpty ifTrue: [^nil].
	y := scrollAmount y.
	howMany := self elements size // self columnSize.
	cellHeight := self catalogComposite bounds height / self rowSize.
	height := cellHeight * howMany.
	height &lt;= 0 
		ifTrue: [ratio := 0]
		ifFalse: [ratio := (y / height * howMany) abs].
	newStartIndex := ratio * self columnSize + 1.
	newStartIndex = self startIndex ifTrue: [^nil].
	self startIndex to: self lastIndex
		do: 
			[:index | 
			catalogViewer := self viewers at: index - self startIndex + 1.
			catalogElement := self elements at: index.
			catalogElement applyPreferencesFrom: catalogViewer].
	startIndex := newStartIndex.
	self updateViewers</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>selecting</category>

<body package="ChemoJun-Catalog-Viewer" selector="addSelection:">addSelection: catalogElement 
	self selections add: catalogElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="clearSelections">clearSelections
	selectedElements := OrderedCollection new</body>

<body package="ChemoJun-Catalog-Viewer" selector="removeSelection:">removeSelection: catalogElement 
	self selections remove: catalogElement</body>

<body package="ChemoJun-Catalog-Viewer" selector="selection">selection
	self selections isEmpty ifTrue: [^nil].
	^self selections last</body>

<body package="ChemoJun-Catalog-Viewer" selector="selection:">selection: element 
	element ifNil: [self selections: Array new]
		ifNotNil: [:it | self selections: (Array with: it)]</body>

<body package="ChemoJun-Catalog-Viewer" selector="selections">selections
	selectedElements ifNil: [self clearSelections].
	^selectedElements</body>

<body package="ChemoJun-Catalog-Viewer" selector="selections:">selections: elementCollection 
	selectedElements := elementCollection asOrderedCollection 
				select: [:element | element notNil].
	selectedElements isEmpty 
		ifTrue: [self updateEditMenuIndication]
		ifFalse: [self redisplay]</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>testing</category>

<body package="ChemoJun-Catalog-Viewer" selector="hasVoidElement">hasVoidElement
	^(self elements detect: [:element | element isVoid] ifNone: [nil]) notNil</body>

<body package="ChemoJun-Catalog-Viewer" selector="isAllSelections">isAllSelections
	self selections isEmpty ifTrue: [^false].
	^(self elements reject: [:element | self selections includes: element]) 
		isEmpty</body>

<body package="ChemoJun-Catalog-Viewer" selector="isEmpty">isEmpty
	^self elements isEmpty</body>
</methods>

<methods>
<class-id>ChemoJun.ChemoJunViewerCatalog</class-id> <category>private</category>

<body package="ChemoJun-Catalog-Viewer" selector="addCatalogViewers">addCatalogViewers
	| fractionBox |
	fractionBox := 0 @ 0 extent: (1 / self columnSize) @ (1 / self rowSize).
	(0 to: self rowSize - 1) do: 
			[:y | 
			(0 to: self columnSize - 1) do: 
					[:x | 
					| aViewer aWrapper aBox aLayoutFrame |
					aViewer := self class defaultCatalogViewerClass new.
					aViewer moleculeCatalog: self.
					self viewers add: aViewer.
					aViewer allButOpenInterface: #windowSpec.
					aWrapper := aViewer builder componentAt: #moleculeView.
					aWrapper component borderColor: self class defaultBorderNormalColor.
					aBox := fractionBox 
								translatedBy: (x * fractionBox width) @ (y * fractionBox height).
					aLayoutFrame := LayoutFrame 
								leftFraction: aBox left
								offset: 1
								rightFraction: aBox right
								offset: -1
								topFraction: aBox top
								offset: 1
								bottomFraction: aBox bottom
								offset: -1.
					self catalogComposite add: aWrapper in: aLayoutFrame]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="htmlTo:with:">htmlTo: aFilename with: aCollection 
	JunProgress new do: 
			[:progress | 
			| eachImageExtent |
			eachImageExtent := self defaultEachImageExtent.
			aCollection with: (1 to: aCollection size)
				do: 
					[:assoc :index | 
					| element filename |
					element := assoc key.
					progress message: element baseNameString.
					filename := assoc value last asFilename.
					self 
						assert: [JunJpegImageStream on: filename writeStream]
						do: 
							[:stream | 
							Cursor write showWhile: 
									[stream 
										nextPutImage: (self asImageOfElement: element extent: eachImageExtent)]]
						ensure: [:stream | stream close].
					filename := assoc value first asFilename.
					self 
						assert: [JunJpegImageStream on: filename writeStream]
						do: 
							[:stream | 
							Cursor write showWhile: 
									[stream 
										nextPutImage: (self asImageOfElement: element extent: eachImageExtent * 2)]]
						ensure: [:stream | stream close].
					progress value: index / aCollection size].
			self 
				assert: [aFilename writeStream]
				do: 
					[:aStream | 
					aStream 
						nextPutAll: '&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"&gt;
&lt;html lang="ja"&gt;
&lt;head&gt;
&lt;meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS"&gt;
&lt;meta http-equiv="Content-Style-Type" content="text/css"&gt;
&lt;link rev="made" href="mailto:cheminfo@nii.ac.jp"&gt;
&lt;link rel="index" href="index.html"&gt;
&lt;title&gt;Molecular Catalog&lt;/title&gt;
&lt;style type="text/css"&gt;
&lt;!--
body {
  background-color : #ffffff;
  margin : 20px;
  padding : 10px;
  font-family : serif;
  font-size : 10pt;
}
img.borderless {
  border-width : 0px;
  vertical-align : middle;
}
table.belt {
  border-style : solid;
  border-width : 0px;
  border-color : #000000;
  background-color : #eeeeee;
  padding : 0px 0px;
}
table.content {
  border-style : solid;
  border-width : 0px;
  border-color : #000000;
  padding : 0px 0px;
}
table.element {
  border-style : solid;
  border-width : 0px;
  border-color : #000000;
  padding : 0px 0px;
}
td.element {
  text-align : right;
  font-size : 8pt;
  padding : 0px 0px;
  background-color : #ffffff;
}
--&gt;
&lt;/style&gt;
&lt;/head&gt;
&lt;body&gt;
&lt;table class="belt" summary="belt"&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;td&gt;
      &lt;table class="content" summary="content"&gt;
        &lt;tbody&gt;
'.
					10 timesRepeat: [aStream space].
					aStream nextPutAll: '&lt;tr&gt;'.
					aStream cr.
					aCollection with: (1 to: aCollection size)
						do: 
							[:assoc :index | 
							| image thumbnail alt |
							image := (Filename splitPath: assoc value first asString) last.
							thumbnail := (Filename splitPath: assoc value last asString) last.
							alt := (Filename splitExtension: thumbnail) first.
							12 timesRepeat: [aStream space].
							aStream nextPutAll: '&lt;td class="element"&gt;'.
							aStream nextPutAll: '&lt;a href="images/'.
							aStream nextPutAll: image.
							aStream nextPutAll: '"&gt;'.
							aStream nextPutAll: '&lt;img class="borderless" src="thumbnails/'.
							aStream nextPutAll: thumbnail.
							aStream nextPutAll: '" width="'.
							aStream nextPutAll: eachImageExtent x printString.
							aStream nextPutAll: '" height="'.
							aStream nextPutAll: eachImageExtent y printString.
							aStream nextPutAll: '" alt="'.
							aStream nextPutAll: alt.
							aStream nextPutAll: '"&gt;'.
							aStream nextPutAll: '&lt;/a&gt;'.
							aStream nextPutAll: '&lt;/td&gt;'.
							aStream cr.
							(index \\ columnSize = 0 and: [index ~= aCollection size]) 
								ifTrue: 
									[10 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;/tr&gt;'.
									aStream cr.
									10 timesRepeat: [aStream space].
									aStream nextPutAll: '&lt;tr&gt;'.
									aStream cr]].
					10 timesRepeat: [aStream space].
					aStream nextPutAll: '&lt;/tr&gt;'.
					aStream cr.
					aStream 
						nextPutAll: '        &lt;/tbody&gt;
      &lt;/table&gt;
      &lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;
&lt;/body&gt;
&lt;/html&gt;']
				ensure: [:aStream | aStream close]]</body>

<body package="ChemoJun-Catalog-Viewer" selector="lastIndex">lastIndex
	^self startIndex - 1 + self numberOfViewers min: self numberOfElements</body>

<body package="ChemoJun-Catalog-Viewer" selector="removeCatalogViewers">removeCatalogViewers
	self viewers copy do: [:aViewer | self viewers remove: aViewer].
	self catalogComposite components copy 
		do: [:aWrapper | self catalogComposite remove: aWrapper]</body>

<body package="ChemoJun-Catalog-Viewer" selector="startIndex">startIndex
	startIndex ifNil: [startIndex := 1].
	^startIndex</body>

<body package="ChemoJun-Catalog-Viewer" selector="updateViewers">updateViewers
	| catalogViewer catalogElement |
	self startIndex to: self lastIndex
		do: 
			[:index | 
			catalogViewer := self viewers at: index - self startIndex + 1.
			catalogElement := self elements at: index.
			catalogViewer setMoleculeObject: nil.
			catalogViewer flushDisplayObject.
			catalogElement applyPreferencesTo: catalogViewer.
			catalogViewer changed: #object].
	self lastIndex - self startIndex + 2 to: self numberOfViewers
		do: 
			[:index | 
			catalogViewer := self viewers at: index.
			catalogViewer setMoleculeObject: nil.
			catalogViewer flushDisplayObject.
			catalogViewer changed: #object].
	self catalogScroller scrollOffsetHolder 
		grid: (self catalogComposite bounds width / self columnSize) 
				@ self catalogComposite bounds height / self rowSize.
	self catalogScroller fixScrollingOffset.
	self catalogComposite displaySelections</body>
</methods>


</st-source>
